#include "cChangeNotify.hpp"
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

ChangeNotify::ChangeNotify( LPCTSTR lpPathName, BOOL bWatchSubTree,DWORD dwNotifyFilter)
{

	HANDLE hCN;

	try{
		hCN = FindFirstChangeNotification(lpPathName,bWatchSubTree,dwNotifyFilter);
	}
	catch(...)
	{
		fprintf(stderr,"ChangeNotify: Internal Error, unable to create ChangeNotify object\n");
	}

	RetVal = ( hCN != INVALID_HANDLE_VALUE );
	SetHandle( hCN );
	
}
	




	
// constructor for use when the user wants a ChangeNotify object to control an already
// created named ChangeNotify.
	
ChangeNotify::ChangeNotify( HANDLE hCN )
{
	SetHandle( hCN );

}

	
// Destructor to ensure that the ChangeNotify handle is closed when the ChangeNotify object
// is destroyed.	
ChangeNotify::~ChangeNotify()
{
	CloseHandle( MyHandle() );

}


BOOL ChangeNotify::Close()
{
	return(FindCloseChangeNotification( MyHandle() ));
}

BOOL ChangeNotify::FindNext()
{
	return( FindNextChangeNotification( MyHandle() ));
}
  
