// File.cpp
//
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define RETURNRESULT(x)		if((x)){ XST_mYES(0); }\
                     		else { XST_mNO(0); }\
                     		XSRETURN(1)
#define SETIV(index,value) sv_setiv(ST(index), value)
#define SETPV(index,string) sv_setpv(ST(index), string)

// constant function for exporting NT definitions.
static long constant(CPerl* pPerl, char *name)
{
    errno = 0;
    switch (*name) {
    case 'A':
	if (strEQ(name, "ARCHIVE"))
#ifdef FILE_ATTRIBUTE_ARCHIVE
		return FILE_ATTRIBUTE_ARCHIVE;
#else
		goto not_there;
#endif	
	break;
    case 'B':
	break;
    case 'C':
	if (strEQ(name, "COMPRESSED"))
#ifdef FILE_ATTRIBUTE_COMPRESSED
		return FILE_ATTRIBUTE_COMPRESSED;
#else
		goto not_there;
#endif	
	break;
    case 'D':
	if (strEQ(name, "DIRECTORY"))
#ifdef FILE_ATTRIBUTE_DIRECTORY
		return FILE_ATTRIBUTE_DIRECTORY;
#else
		goto not_there;
#endif	
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	if (strEQ(name, "HIDDEN"))
#ifdef FILE_ATTRIBUTE_HIDDEN
		return FILE_ATTRIBUTE_HIDDEN;
#else
		goto not_there;
#endif	
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	if (strEQ(name, "NORMAL"))
#ifdef FILE_ATTRIBUTE_NORMAL
		return FILE_ATTRIBUTE_NORMAL;
#else
		goto not_there;
#endif	
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	if (strEQ(name, "READONLY"))
#ifdef FILE_ATTRIBUTE_READONLY
		return FILE_ATTRIBUTE_READONLY;
#else
		goto not_there;
#endif	
	break;
    case 'S':
	if (strEQ(name, "SYSTEM"))
#ifdef FILE_ATTRIBUTE_SYSTEM
		return FILE_ATTRIBUTE_SYSTEM;
#else
		goto not_there;
#endif	
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


XS(XS_NT__File_constant)
{
	dXSARGS;

	if (items != 2)
	{
		croak("Usage: Win32::File::constant(name, arg)\n");
	}
	{
		char* name = (char*)SvPV(ST(0),na);
		ST(0) = sv_newmortal();
		sv_setiv(ST(0), constant(pPerl, name));
	}
	XSRETURN(1);
}

XS(XS_NT__File_GetAttributes)
{
	dXSARGS;
	DWORD dwAttribs;

	if (items != 2)
	{
		croak("Usage: Win32::File::GetAttributes(filename, returnedAttributes)\n");
	}
	{
		char* fileName = (char*)SvPV(ST(0),na);
		dwAttribs = GetFileAttributes(fileName);
		SETIV(1, dwAttribs);
	}
	RETURNRESULT(dwAttribs != 0xffffffff);
}


XS(XS_NT__File_SetAttributes)
{
	dXSARGS;
	BOOL bRet;

	if (items != 2)
	{
		croak("Usage: Win32::File::SetAttributes(filename, newAttributes)\n");
	}
	{
		char* fileName = (char*)SvPV(ST(0),na);
		DWORD dwAttribs = SvIV(ST(1));
		bRet = SetFileAttributes(fileName, dwAttribs);
	}
	RETURNRESULT(bRet);
}


XS(boot_Win32__File)
{
	dXSARGS;
	char* file = __FILE__;

	newXS("Win32::File::constant", XS_NT__File_constant, file);
	newXS("Win32::File::GetAttributes", XS_NT__File_GetAttributes, file);
	newXS("Win32::File::SetAttributes", XS_NT__File_SetAttributes, file);
	ST(0) = &sv_yes;
	XSRETURN(1);
}

