#include "cMutex.hpp"
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

Mutex::Mutex(BOOL bInitial, LPCTSTR lpMutexName )
{

	HANDLE hMut;

// Create a SECURITY_ATTRIBUTES to allow for inheritance of this object.

	SECURITY_ATTRIBUTES		stSecurity;
	
	stSecurity.nLength = sizeof( SECURITY_ATTRIBUTES ); // set the length
	stSecurity.bInheritHandle = TRUE;				   // allow this Mutex to be inherited.
	stSecurity.lpSecurityDescriptor = NULL;			   // Use the calling processes Security Descriptor.

	try{
		hMut = CreateMutex( &stSecurity,bInitial,lpMutexName);
	}
	catch(...)
	{
		fprintf(stderr,"Mutex: Internal Error, unable to create Mutex object\n");
	}

	SetHandle( hMut );
	
}
	




	
// constructor for use when the user wants a Mutex object to control an already
// created named Mutex.
	
Mutex::Mutex( HANDLE hMut )
{
	SetHandle( hMut );

}

	
// Destructor to ensure that the Mutex handle is closed when the Mutex object
// is destroyed.	
Mutex::~Mutex()
{
	CloseHandle( MyHandle() );

}

BOOL Mutex::Release()
{
	HANDLE hH;
	hH = MyHandle();

	return( ReleaseMutex( hH ) );

}
  
