//process.cpp
#include <stdio.h>
#include "cProcess.hpp"
#include <windows.h>
#include <process.h>

// Perl constructor.



cProcess::cProcess(char* szAppName, char* szCommLine,BOOL Inherit,DWORD CreateFlags,char* szCurrDir)
{
	
//spawn
//	PROCESS_INFORMATION stProcInfo;
	STARTUPINFO stStartup;

// initialize the STARTUP_INFO structure for the new process.

	stStartup.lpReserved=NULL;
	stStartup.cb = sizeof( STARTUPINFO );
	stStartup.lpDesktop = NULL;
	stStartup.lpTitle = NULL;
	stStartup.dwFlags = 0;
	stStartup.cbReserved2 = 0;
	stStartup.lpReserved2 = NULL;

// create the process

	bRetVal = CreateProcess( szAppName,szCommLine,NULL,NULL,Inherit,CreateFlags,NULL,szCurrDir,&stStartup,&stProcInfo);

	if(bRetVal){
		hProcess = stProcInfo.hProcess;
		hThread = stProcInfo.hThread;
		SetHandle(hProcess);
	}
	else
		SetHandle(NULL);


}

cProcess::~cProcess(void)
{
	CloseHandle( MyHandle() );
}


BOOL cProcess::Kill(UINT uExitCode)
{
	return( TerminateProcess( hProcess, uExitCode ));
}

BOOL cProcess::Suspend()
{
	return( SuspendThread( hThread ));

}

BOOL cProcess::Resume()
{
	return( ResumeThread( hThread ) );
}

BOOL cProcess::GetPriorityClass( DWORD* pdwPriorityClass )
{
	(*pdwPriorityClass) = ::GetPriorityClass(hProcess);

	if( pdwPriorityClass == 0 )
		return FALSE;
	else
		return TRUE;

}

BOOL cProcess::SetPriorityClass( DWORD dwPriorityClass )
{
	return( ::SetPriorityClass( hProcess, dwPriorityClass ));
}

BOOL cProcess::GetExitCode(DWORD* pdwExitCode )
{
	return( GetExitCodeProcess( hProcess, pdwExitCode ));
}

