#include "cSemaphore.hpp"
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

Semaphore::Semaphore( LONG linitialCount,LONG lMaximumCount,LPCTSTR lpName )
{

	HANDLE hSem;
// Create a SECURITY_ATTRIBUTES to allow for inheritance of this object.
	SECURITY_ATTRIBUTES		stSecurity;
	
	stSecurity.nLength = sizeof( SECURITY_ATTRIBUTES ); // set the length
	stSecurity.bInheritHandle = TRUE;				   // allow this semaphore to be inherited.
	stSecurity.lpSecurityDescriptor = NULL;			   // Use the calling processes Security Descriptor.

	try{
		hSem = CreateSemaphore( &stSecurity,linitialCount,lMaximumCount,lpName);
	}
	catch(...)
	{
		fprintf(stderr,"Semaphore: Internal Error, unable to create semaphore object\n");
	}

	SetHandle( hSem );
	
}
	




	
// constructor for use when the user wants a semaphore object to control an already
// created named semaphore.
	
Semaphore::Semaphore( HANDLE hSem )
{
	SetHandle( hSem );

}

	
// Destructor to ensure that the semaphore handle is closed when the Semaphore object
// is destroyed.	
Semaphore::~Semaphore()
{
	CloseHandle( MyHandle() );

}

BOOL Semaphore::Release( LONG lReleaseCount, LONG* lPreviousCount )
{
	HANDLE hH;
	hH = MyHandle();

	return( ReleaseSemaphore(hH,lReleaseCount, lPreviousCount ));

}
  
