// Service.cpp
//
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define RETURNRESULT(x)		if((x)){ XST_mYES(0); }\
                     		else { XST_mNO(0); }\
                     		XSRETURN(1)
#define SETIV(index,value) sv_setiv(ST(index), value)
#define SETPV(index,string) sv_setpv(ST(index), string)

// constant function for exporting NT definitions.

static long constant(CPerl* pPerl, char *name)
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	if (strEQ(name, "SERVICE_WIN32_OWN_PROCESS"))
#ifdef SERVICE_WIN32_OWN_PROCESS
		return SERVICE_WIN32_OWN_PROCESS;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_WIN32_SHARE_PROCESS"))
#ifdef SERVICE_WIN32_SHARE_PROCESS
		return SERVICE_WIN32_SHARE_PROCESS;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_KERNEL_DRIVER"))
#ifdef SERVICE_KERNEL_DRIVER
		return SERVICE_KERNEL_DRIVER;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_FILE_SYSTEM_DRIVER"))
#ifdef SERVICE_FILE_SYSTEM_DRIVER
		return SERVICE_FILE_SYSTEM_DRIVER;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_INTERACTIVE_PROCESS"))
#ifdef SERVICE_INTERACTIVE_PROCESS
		return SERVICE_INTERACTIVE_PROCESS;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_STOPPED"))
#ifdef SERVICE_STOPPED
		return SERVICE_STOPPED;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_START_PENDING"))
#ifdef SERVICE_START_PENDING
		return SERVICE_START_PENDING;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_STOP_PENDING"))
#ifdef SERVICE_STOP_PENDING
		return SERVICE_STOP_PENDING;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_RUNNING"))
#ifdef SERVICE_RUNNING
		return SERVICE_RUNNING;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_CONTINUE_PENDING"))
#ifdef SERVICE_CONTINUE_PENDING
		return SERVICE_CONTINUE_PENDING;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_PAUSE_PENDING"))
#ifdef SERVICE_PAUSE_PENDING
		return SERVICE_PAUSE_PENDING;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_PAUSED"))
#ifdef SERVICE_PAUSED
		return SERVICE_PAUSED;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_ACCEPT_STOP"))
#ifdef SERVICE_ACCEPT_STOP
		return SERVICE_ACCEPT_STOP;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_ACCEPT_PAUSE_CONTINUE"))
#ifdef SERVICE_ACCEPT_PAUSE_CONTINUE
		return SERVICE_ACCEPT_PAUSE_CONTINUE;
#else
		goto not_there;
#endif	
	if (strEQ(name, "SERVICE_ACCEPT_SHUTDOWN"))
#ifdef SERVICE_ACCEPT_SHUTDOWN
		return SERVICE_ACCEPT_SHUTDOWN;
#else
		goto not_there;
#endif	
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


XS(XS_NT__Service_constant)
{
	dXSARGS;

	if (items != 2)
	{
		croak("Usage: Win32::Service::constant(name, arg)\n");
	}
	{
		char* name = (char*)SvPV(ST(0),na);
		ST(0) = sv_newmortal();
		sv_setiv(ST(0), constant(pPerl, name));
	}
	XSRETURN(1);
}

XS(XS_NT__Service_StartService)
{
	dXSARGS;
	BOOL bRet = FALSE;

	if(items != 2)
	{
		croak("Usage: Win32::Service::StartService($hostName, $serviceName)\n");
	}
	{
		SC_HANDLE hSCManager, hSCService;
		char* lpHostName = (char*)SvPV(ST(0),na);
		char* lpServiceName = (char*)SvPV(ST(1),na);
		if(*lpHostName == '\0')
			lpHostName = NULL;
		if(*lpServiceName != '\0')
		{
			hSCManager = OpenSCManager(lpHostName, NULL, SC_MANAGER_CONNECT);
			if(hSCManager != NULL)
			{
				hSCService = OpenService(hSCManager, lpServiceName, SERVICE_START);
				if(hSCService != NULL)
				{
					bRet = StartService(hSCService, 0, NULL);
					CloseServiceHandle(hSCService);
				}
				CloseServiceHandle(hSCManager);
			}
		}
	}
	RETURNRESULT(bRet);
}

XS(XS_NT__Service_StopService)
{
	dXSARGS;
	BOOL bRet = FALSE;

	if(items != 2)
	{
		croak("Usage: Win32::Service::StopService($hostName, $serviceName)\n");
	}
	{
		SERVICE_STATUS serviceStatus;
		SC_HANDLE hSCManager, hSCService;
		char* lpHostName = (char*)SvPV(ST(0),na);
		char* lpServiceName = (char*)SvPV(ST(1),na);
		if(*lpHostName == '\0')
			lpHostName = NULL;
		if(*lpServiceName != '\0')
		{
			hSCManager = OpenSCManager(lpHostName, NULL, SC_MANAGER_CONNECT);
			if(hSCManager != NULL)
			{
				hSCService = OpenService(hSCManager, lpServiceName, SERVICE_STOP);
				if(hSCService != NULL)
				{
					bRet = ControlService(hSCService, SERVICE_CONTROL_STOP, &serviceStatus);
					CloseServiceHandle(hSCService);
				}
				CloseServiceHandle(hSCManager);
			}
		}
	}
	RETURNRESULT(bRet);
}


XS(XS_NT__Service_GetStatus)
{
	dXSARGS;
	BOOL bRet = FALSE;

	if(items != 3)
	{
usage:
		croak("Usage: Win32::Service::GetStatus($hostName, $serviceName, \\%status)\n");
	}
	{
		SV* sv;
		HV* hv;
		SERVICE_STATUS serviceStatus;
		SC_HANDLE hSCManager, hSCService;
		char* lpHostName = (char*)SvPV(ST(0),na);
		char* lpServiceName = (char*)SvPV(ST(1),na);

		sv = ST(2);
		if(SvROK(sv))
			sv = SvRV(sv);
		if(SvTYPE(sv) != SVt_PVHV)
			goto usage;
		hv = (HV*)sv;

		if(*lpHostName == '\0')
			lpHostName = NULL;

		if(*lpServiceName != '\0')
		{
			hSCManager = OpenSCManager(lpHostName, NULL, SC_MANAGER_CONNECT);
			if(hSCManager != NULL)
			{
				hSCService = OpenService(hSCManager, lpServiceName, SERVICE_INTERROGATE);
				if(hSCService != NULL)
				{
					bRet = ControlService(hSCService, SERVICE_CONTROL_INTERROGATE, &serviceStatus);
					if(!bRet)
					{
						if(GetLastError() == ERROR_SERVICE_NOT_ACTIVE)
						{
							memset(&serviceStatus, 0, sizeof(serviceStatus));
							serviceStatus.dwCurrentState = SERVICE_STOPPED;
							bRet = TRUE;
						}
					}
					CloseServiceHandle(hSCService);
				}
				CloseServiceHandle(hSCManager);
				if(bRet)
				{
					sv = newSViv(serviceStatus.dwServiceType);
					hv_store(hv, "ServiceType", strlen("ServiceType"), sv, 0);
    
					sv = newSViv(serviceStatus.dwCurrentState);
					hv_store(hv, "CurrentState", strlen("CurrentState"), sv, 0);

					sv = newSViv(serviceStatus.dwControlsAccepted);
					hv_store(hv, "ControlsAccepted", strlen("ControlsAccepted"), sv, 0);

					sv = newSViv(serviceStatus.dwWin32ExitCode);
					hv_store(hv, "Win32ExitCode", strlen("Win32ExitCode"), sv, 0);

					sv = newSViv(serviceStatus.dwServiceSpecificExitCode);
					hv_store(hv, "ServiceSpecificExitCode", strlen("ServiceSpecificExitCode"), sv, 0);

					sv = newSViv(serviceStatus.dwCheckPoint);
					hv_store(hv, "CheckPoint", strlen("CheckPoint"), sv, 0);

					sv = newSViv(serviceStatus.dwWaitHint);
					hv_store(hv, "WaitHint", strlen("WaitHint"), sv, 0);

					sv_setsv(ST(2), newRV((SV*)hv));
				}
			}
		}
	}
	RETURNRESULT(bRet);
}

XS(XS_NT__Service_PauseService)
{
	dXSARGS;
	BOOL bRet = FALSE;

	if(items != 2)
	{
		croak("Usage: Win32::Service::PauseService($hostName, $serviceName)\n");
	}
	{
		SERVICE_STATUS serviceStatus;
		SC_HANDLE hSCManager, hSCService;
		char* lpHostName = (char*)SvPV(ST(0),na);
		char* lpServiceName = (char*)SvPV(ST(1),na);
		if(*lpHostName == '\0')
			lpHostName = NULL;
		if(*lpServiceName != '\0')
		{
			hSCManager = OpenSCManager(lpHostName, NULL, SC_MANAGER_ALL_ACCESS);
			if(hSCManager != NULL)
			{
				hSCService = OpenService(hSCManager, lpServiceName, SERVICE_PAUSE_CONTINUE);
				if(hSCService != NULL)
				{
					bRet = ControlService(hSCService, SERVICE_CONTROL_PAUSE, &serviceStatus);
					CloseServiceHandle(hSCService);
				}
				CloseServiceHandle(hSCManager);
			}
		}
	}
	RETURNRESULT(bRet);
}

XS(XS_NT__Service_ResumeService)
{
	dXSARGS;
	BOOL bRet = FALSE;

	if(items != 2)
	{
		croak("Usage: Win32::Service::ResumeService($hostName, $serviceName)\n");
	}
	{
		SERVICE_STATUS serviceStatus;
		SC_HANDLE hSCManager, hSCService;
		char* lpHostName = (char*)SvPV(ST(0),na);
		char* lpServiceName = (char*)SvPV(ST(1),na);
		if(*lpHostName == '\0')
			lpHostName = NULL;
		if(*lpServiceName != '\0')
		{
			hSCManager = OpenSCManager(lpHostName, NULL, SC_MANAGER_ALL_ACCESS);
			if(hSCManager != NULL)
			{
				hSCService = OpenService(hSCManager, lpServiceName, SERVICE_PAUSE_CONTINUE);
				if(hSCService != NULL)
				{
					bRet = ControlService(hSCService, SERVICE_CONTROL_CONTINUE, &serviceStatus);
					CloseServiceHandle(hSCService);
				}
				CloseServiceHandle(hSCManager);
			}
		}
	}
	RETURNRESULT(bRet);
}

XS(XS_NT__Service_GetServices)
{
	dXSARGS;
	BOOL bRet = FALSE;

	if(items != 2)
	{
usage:
		croak("Usage: Win32::Service::GetServices($hostName, \\%list)\n");
	}
	{
		SV* sv;
		HV* hv;
		DWORD dwBytesNeeded, dwServicesReturned, dwResumeHandle, dwIndex;
		ENUM_SERVICE_STATUS ess[1000];
		SC_HANDLE hSCManager;
		char* lpHostName = (char*)SvPV(ST(0),na);

		if(*lpHostName == '\0')
			lpHostName = NULL;

		sv = ST(1);
		if(SvROK(sv))
			sv = SvRV(sv);
		if(SvTYPE(sv) != SVt_PVHV)
			goto usage;
		hv = (HV*)sv;

		hSCManager = OpenSCManager(lpHostName, NULL, SC_MANAGER_ENUMERATE_SERVICE);
		if(hSCManager != NULL)
		{
			dwResumeHandle = 0;
			dwBytesNeeded = 0;
			dwServicesReturned = 0;
			while(EnumServicesStatus(hSCManager, SERVICE_WIN32, SERVICE_ACTIVE | SERVICE_INACTIVE,
						ess, sizeof(ess), &dwBytesNeeded, &dwServicesReturned, &dwResumeHandle) == TRUE
					|| GetLastError() == ERROR_MORE_DATA)
			{
				for(dwIndex = 0; dwIndex < dwServicesReturned; ++dwIndex)
				{
					sv = newSVpv(ess[dwIndex].lpServiceName, 0);
					hv_store(hv, ess[dwIndex].lpDisplayName, strlen(ess[dwIndex].lpDisplayName), sv, 0);
				}
				if(dwResumeHandle == 0)
				{
					bRet = TRUE;
					break;
				}
			}
			CloseServiceHandle(hSCManager);
		}
	}
	RETURNRESULT(bRet);
}

XS(boot_Win32__Service)
{
	dXSARGS;
	char* file = __FILE__;

	newXS("Win32::Service::constant", XS_NT__Service_constant, file);
	newXS("Win32::Service::StartService", XS_NT__Service_StartService, file);
	newXS("Win32::Service::StopService", XS_NT__Service_StopService, file);
	newXS("Win32::Service::GetStatus", XS_NT__Service_GetStatus, file);
	newXS("Win32::Service::PauseService", XS_NT__Service_PauseService, file);
	newXS("Win32::Service::ResumeService", XS_NT__Service_ResumeService, file);
	newXS("Win32::Service::GetServices", XS_NT__Service_GetServices, file);
	ST(0) = &sv_yes;
	XSRETURN(1);
}


