
#ifdef MSWIN32
#include <windows.h>
#define WIN32_LEAN_AND_MEAN
#endif

#include "INTERN.h"
#include "perl.h"

#ifdef MSWIN32
#include "perllib.h"
#endif

#ifdef PERL_OBJECT
#define CHECKFUNC(x) OP* CK##x(CPerl *pPerl, OP* op)\
		{\
			return pPerl->ck##x(op);\
		}

#define PPFUNC(x) OP* PP##x(CPerl *pPerl)\
		{\
			return pPerl->pp##x();\
		}

CHECKFUNC(_concat)
CHECKFUNC(_delete)
CHECKFUNC(_eof)
CHECKFUNC(_eval)
CHECKFUNC(_exec)
CHECKFUNC(_formline)
CHECKFUNC(_ftst)
CHECKFUNC(_fun)
CHECKFUNC(_glob)
CHECKFUNC(_grep)
CHECKFUNC(_index)
CHECKFUNC(_lengthconst)
CHECKFUNC(_lfun)
CHECKFUNC(_listiob)
CHECKFUNC(_match)
CHECKFUNC(_null)
CHECKFUNC(_repeat)
CHECKFUNC(_require)
CHECKFUNC(_rfun)
CHECKFUNC(_rvconst)
CHECKFUNC(_select)
CHECKFUNC(_shift)
CHECKFUNC(_sort)
CHECKFUNC(_spair)
CHECKFUNC(_split)
CHECKFUNC(_subr)
CHECKFUNC(_svconst)
CHECKFUNC(_trunc)

PPFUNC(_null)
PPFUNC(_stub)
PPFUNC(_scalar)
PPFUNC(_pushmark)
PPFUNC(_wantarray)
PPFUNC(_const)
PPFUNC(_gvsv)
PPFUNC(_gv)
PPFUNC(_gelem)
PPFUNC(_padsv)
PPFUNC(_padav)
PPFUNC(_padhv)
PPFUNC(_padany)
PPFUNC(_pushre)
PPFUNC(_rv2gv)
PPFUNC(_rv2sv)
PPFUNC(_av2arylen)
PPFUNC(_rv2cv)
PPFUNC(_anoncode)
PPFUNC(_refgen)
PPFUNC(_srefgen)
PPFUNC(_ref)
PPFUNC(_bless)
PPFUNC(_backtick)
PPFUNC(_glob)
PPFUNC(_readline)
PPFUNC(_rcatline)
PPFUNC(_regcmaybe)
PPFUNC(_regcomp)
PPFUNC(_match)
PPFUNC(_subst)
PPFUNC(_substcont)
PPFUNC(_trans)
PPFUNC(_sassign)
PPFUNC(_aassign)
PPFUNC(_chop)
PPFUNC(_schop)
PPFUNC(_chomp)
PPFUNC(_schomp)
PPFUNC(_defined)
PPFUNC(_undef)
PPFUNC(_study)
PPFUNC(_pos)
PPFUNC(_preinc)
//PPFUNC(_i_preinc)
PPFUNC(_predec)
//PPFUNC(_i_predec)
PPFUNC(_postinc)
//PPFUNC(_i_postinc)
PPFUNC(_postdec)
//PPFUNC(_i_postdec)
PPFUNC(_pow)
PPFUNC(_multiply)
PPFUNC(_i_multiply)
PPFUNC(_divide)
PPFUNC(_i_divide)
PPFUNC(_modulo)
PPFUNC(_i_modulo)
PPFUNC(_repeat)
PPFUNC(_add)
PPFUNC(_i_add)
PPFUNC(_subtract)
PPFUNC(_i_subtract)
PPFUNC(_concat)
PPFUNC(_stringify)
PPFUNC(_left_shift)
PPFUNC(_right_shift)
PPFUNC(_lt)
PPFUNC(_i_lt)
PPFUNC(_gt)
PPFUNC(_i_gt)
PPFUNC(_le)
PPFUNC(_i_le)
PPFUNC(_ge)
PPFUNC(_i_ge)
PPFUNC(_eq)
PPFUNC(_i_eq)
PPFUNC(_ne)
PPFUNC(_i_ne)
PPFUNC(_ncmp)
PPFUNC(_i_ncmp)
PPFUNC(_slt)
PPFUNC(_sgt)
PPFUNC(_sle)
PPFUNC(_sge)
PPFUNC(_seq)
PPFUNC(_sne)
PPFUNC(_scmp)
PPFUNC(_bit_and)
PPFUNC(_bit_xor)
PPFUNC(_bit_or)
PPFUNC(_negate)
PPFUNC(_i_negate)
PPFUNC(_not)
PPFUNC(_complement)
PPFUNC(_atan2)
PPFUNC(_sin)
PPFUNC(_cos)
PPFUNC(_rand)
PPFUNC(_srand)
PPFUNC(_exp)
PPFUNC(_log)
PPFUNC(_sqrt)
PPFUNC(_int)
PPFUNC(_hex)
PPFUNC(_oct)
PPFUNC(_abs)
PPFUNC(_length)
PPFUNC(_substr)
PPFUNC(_vec)
PPFUNC(_index)
PPFUNC(_rindex)
PPFUNC(_sprintf)
PPFUNC(_formline)
PPFUNC(_ord)
PPFUNC(_chr)
PPFUNC(_crypt)
PPFUNC(_ucfirst)
PPFUNC(_lcfirst)
PPFUNC(_uc)
PPFUNC(_lc)
PPFUNC(_quotemeta)
PPFUNC(_rv2av)
PPFUNC(_aelemfast)
PPFUNC(_aelem)
PPFUNC(_aslice)
PPFUNC(_each)
PPFUNC(_values)
PPFUNC(_keys)
PPFUNC(_delete)
PPFUNC(_exists)
PPFUNC(_rv2hv)
PPFUNC(_helem)
PPFUNC(_hslice)
PPFUNC(_unpack)
PPFUNC(_pack)
PPFUNC(_split)
PPFUNC(_join)
PPFUNC(_list)
PPFUNC(_lslice)
PPFUNC(_anonlist)
PPFUNC(_anonhash)
PPFUNC(_splice)
PPFUNC(_push)
PPFUNC(_pop)
PPFUNC(_shift)
PPFUNC(_unshift)
PPFUNC(_sort)
PPFUNC(_reverse)
PPFUNC(_grepstart)
PPFUNC(_grepwhile)
PPFUNC(_mapstart)
PPFUNC(_mapwhile)
PPFUNC(_range)
PPFUNC(_flip)
PPFUNC(_flop)
PPFUNC(_and)
PPFUNC(_or)
PPFUNC(_xor)
PPFUNC(_cond_expr)
PPFUNC(_andassign)
PPFUNC(_orassign)
PPFUNC(_method)
PPFUNC(_entersub)
PPFUNC(_leavesub)
PPFUNC(_caller)
PPFUNC(_warn)
PPFUNC(_die)
PPFUNC(_reset)
PPFUNC(_lineseq)
PPFUNC(_nextstate)
PPFUNC(_dbstate)
PPFUNC(_unstack)
PPFUNC(_enter)
PPFUNC(_leave)
PPFUNC(_scope)
PPFUNC(_enteriter)
PPFUNC(_iter)
PPFUNC(_enterloop)
PPFUNC(_leaveloop)
PPFUNC(_return)
PPFUNC(_last)
PPFUNC(_next)
PPFUNC(_redo)
PPFUNC(_dump)
PPFUNC(_goto)
PPFUNC(_exit)
PPFUNC(_open)
PPFUNC(_close)
PPFUNC(_pipe_op)
PPFUNC(_fileno)
PPFUNC(_umask)
PPFUNC(_binmode)
PPFUNC(_tie)
PPFUNC(_tied)
PPFUNC(_untie)
PPFUNC(_dbmopen)
PPFUNC(_dbmclose)
PPFUNC(_sselect)
PPFUNC(_select)
PPFUNC(_getc)
PPFUNC(_read)
PPFUNC(_enterwrite)
PPFUNC(_leavewrite)
PPFUNC(_prtf)
PPFUNC(_print)
PPFUNC(_prototype)
PPFUNC(_sysopen)
PPFUNC(_sysread)
PPFUNC(_syswrite)
PPFUNC(_send)
PPFUNC(_recv)
PPFUNC(_eof)
PPFUNC(_tell)
PPFUNC(_seek)
PPFUNC(_truncate)
PPFUNC(_fcntl)
PPFUNC(_ioctl)
PPFUNC(_flock)
PPFUNC(_socket)
PPFUNC(_sockpair)
PPFUNC(_bind)
PPFUNC(_connect)
PPFUNC(_listen)
PPFUNC(_accept)
PPFUNC(_shutdown)
PPFUNC(_gsockopt)
PPFUNC(_ssockopt)
PPFUNC(_getsockname)
PPFUNC(_getpeername)
PPFUNC(_lstat)
PPFUNC(_stat)
PPFUNC(_ftrread)
PPFUNC(_ftrwrite)
PPFUNC(_ftrexec)
PPFUNC(_fteread)
PPFUNC(_ftewrite)
PPFUNC(_fteexec)
PPFUNC(_ftis)
PPFUNC(_fteowned)
PPFUNC(_ftrowned)
PPFUNC(_ftzero)
PPFUNC(_ftsize)
PPFUNC(_ftmtime)
PPFUNC(_ftatime)
PPFUNC(_ftctime)
PPFUNC(_ftsock)
PPFUNC(_ftchr)
PPFUNC(_ftblk)
PPFUNC(_ftfile)
PPFUNC(_ftdir)
PPFUNC(_ftpipe)
PPFUNC(_ftlink)
PPFUNC(_ftsuid)
PPFUNC(_ftsgid)
PPFUNC(_ftsvtx)
PPFUNC(_fttty)
PPFUNC(_fttext)
PPFUNC(_ftbinary)
PPFUNC(_chdir)
PPFUNC(_chown)
PPFUNC(_chroot)
PPFUNC(_unlink)
PPFUNC(_chmod)
PPFUNC(_utime)
PPFUNC(_rename)
PPFUNC(_link)
PPFUNC(_symlink)
PPFUNC(_readlink)
PPFUNC(_mkdir)
PPFUNC(_rmdir)
PPFUNC(_open_dir)
PPFUNC(_readdir)
PPFUNC(_telldir)
PPFUNC(_seekdir)
PPFUNC(_rewinddir)
PPFUNC(_closedir)
PPFUNC(_fork)
PPFUNC(_wait)
PPFUNC(_waitpid)
PPFUNC(_system)
PPFUNC(_exec)
PPFUNC(_kill)
PPFUNC(_getppid)
PPFUNC(_getpgrp)
PPFUNC(_setpgrp)
PPFUNC(_getpriority)
PPFUNC(_setpriority)
PPFUNC(_time)
PPFUNC(_tms)
PPFUNC(_localtime)
PPFUNC(_gmtime)
PPFUNC(_alarm)
PPFUNC(_sleep)
PPFUNC(_shmget)
PPFUNC(_shmctl)
PPFUNC(_shmread)
PPFUNC(_shmwrite)
PPFUNC(_msgget)
PPFUNC(_msgctl)
PPFUNC(_msgsnd)
PPFUNC(_msgrcv)
PPFUNC(_semget)
PPFUNC(_semctl)
PPFUNC(_semop)
PPFUNC(_require)
PPFUNC(_dofile)
PPFUNC(_entereval)
PPFUNC(_leaveeval)
PPFUNC(_entertry)
PPFUNC(_leavetry)
PPFUNC(_ghbyname)
PPFUNC(_ghbyaddr)
PPFUNC(_ghostent)
PPFUNC(_gnbyname)
PPFUNC(_gnbyaddr)
PPFUNC(_gnetent)
PPFUNC(_gpbyname)
PPFUNC(_gpbynumber)
PPFUNC(_gprotoent)
PPFUNC(_gsbyname)
PPFUNC(_gsbyport)
PPFUNC(_gservent)
PPFUNC(_shostent)
PPFUNC(_snetent)
PPFUNC(_sprotoent)
PPFUNC(_sservent)
PPFUNC(_ehostent)
PPFUNC(_enetent)
PPFUNC(_eprotoent)
PPFUNC(_eservent)
PPFUNC(_gpwnam)
PPFUNC(_gpwuid)
PPFUNC(_gpwent)
PPFUNC(_spwent)
PPFUNC(_epwent)
PPFUNC(_ggrnam)
PPFUNC(_ggrgid)
PPFUNC(_ggrent)
PPFUNC(_sgrent)
PPFUNC(_egrent)
PPFUNC(_getlogin)
PPFUNC(_syscall)

#ifndef MSWIN32
CPerl::CPerl()
{
	memset(((char*)this)+sizeof(void*), 0, sizeof(CPerl)-sizeof(void*));
}

CPerl*
perl_alloc()
{	// Create a CPerl object
	CPerl *ptr = new CPerl();
	if(ptr != NULL)
		ptr->Init();

	return ptr;
}

#else
CPerl::CPerl(IPerlSupport *pvtbl)
{
	memset(((char*)this)+sizeof(void*), 0, sizeof(CPerl)-sizeof(void*));
	pVtbl = pvtbl;
}

void CPerl::Exit(int x)
{
	longjmp(MSLibControl, 1);
}

void CPerl::FlushAll(void)
{
	pVtbl->Flushall(errno);
}

void* CPerl::operator new(size_t nSize, IPerlSupport *pvtbl)
{
	if(pvtbl != NULL)
		return pvtbl->Malloc(nSize);

	return NULL;
}

int &CPerl::ErrorNo(void)
{
	return Errno;
}

void CPerl::PerlCaller(char* string, int size)
{
	pVtbl->PerlCaller(string, size);
}

IPerlSupport* CPerl::GetpVtbl(void)
{
	return pVtbl;
}

CPerl*
perl_alloc(IPerlSupport *pvtbl)
{	// Create a CPerl object
	CPerl *ptr = new(pvtbl) CPerl(pvtbl);
	if(ptr != NULL)
		ptr->Init();

	return ptr;
}

int	fprintf(FILE *stream, const char *format, ...)
{
	va_list(arglist);
	va_start(arglist, format);
	return pVtbl->Vfprintf(stream, format, arglist, errno);
}

#ifndef VER_PLATFORM_WIN32s
#define VER_PLATFORM_WIN32s 0
#endif

#ifndef VER_PLATFORM_WIN32_WINDOWS
#define VER_PLATFORM_WIN32_WINDOWS 1
#endif

#ifndef VER_PLATFORM_WIN32_NT
#define VER_PLATFORM_WIN32_NT 2
#endif

int CPerl::IsWinNT(void)
{
	return (Win32System == VER_PLATFORM_WIN32_NT);
}

int CPerl::IsWin95(void)
{
	return (Win32System == VER_PLATFORM_WIN32_WINDOWS);
}

void CPerl::SaveTmps(void)
{
	SAVETMPS;
}

void CPerl::FreeTmps(void)
{
	FREETMPS;
}

void CPerl::srand(unsigned int seed)
{
	randSeed = (long)seed;
}

int CPerl::rand(void)
{
	return(((randSeed = randSeed * 214013L + 2531011L) >> 16) & 0x7fff);
}

CV* CPerl::NewXSVersion(char *name, void (*subaddr)(CPerl *pPerl, CV* cv), char *filename, char *buildNum /* = NT_BUILD_NUMBER */)
{	// check that we can run this build of the extension
	if(strcmp(buildNum, NT_BUILD_NUMBER) != 0)
	{
		int nBuildExt = atoi(buildNum);
		int nBuildVer = atoi(NT_BUILD_NUMBER);
		if(nBuildExt < 303 || nBuildExt > nBuildVer)
			croak("This is build %s of Perl and the extension reqiures build %s\n", NT_BUILD_NUMBER, buildNum);
	}
	return newXS(name, subaddr, filename);
}

#endif /* MSWIN32 */

void CPerl::Init(void)
{
	maxo INIT(MAXO);/* Number of ops */
	rsfp INIT(Nullfp);
	expect INIT(XSTATE);	/* how to interpret ambiguous tokens */

	Isplitstr INIT(" ");
	Ichopset INIT(" \n-");	/* $: */
	Imaxsysfd INIT(MAXSYSFD); /* top fd to pass to subprocesses */
	Istatname INIT(Nullsv);
	Imaxscream INIT(-1);
	Itmps_ix INIT(-1);
	Itmps_floor INIT(-1);
	Iop_mask INIT(NULL);	/* masked operations for safe evals */
	Idlmax INIT(128);
	Icurcop INIT(&compiling);
	Icopline INIT(NOLINE);
	Icxstack_ix INIT(-1);
	Icxstack_max INIT(128);
	Ilaststatval INIT(-1);
	Ilaststype INIT(OP_STAT);

	fdscript = -1;

#ifdef MSWIN32
	New(2904, environ, 1, char*);
	*environ = NULL;
	last_hkey = (void*)(-1);
	generation = 100;
	randSeed = 1L;
	Errno = 0;
	pNtCryptBuffer = NULL;

	OSVERSIONINFO osver;
	memset(&osver, 0, sizeof(OSVERSIONINFO));
	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osver);
	Win32System = osver.dwPlatformId;
#endif /* MSIWN32 */
}

#endif /* PERL_OBJECT */