// NT.C

// (c) 1995 Microsoft Corporation. All rights reserved. 
//	Developed by ActiveWare Internet Corp., http://www.ActiveWare.com
// Portions (c) 1993 Intergraph Corporation. All rights reserved.

//    You may distribute under the terms of either the GNU General Public
//    License or the Artistic License, as specified in the README file.

#include <windows.h>
#define WIN32_LEAN_AND_MEAN
#include "EXTERN.h"
#include "perl.h"
#include <fcntl.h>
#include <sys/stat.h>
#include <assert.h>

#define CROAK croak

BOOL HasRedirection(char *ptr)
{
	int inquote = 0;
	char quote = '\0';

	//
	// Scan string looking for redirection (< or >) or pipe
	// characters (|) that are not in a quoted string
	//
	while(*ptr) 
	{
		switch(*ptr) 
		{
			case '\'':
			case '\"':
				if(inquote) 
				{
					if(quote == *ptr) 
					{
						inquote = 0;
						quote = '\0';
					}
				}
				else
				{
					quote = *ptr;
					inquote++;
				}
				break;

			case '>':
			case '<':
			case '|':
				if(!inquote)
					return TRUE;

			default:
				break;
		}
		++ptr;
	}
	return FALSE;
}

// since the current process environment is being updated in util.c
// the library functions will get the correct environment
FILE *my_popen(char *cmd, char *mode)
{
    return _popen(cmd, mode);
}

long my_pclose(FILE *fp)
{
	int retval = _pclose(fp);
	return (retval < 0) ? retval : retval * 256;
}

char *desCrypt(char *buff, char *buf, char *salt);

char *NtCrypt(char*pClear, char*pKey)
{
	if(pNtCryptBuffer == NULL)
		New(1110, pNtCryptBuffer, 30, char);

	return desCrypt(pNtCryptBuffer, pClear, pKey);
}

char *NtGetLib(void)
{
	static char szLibPath[MAX_PATH+1];
	static BOOL called = 0;

	if(!called) 
	{
		DWORD bufsz;

		bufsz = sizeof(szLibPath);
		NtGetPerlRegStr(this, "PRIVLIB", DEFPRIVLIB, szLibPath, &bufsz);
		called = TRUE;
	}
	return szLibPath;
}

char *NtGetArchLib(void)
{
	static char szArchLibPath[MAX_PATH+1];
	static BOOL called = 0;
#if defined _ALPHA_
	static char *szMArchLib = "\\alpha-win32";
#elif defined _X86_
	static char *szMArchLib = "\\i386-win32";
#elif defined _MIPS_
	static char *szMArchLib = "\\mips-win32";
#elif defined _PPC_
	static char *szMArchLib = "\\ppc-win32";
#endif            

	if(!called) 
	{
		DWORD bufsz;

		bufsz = sizeof(szArchLibPath);
		NtGetPerlRegStr(this, "ARCHLIB", "", szArchLibPath, &bufsz);
		if (strlen(szArchLibPath) == 0)
		{
			// Derive ARCHLIB from PRIVLIB
			strcpy(szArchLibPath, NtGetLib());
			strcat(szArchLibPath, szMArchLib);
		}
		called = TRUE;
	}
	return szArchLibPath;
}

char *NtGetSiteLib(void)
{
	static char szSiteLibPath[MAX_PATH+1];
	static BOOL called = 0;

	if(!called) 
	{
		DWORD bufsz;

		bufsz = sizeof(szSiteLibPath);
		NtGetPerlRegStr(this, "SITELIB", DEFSITELIB, szSiteLibPath, &bufsz);
		called = TRUE;
	}
	return szSiteLibPath;
}

char *NtGetBin(void)
{
	static char binpath[MAX_PATH+1];
	static BOOL called = 0;

	if(!called) 
	{
		DWORD bufsz;

		bufsz = sizeof(binpath);
		NtGetPerlRegStr(this, "BIN", DEFBIN, binpath, &bufsz);
		called = TRUE;
	}
	return binpath;
}

char *NtGetDebugScriptStr(void)
{
	static char debugScript[MAX_PATH+1];
	static BOOL called = 0;

	if(!called) 
	{
		DWORD bufsz;

		bufsz = sizeof(debugScript);
		NtGetPerlRegStr(this, "PERL5DB", "", debugScript, &bufsz);
		called = TRUE;
	}
	if(debugScript[0] != '\0')
		return debugScript;

	return NULL;
}

static char *GetShell(CPerl *pPerl)
{
	static char* szWin95DefaultShell = "Cmd32.exe";
#ifdef PRIVATE_PERL
	static char* szPerlModule = "pPerl300.dll";
#else
	static char* szPerlModule = "Perl300.dll";
#endif
	static char szShellPath[MAX_PATH+1];
	static BOOL called = 0;

	if(!called)
	{
		char* ptr;
		char szDefault[MAX_PATH+1];
		DWORD bufsz;

		if(pPerl->IsWin95())
		{

			ptr = szDefault;
			if(GetModuleFileName(GetModuleHandle(szPerlModule), szDefault, sizeof(szDefault)))
			{
				ptr = strrchr(szDefault, '\\');
				if(ptr == NULL)
					ptr = strrchr(szDefault, '/');

				if(ptr != NULL)
				{	// step over path separator
					++ptr;
				}
				else
					ptr = szDefault;
			}
			strcpy(ptr, szWin95DefaultShell);
		}
		else
		{
			if((ptr = pPerl->GetpVtbl()->Getenv("COMSPEC")) == 0)
	    		ptr = "cmd.exe";

			strcpy(szDefault, ptr);
		}

		bufsz = sizeof(szShellPath);
		NtGetPerlRegStr(pPerl, "COMSPEC", szDefault, szShellPath, &bufsz);
		called = TRUE;
	}
	return szShellPath;
}

int do_aspawn(void* really, void** mark, void** arglast)
{
	char **argv;
	char *strPtr;
	char *cmd;
	int status;
	unsigned int length;
	int index = 0;
    SV *sv = (SV*)really;
	SV** pSv = (SV**)mark;

	New(1110, argv, (arglast - mark) + 3, char*);

	if(sv != Nullsv)
	{
		cmd = SvPV(sv, length);
	}
	else
	{
		cmd = GetShell(this);
		argv[index++] = "/c";
	}

	while(++pSv <= (SV**)arglast)
	{
		sv = *pSv;
		strPtr = SvPV(sv, length);
		if(strPtr != NULL && *strPtr != '\0')
			argv[index++] = strPtr;
	}
	argv[index++] = 0;

	status = pVtbl->Spawn(P_WAIT, cmd, (const char* const*)argv, (const char* const*)environ, errno);

	Safefree(argv);

	// set statusvalue the perl variable $?
	return (statusvalue = status*256);
}

int	do_spawn(char *cmd)
{
	char **a;
	char *s;
	char **argv;
	int status = -1;
	BOOL needToTry = TRUE;
	char *shell, *cmd2;

	/* save an extra exec if possible */
	shell = GetShell(this);

	/* see if there are shell metacharacters in it */
	if(!HasRedirection(cmd)) 
	{
		New(1102,argv, strlen(cmd) / 2 + 2, char*);

		New(1103,cmd2, strlen(cmd) + 1, char);
		strcpy(cmd2, cmd);
		a = argv;
		for(s = cmd2; *s;) 
		{
			while(*s && isspace(*s)) s++;
			if(*s)
				*(a++) = s;

			if(*s == '\"')
			{	// go to next quote
				while(*++s != '\"')
					if(*s == '\0')
						break;
				if(*s == '\"')
					++s;	// step over quote
			}
			else
				while(*s && !isspace(*s)) s++;

			if(*s)
				*s++ = '\0';
		}
		*a = Nullch;
		if(argv[0])
		{
			status = pVtbl->Spawn(P_WAIT, argv[0], (const char* const*)argv, (const char* const*)environ, errno);
			if(status != -1 || errno == 0)
				needToTry = FALSE;
		}
		Safefree(argv);
		Safefree(cmd2);
	}
	if(needToTry)
	{
        status = pVtbl->Cmd(P_WAIT, shell, cmd, (const char* const*)environ);
	}

	// set statusvalue the perl variable $?
	return (statusvalue = status*256);
}


#define PATHLEN 1024

// The idea here is to read all the directory names into a string table
// (separated by nulls) and when one of the other dir functions is called
// return the pointer to the current file name. 
DIR *opendir(char *filename)
{
    DIR            *p;
	long            len;
	long            idx;
	char            scannamespc[PATHLEN];
	char       *scanname = scannamespc;
	struct stat     sbuf;
	WIN32_FIND_DATA FindData;
	HANDLE          fh;

	// Create the search pattern
	strcpy(scanname, filename);

	len = strlen(scanname);
	if(len > 0 && ((scanname[len-1] == '/') || (scanname[len-1] == '\\')))
		scanname[len-1] = '\0';

	// check to see if filename is a directory
	if(stat(scanname, &sbuf) < 0 || sbuf.st_mode & _S_IFDIR == 0)
	{
		return NULL;
	}
	strcat(scanname, "/*");

	// Get a DIR structure
	Newz(1501, p, 1, DIR);
	if(p == NULL)
		return NULL;

	// do the FindFirstFile call
	fh = pVtbl->FindFirstFile(scanname, &FindData);
	if(fh == INVALID_HANDLE_VALUE) 
	{
	    Safefree(p);
		return NULL;
	}

	// now allocate the first part of the string table for the filenames that we find.
	idx = strlen(FindData.cFileName)+1;
	New(1502, p->start, idx, char);
	if(p->start == NULL) 
	{
		pVtbl->FindClose(fh);
		CROAK("opendir: malloc failed!\n");
	}
	strcpy(p->start, FindData.cFileName);
	p->nfiles++;

	// loop finding all the files that match the wildcard
	// (which should be all of them in this directory!).
	// the variable idx should point one past the null terminator
	// of the previous string found.
	//
	while(pVtbl->FindNextFile(fh, &FindData)) 
	{
		len = strlen(FindData.cFileName);
		// bump the string table size by enough for the
		// new name and it's null terminator 
		Renew(p->start, idx+len+1, char);
		if(p->start == NULL) 
		{
			pVtbl->FindClose(fh);
	    	CROAK("opendir: malloc failed!\n");
		}
		strcpy(&p->start[idx], FindData.cFileName);
		p->nfiles++;
		idx += len+1;
	}
	pVtbl->FindClose(fh);
	p->size = idx;
	p->curr = p->start;
	return p;
}


// Readdir just returns the current string pointer and bumps the
// string pointer to the next entry.
struct direct *readdir(DIR *dirp)
{
	int         len;
	static int  dummy = 0;

	if(dirp->curr) 
	{	// first set up the structure to return
		len = strlen(dirp->curr);
		strcpy(dirp->dirstr.d_name, dirp->curr);
		dirp->dirstr.d_namlen = len;

		// Fake an inode
		dirp->dirstr.d_ino = dummy++;

		// Now set up for the next call to readdir
		dirp->curr += len + 1;
		if(dirp->curr >= (dirp->start + dirp->size)) 
		{
	    	dirp->curr = NULL;
		}

		return &(dirp->dirstr);
	} 
	else
		return NULL;
}

// Telldir returns the current string pointer position
long telldir(DIR *dirp)
{
    return (long) dirp->curr;
}


// Seekdir moves the string pointer to a previously saved position (Saved by telldir).
void seekdir(DIR *dirp, long loc)
{
    dirp->curr = (char *)loc;
}

// Rewinddir resets the string pointer to the start
void rewinddir(DIR *dirp)
{
    dirp->curr = dirp->start;
}

// free the memory allocated by opendir
int closedir(DIR *dirp)
{
    Safefree(dirp->start);
    Safefree(dirp);
	return 1;
}

//
// various stubs
//


// Ownership
//
// Just pretend that everyone is a superuser. NT will let us know if
// we don\'t really have permission to do something.
//

#define ROOT_UID    ((uid_t)0)
#define ROOT_GID    ((gid_t)0)

uid_t getuid(void)
{
	return ROOT_UID;
}

uid_t geteuid(void)
{
	return ROOT_UID;
}

gid_t getgid(void)
{
	return ROOT_GID;
}

gid_t getegid(void)
{
	return ROOT_GID;
}

int setuid(uid_t uid)
{ 
	return (uid == ROOT_UID ? 0 : -1);
}

int setgid(gid_t gid)
{
	return (gid == ROOT_GID ? 0 : -1);
}

//
// File system stuff
//

int ioctl(int i, unsigned int u, char *data)
{
//	CROAK("ioctl not implemented!\n");
//	return -1;
	u_long argp=(u_long)data;
	int result = 0;

	if(NtIsSocket( i ))
	{
		result = nt_ioctlsocket( (SOCKET)i, (long)u, &argp );
	}
	else
	{
		CROAK("ioctl not implemented on non-sockets!\n");
		result = -1;
	}
	return result;
}

unsigned int sleep(unsigned int t)
{
	Sleep(t*1000);
	return 0;
}

#define NT_FLOCK_SH 1
#define NT_FLOCK_EX 2
#define NT_FLOCK_NB 4
#define NT_FLOCK_UN 8
const DWORD lockLength = 0xffff0000;

int CPerlFlock(CPerl *pPerl, int fd, int operation, int& err)
{	// simulate flock by locking a range on the file
	if(pPerl->IsWinNT());
	else
	{
		if(pPerl->IsWin95())
		{
			pPerl->CROAK("flock() is not available on Win95!\n");
			return -1;
		}
		else
		{
			pPerl->CROAK("flock() is not available on Win32s!\n");
			return -1;
		}
	}

	OVERLAPPED o;
	int i = -1;
	HANDLE hFile = (HANDLE)pPerl->GetpVtbl()->GetOSfhandle(fd);
	memset(&o, 0, sizeof(o));
	switch(operation) 
	{
		case NT_FLOCK_SH:	// shared lock
			if(LockFileEx(hFile, 0, 0, lockLength, 0, &o))
				i = 0;
			else
				err = GetLastError();
			break;

		case NT_FLOCK_EX:	// exclusive lock
			if(LockFileEx(hFile, LOCKFILE_EXCLUSIVE_LOCK, 0, lockLength, 0, &o))
				i = 0;
			else
				err = GetLastError();
			break;

		case NT_FLOCK_SH|NT_FLOCK_NB:	// non-blocking shared lock
			if(LockFileEx(hFile, LOCKFILE_FAIL_IMMEDIATELY, 0, lockLength, 0, &o))
				i = 0;
			else
				err = GetLastError();
			break;

		case NT_FLOCK_EX|NT_FLOCK_NB:	// non-blocking exclusive lock
			if(LockFileEx(hFile, LOCKFILE_EXCLUSIVE_LOCK|LOCKFILE_FAIL_IMMEDIATELY, 0, lockLength, 0, &o))
				i = 0;
			else
				err = GetLastError();
			break;

		case NT_FLOCK_UN:	// unlock lock
			if(UnlockFileEx(hFile, 0, lockLength, 0, &o))
				i = 0;
			else
				err = GetLastError();
			break;

		default:	// unknown
			err = EINVAL;
			break;
    }
	return i;
}

int NtKill(int pid, int sig)
{
	int nRet = -1;
	HANDLE hProcess;

	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, (DWORD)pid);
	if(hProcess != NULL)
	{
		if(TerminateProcess(hProcess, 0) == FALSE)
			nRet = 0;

		CloseHandle(hProcess);
	}

	return nRet;
}
