// NT.H

// (c) 1995 Microsoft Corporation. All rights reserved. 
//	Developed by ActiveWare Internet Corp., http://www.ActiveWare.com

//    You may distribute under the terms of either the GNU General Public
//    License or the Artistic License, as specified in the README file.

#ifndef  _INC_NT_PERL5
#define  _INC_NT_PERL5

#include "build.h"

#define NT_PERL_VERSION_NUMBER "Build "##NT_BUILD_NUMBER
#define WINDOWS_NT_PERL_VERSION "\n\nPerl for Win32 "##NT_PERL_VERSION_NUMBER
#define WINDOWS_NT_PERL_VERSION_STRING "\n\tWin32 port Copyright (c) 1995-1996 Microsoft Corporation.\n\t\tAll rights reserved.\n\
\tDeveloped by ActiveWare Internet Corp., http://www.ActiveWare.com"##WINDOWS_NT_PERL_VERSION##\
" - Built "##__TIME__##" "##__DATE__##"\n"

#ifdef   WIN32_LEAN_AND_MEAN		// C file is NOT a Perl5 original.

#define  CONTEXT	PERL_CONTEXT	// Avoid conflict of CONTEXT defs.

#define  index		strchr			// Why 'index'?

#endif //WIN32_LEAN_AND_MEAN

#include <direct.h>
#include <io.h>
#include <process.h>
#include <stdio.h>

void NTInit(CPERLarg);
void NTLibInit(CPERLarg);
void Win32OLEInit(CPERLarg);
void* LibraryLoad(char*);

// extern int myrename(char *OldFileName, char *newname);
extern int CPerlFlock(CPerl *pPerl, int fd, int operation, int& err);

// #undef rename
// #define rename myrename

// For UNIX compatibility.

typedef long		uid_t;
typedef long		gid_t;

extern  uid_t	getuid(void);
extern  gid_t	getgid(void);
extern  uid_t	geteuid(void);
extern  gid_t	getegid(void);

extern  int	setuid(uid_t uid);
extern  int	setgid(gid_t gid);

#define USE_SOCKETS_AS_HANDLES
#ifndef USE_SOCKETS_AS_HANDLES
extern FILE *myfdopen(int, char *);

#undef fdopen
#define fdopen myfdopen
#endif	// USE_SOCKETS_AS_HANDLES

#define crypt NtCrypt
#define kill NtKill

int NtKill(int pid, int sig);
int NtIsSocket( int fd );
char * NtCrypt(char*pText, char*pSalt);
char * NtGetBin(void);
char * NtGetArchLib(void);
char * NtGetSiteLib(void);
char * NtGetLib(void);
char * NtGetDebugScriptStr(void);
void NtGetPerlRegStr(CPERLarg_ char *lpszValueName, char *lpszDefault, char *lpszData, unsigned long *lpdwDataLen);

void QSortCv(CPerl *pPerl, void *base, size_t max, size_t width);
void QSortCmp(CPerl *pPerl, void *base, size_t max, size_t width);

// int do_aspawn(SV* really, SV** mark, SV** arglast);
int do_aspawn(void* really, void** mark, void** arglast); // since SV is not defined yet
int do_spawn(char *cmd);

#define  STANDARD_C	1		// Perl5 likes standard C.
#define  DOSISH		1		// Take advantage of DOSish code in Perl5.

#define  OP_BINARY	_O_BINARY	// Mistake in in pp_sys.c.

// #undef   mkdir
// #define  mkdir(nm, md)	_mkdir(nm)	// For UNIX compatibility.

unsigned int sleep(unsigned int);

typedef  char *		caddr_t;	// In malloc.c (core address).

#pragma  warning(disable: 4018 4035 4101 4102 4244 4245 4761)

#define HAS_IOCTL				// Well, we'll fake it for sockets.

#endif // _INC_NT_PERL5
