// NTXS.cpp

// (c) 1995 Microsoft Corporation. All rights reserved. 
//	Developed by ActiveWare Internet Corp., http://www.ActiveWare.com

// Portions Copyright 1995 Honeywell Inc.
// by Dean.Troyer@AZ.Honeywell.COM

//    You may distribute under the terms of either the GNU General Public
//    License or the Artistic License, as specified in the README file.



#include <windows.h>
#include <winnt.h>
#define WIN32_LEAN_AND_MEAN

#include "EXTERN.h"
#include "perl.h"
#include "XSub.h"

#define CROAK croak
#define newXSInternal    pPerl->Perl_newXS

#define TMPBUFSZ 1024

#define SUCCESSRETURNED(x)	(x == ERROR_SUCCESS)
#define REGRETURN(x) XSRETURN_IV(SUCCESSRETURNED(x))


#define SETIV(index,value) sv_setiv(ST(index), value)
#define SETPV(index,string) sv_setpv(ST(index), string)
#define SETPVN(index, buffer, length) sv_setpvn(ST(index), (char*)buffer, length)
#define SETHKEY(index, hkey)	SETIV(index,(long)hkey)

#define NEW(x,v,n,t)  (v = (t*)safemalloc((MEM_SIZE)((n) * sizeof(t))))
#define SvHKEY(index) (HKEY)((unsigned long)SvIV(index))

#define PERLADVAPI WINAPI

static HINSTANCE hAdvApiLib = NULL;
extern CRITICAL_SECTION csADVAPI;

// functions from advapi.dll
// Event Logging
typedef BOOL (PERLADVAPI *LPBackupEventLog)(HANDLE, LPCSTR);	
typedef BOOL (PERLADVAPI *LPClearEventLog)(HANDLE, LPCSTR);
typedef BOOL (PERLADVAPI *LPCloseEventLog)(HANDLE);
typedef BOOL (PERLADVAPI *LPDeregisterEventSource)(HANDLE);
typedef BOOL (PERLADVAPI *LPGetNumberOfEventLogRecords)(HANDLE, PDWORD);
typedef BOOL (PERLADVAPI *LPGetUserName)(LPSTR, LPDWORD);
typedef BOOL (PERLADVAPI *LPIsValidSid)(PSID);
typedef BOOL (PERLADVAPI *LPLookupAccountName)(LPCSTR, LPCSTR, PSID, LPDWORD, LPSTR, LPDWORD, PSID_NAME_USE);
typedef BOOL (PERLADVAPI *LPLookupAccountSid)(LPCSTR, PSID, LPSTR, LPDWORD, LPSTR, LPDWORD, PSID_NAME_USE);
typedef HANDLE (PERLADVAPI *LPOpenBackupEventLog)(LPCSTR, LPCSTR);
typedef HANDLE (PERLADVAPI *LPOpenEventLog)(LPCSTR, LPCSTR);
typedef BOOL (PERLADVAPI *LPReadEventLog)(HANDLE, DWORD, DWORD, LPVOID, DWORD, DWORD*, DWORD*);
typedef HANDLE (PERLADVAPI *LPRegisterEventSource)(LPCSTR, LPCSTR);
typedef BOOL (PERLADVAPI *LPReportEvent)(HANDLE, unsigned short, unsigned short, DWORD, PSID, unsigned short, DWORD, LPCSTR*, LPVOID);

// Registry Functions
typedef LONG (PERLADVAPI *LPRegCloseKey)(HKEY);
typedef LONG (PERLADVAPI *LPRegConnectRegistry)(LPSTR, HKEY, PHKEY);
typedef LONG (PERLADVAPI *LPRegCreateKeyEx)(HKEY, LPCSTR, DWORD, LPSTR, DWORD, REGSAM, LPSECURITY_ATTRIBUTES, PHKEY, LPDWORD);
typedef LONG (PERLADVAPI *LPRegDeleteKey)(HKEY, LPCSTR);
typedef LONG (PERLADVAPI *LPRegDeleteValue)(HKEY, LPCSTR);
typedef LONG (PERLADVAPI *LPRegEnumKey)(HKEY, DWORD, LPSTR, DWORD);
typedef LONG (PERLADVAPI *LPRegEnumKeyEx)(HKEY, DWORD, LPSTR, LPDWORD, LPDWORD, LPSTR, LPDWORD, PFILETIME);
typedef LONG (PERLADVAPI *LPRegEnumValue)(HKEY, DWORD, LPSTR, LPDWORD, LPDWORD, LPDWORD, LPBYTE, LPDWORD);
typedef LONG (PERLADVAPI *LPRegFlushKey)(HKEY);
typedef LONG (PERLADVAPI *LPRegGetKeySecurity)(HKEY, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, LPDWORD);
typedef LONG (PERLADVAPI *LPRegLoadKey)(HKEY, LPCSTR, LPCSTR);
typedef LONG (PERLADVAPI *LPRegOpenKey)(HKEY, LPCSTR, PHKEY);
typedef LONG (PERLADVAPI *LPRegOpenKeyEx)(HKEY, LPCSTR, DWORD, REGSAM, PHKEY);
typedef LONG (PERLADVAPI *LPRegQueryInfoKey)(HKEY, LPSTR, LPDWORD, LPDWORD, LPDWORD, LPDWORD,
												LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, PFILETIME);
typedef LONG (PERLADVAPI *LPRegQueryValue)(HKEY, LPCSTR, LPSTR, PLONG);
typedef LONG (PERLADVAPI *LPRegQueryValueEx)(HKEY, LPSTR, LPDWORD, LPDWORD, LPBYTE, LPDWORD);
typedef LONG (PERLADVAPI *LPRegReplaceKey)(HKEY, LPCSTR, LPCSTR, LPCSTR);
typedef LONG (PERLADVAPI *LPRegRestoreKey)(HKEY, LPCSTR, DWORD);
typedef LONG (PERLADVAPI *LPRegSaveKey)(HKEY, LPCSTR, LPSECURITY_ATTRIBUTES);
typedef LONG (PERLADVAPI *LPRegSetKeySecurity)(HKEY, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
typedef LONG (PERLADVAPI *LPRegSetValue)(HKEY, LPCSTR, DWORD, LPCSTR, DWORD);
typedef LONG (PERLADVAPI *LPRegSetValueEx)(HKEY, LPCSTR, DWORD, DWORD, CONST BYTE*, DWORD);
typedef LONG (PERLADVAPI *LPRegUnLoadKey)(HKEY, LPCSTR);

// Admin Functions
typedef BOOL (PERLADVAPI *LPInitiateSystemShutdown)(LPSTR, LPSTR, DWORD, BOOL, BOOL);
typedef BOOL (PERLADVAPI *LPAbortSystemShutdown)(LPSTR);
typedef BOOL (PERLADVAPI *LPOpenProcessToken)(HANDLE, DWORD, PHANDLE);
typedef BOOL (PERLADVAPI *LPLookupPrivilegeValue)(LPCSTR, LPCSTR, PLUID);
typedef BOOL (PERLADVAPI *LPAdjustTokenPrivileges)(HANDLE, BOOL, PTOKEN_PRIVILEGES, DWORD, PTOKEN_PRIVILEGES, PDWORD);

// Event Logging
static LPBackupEventLog pBackupEventLog = 0;
static LPClearEventLog pClearEventLog = 0;
static LPCloseEventLog pCloseEventLog = 0;
static LPDeregisterEventSource pDeregisterEventSource = 0;
static LPGetNumberOfEventLogRecords pGetNumberOfEventLogRecords = 0;
static LPGetUserName pGetUserName = 0;
static LPIsValidSid pIsValidSid = 0;
static LPLookupAccountName pLookupAccountName = 0;
static LPLookupAccountSid pLookupAccountSid = 0;
static LPOpenBackupEventLog pOpenBackupEventLog = 0;
static LPOpenEventLog pOpenEventLog = 0;
static LPReadEventLog pReadEventLog = 0;
static LPRegisterEventSource pRegisterEventSource = 0;
static LPReportEvent pReportEvent = 0;

// Registry Functions
static LPRegCloseKey pRegCloseKey = 0;
static LPRegConnectRegistry pRegConnectRegistry = 0;
static LPRegCreateKeyEx pRegCreateKeyEx = 0;
static LPRegDeleteKey pRegDeleteKey = 0;
static LPRegDeleteValue pRegDeleteValue = 0;
static LPRegEnumKey pRegEnumKey = 0;
static LPRegEnumKeyEx pRegEnumKeyEx = 0;
static LPRegEnumValue pRegEnumValue = 0;
static LPRegFlushKey pRegFlushKey = 0;
static LPRegGetKeySecurity pRegGetKeySecurity = 0;
static LPRegLoadKey pRegLoadKey = 0;
static LPRegOpenKey pRegOpenKey = 0;
static LPRegOpenKeyEx pRegOpenKeyEx = 0;
static LPRegQueryInfoKey pRegQueryInfoKey = 0;
static LPRegQueryValue pRegQueryValue = 0;
static LPRegQueryValueEx pRegQueryValueEx = 0;
static LPRegReplaceKey pRegReplaceKey = 0;
static LPRegRestoreKey pRegRestoreKey = 0;
static LPRegSaveKey pRegSaveKey = 0;
static LPRegSetKeySecurity pRegSetKeySecurity = 0;
static LPRegSetValue pRegSetValue = 0;
static LPRegSetValueEx pRegSetValueEx = 0;
static LPRegUnLoadKey pRegUnLoadKey = 0;

// Admin Functions
static LPInitiateSystemShutdown pInitiateSystemShutdown = 0;
static LPAbortSystemShutdown pAbortSystemShutdown = 0;
static LPOpenProcessToken pOpenProcessToken = 0;
static LPLookupPrivilegeValue pLookupPrivilegeValue = 0;
static LPAdjustTokenPrivileges pAdjustTokenPrivileges = 0;

static FARPROC GetAdvApiAddress(CPerl *pPerl, HINSTANCE hInstance, char *lpFunctionName)
{
	char buffer[512];
	FARPROC proc = GetProcAddress(hInstance, lpFunctionName);
	if(proc == 0)
	{
		sprintf(buffer, "Unable to get address of %s in ADVAPI.DLL", lpFunctionName);
		CROAK(buffer);
	}
	return proc;
}


void AdvApiStartup(CPerl *pPerl)
{
	EnterCriticalSection(&csADVAPI);
	if(hAdvApiLib == NULL)
	{
		HINSTANCE hLib = LoadLibrary("ADVAPI32.DLL");
		if(hLib == NULL)
			CROAK("Could not load ADVAPI32.dll\n");

		// Event Logging
		pBackupEventLog = (LPBackupEventLog)GetAdvApiAddress(pPerl, hLib, "BackupEventLogA");
		pClearEventLog = (LPClearEventLog)GetAdvApiAddress(pPerl, hLib, "ClearEventLogA");
		pCloseEventLog = (LPCloseEventLog)GetAdvApiAddress(pPerl, hLib, "CloseEventLog");
		pDeregisterEventSource = (LPDeregisterEventSource)GetAdvApiAddress(pPerl, hLib, "DeregisterEventSource");
		pGetNumberOfEventLogRecords = (LPGetNumberOfEventLogRecords)GetAdvApiAddress(pPerl, hLib, "GetNumberOfEventLogRecords");
		pGetUserName = (LPGetUserName)GetAdvApiAddress(pPerl, hLib, "GetUserNameA");
		pIsValidSid = (LPIsValidSid)GetAdvApiAddress(pPerl, hLib, "IsValidSid");
		pLookupAccountName = (LPLookupAccountName)GetAdvApiAddress(pPerl, hLib, "LookupAccountNameA");
		pLookupAccountSid = (LPLookupAccountSid)GetAdvApiAddress(pPerl, hLib, "LookupAccountSidA");
		pOpenBackupEventLog = (LPOpenBackupEventLog)GetAdvApiAddress(pPerl, hLib, "OpenBackupEventLogA");
		pOpenEventLog = (LPOpenEventLog)GetAdvApiAddress(pPerl, hLib, "OpenEventLogA");
		pReadEventLog = (LPReadEventLog)GetAdvApiAddress(pPerl, hLib, "ReadEventLogA");
		pRegisterEventSource = (LPRegisterEventSource)GetAdvApiAddress(pPerl, hLib, "RegisterEventSourceA");
		pReportEvent = (LPReportEvent)GetAdvApiAddress(pPerl, hLib, "ReportEventA");

		// Registry Functions
		pRegCloseKey = (LPRegCloseKey)GetAdvApiAddress(pPerl, hLib, "RegCloseKey");
		pRegConnectRegistry = (LPRegConnectRegistry)GetAdvApiAddress(pPerl, hLib, "RegConnectRegistryA");
		pRegCreateKeyEx = (LPRegCreateKeyEx)GetAdvApiAddress(pPerl, hLib, "RegCreateKeyExA");
		pRegDeleteKey = (LPRegDeleteKey)GetAdvApiAddress(pPerl, hLib, "RegDeleteKeyA");
		pRegDeleteValue = (LPRegDeleteValue)GetAdvApiAddress(pPerl, hLib, "RegDeleteValueA");
		pRegEnumKey = (LPRegEnumKey)GetAdvApiAddress(pPerl, hLib, "RegEnumKeyA");
		pRegEnumKeyEx = (LPRegEnumKeyEx)GetAdvApiAddress(pPerl, hLib, "RegEnumKeyExA");
		pRegEnumValue = (LPRegEnumValue)GetAdvApiAddress(pPerl, hLib, "RegEnumValueA");
		pRegFlushKey = (LPRegFlushKey)GetAdvApiAddress(pPerl, hLib, "RegFlushKey");
		pRegGetKeySecurity = (LPRegGetKeySecurity)GetAdvApiAddress(pPerl, hLib, "RegGetKeySecurity");
		pRegLoadKey = (LPRegLoadKey)GetAdvApiAddress(pPerl, hLib, "RegLoadKeyA");
		pRegOpenKey = (LPRegOpenKey)GetAdvApiAddress(pPerl, hLib, "RegOpenKeyA");
		pRegOpenKeyEx = (LPRegOpenKeyEx)GetAdvApiAddress(pPerl, hLib, "RegOpenKeyExA");
		pRegQueryInfoKey = (LPRegQueryInfoKey)GetAdvApiAddress(pPerl, hLib, "RegQueryInfoKeyA");
		pRegQueryValue = (LPRegQueryValue)GetAdvApiAddress(pPerl, hLib, "RegQueryValueA");
		pRegQueryValueEx = (LPRegQueryValueEx)GetAdvApiAddress(pPerl, hLib, "RegQueryValueExA");
		pRegReplaceKey = (LPRegReplaceKey)GetAdvApiAddress(pPerl, hLib, "RegReplaceKeyA");
		pRegRestoreKey = (LPRegRestoreKey)GetAdvApiAddress(pPerl, hLib, "RegRestoreKeyA");
		pRegSaveKey = (LPRegSaveKey)GetAdvApiAddress(pPerl, hLib, "RegSaveKeyA");
		pRegSetKeySecurity = (LPRegSetKeySecurity)GetAdvApiAddress(pPerl, hLib, "RegSetKeySecurity");
		pRegSetValue = (LPRegSetValue)GetAdvApiAddress(pPerl, hLib, "RegSetValueA");
		pRegSetValueEx = (LPRegSetValueEx)GetAdvApiAddress(pPerl, hLib, "RegSetValueExA");
		pRegUnLoadKey = (LPRegUnLoadKey)GetAdvApiAddress(pPerl, hLib, "RegUnLoadKeyA");

		// Admin Functions
		pInitiateSystemShutdown = (LPInitiateSystemShutdown)GetAdvApiAddress(pPerl, hLib, "InitiateSystemShutdownA");
		pAbortSystemShutdown = (LPAbortSystemShutdown)GetAdvApiAddress(pPerl, hLib, "AbortSystemShutdownA");
		pOpenProcessToken = (LPOpenProcessToken)GetAdvApiAddress(pPerl, hLib, "OpenProcessToken");
		pLookupPrivilegeValue = (LPLookupPrivilegeValue)GetAdvApiAddress(pPerl, hLib, "LookupPrivilegeValueA");
		pAdjustTokenPrivileges = (LPAdjustTokenPrivileges)GetAdvApiAddress(pPerl, hLib, "AdjustTokenPrivileges");

		hAdvApiLib = hLib;
	}
	LeaveCriticalSection(&csADVAPI);
}

void __cdecl NTADVAPICleanUp(void)
{
	if(hAdvApiLib != NULL)
	{
		FreeLibrary(hAdvApiLib);
		hAdvApiLib = NULL;
	}
}

#define ADVAPISTARTUP if(hAdvApiLib == 0) AdvApiStartup(pPerl)

static time_t ft2timet(FILETIME *ft)
{
	SYSTEMTIME st;
	struct tm tm;

	FileTimeToSystemTime(ft, &st);
	tm.tm_sec = st.wSecond;
	tm.tm_min = st.wMinute;
	tm.tm_hour = st.wHour;
	tm.tm_mday = st.wDay;
	tm.tm_mon = st.wMonth - 1;
	tm.tm_year = st.wYear - 1900;
	tm.tm_wday = st.wDayOfWeek;
	tm.tm_yday = -1;
	tm.tm_isdst = -1;
	return mktime (&tm);
}


static char NTLoginNameStr[128];
static char NTDomainNameStr[128];
static char NTNodeNameStr[128];

static char thisFile[] = __FILE__;
static char unknown[] = "<Unknown>";

static void GetLoginName(CPerl *pPerl)
{
	unsigned long len;

	ADVAPISTARTUP;
	len = sizeof(NTLoginNameStr);
	if(!pGetUserName(NTLoginNameStr, &len)) 
	{
		strcpy(NTLoginNameStr, unknown);
	}
}

#undef getlogin
#define getlogin CPerl::getlogin

char *getlogin()
{
	if(*NTLoginNameStr == '\0') 
		GetLoginName(this);

	return NTLoginNameStr;
}

// Registry access stuff
#ifdef PRIVATE_PERL
#define PERL_REGISTRY_KEY "SOFTWARE\\ActiveWare\\Private\\Perl5"
#else
#define PERL_REGISTRY_KEY "SOFTWARE\\ActiveWare\\Perl5"
#endif

BOOL NtGetRegStr(HKEY hkey, char *lpszValueName, char *lpszDefault, char *lpszData, unsigned long *lpdwDataLen)
{	// Retrieve a REG_SZ or REG_EXPAND_SZ from the registry
	HKEY handle;
	DWORD type, dwDataLen = *lpdwDataLen;
	char *subkey = PERL_REGISTRY_KEY;
	char szBuffer[MAX_PATH+1];
	long retval;

	retval = pRegOpenKeyEx(hkey, subkey, 0, KEY_READ, &handle);
	if(retval == ERROR_SUCCESS) 
	{
		retval = pRegQueryValueEx(handle, lpszValueName, 0, &type, (LPBYTE)lpszData, &dwDataLen);
		pRegCloseKey(handle);
		if(retval == ERROR_SUCCESS && (type == REG_SZ || type == REG_EXPAND_SZ))
		{
			if(type != REG_EXPAND_SZ)
			{
				*lpdwDataLen = dwDataLen;
				return TRUE;
			}
			strcpy(szBuffer, lpszData);
			dwDataLen = ExpandEnvironmentStrings(szBuffer, lpszData, *lpdwDataLen);
			if(dwDataLen < *lpdwDataLen)
			{
				*lpdwDataLen = dwDataLen;
				return TRUE;
			}
		}
	}

	strcpy(lpszData, lpszDefault);
	return FALSE;
}

void NtGetPerlRegStr(CPerl *pPerl, char *lpszValueName, char *lpszDefault, char *lpszData, unsigned long *lpdwDataLen)
{
	ADVAPISTARTUP;
	if(!NtGetRegStr(HKEY_CURRENT_USER, lpszValueName, lpszDefault, lpszData, lpdwDataLen))
	{
		NtGetRegStr(HKEY_LOCAL_MACHINE, lpszValueName, lpszDefault, lpszData, lpdwDataLen);
	}
}

XS(NTExpandEnvironmentStrings)
{
	dXSARGS;
	char *lpSource;
	char buffer[2048];
	DWORD dwDataLen;

	if(items != 1) 
	{
		CROAK("usage: Win32::ExpandEnvironmentStrings($String);\n");
	}
	lpSource = (char *)SvPV(ST(0), na);
	dwDataLen = ExpandEnvironmentStrings(lpSource, buffer, sizeof(buffer));

	XSRETURN_PV(buffer);
}

XS(NTPerlVersion) // DEPRECIATED!! DON'T USE!
{
	dXSARGS;
	XSRETURN_PV(NT_PERL_VERSION_NUMBER);
}

XS(NTBuildNumber)
{
	dXSARGS;
	XSRETURN_PV(NT_BUILD_NUMBER);
}

XS(NTGetLastError)
{
	dXSARGS;
	XSRETURN_IV(GetLastError());
}

XS(NTLoginName)
{
	dXSARGS;
	if(*NTLoginNameStr == '\0')
		GetLoginName(pPerl);

	XSRETURN_PV(NTLoginNameStr);
}

XS(NTNodeName)
{
	dXSARGS;
	if(*NTNodeNameStr == '\0')
	{
		unsigned long len;
		len = sizeof(NTNodeNameStr);
		if(!GetComputerName(NTNodeNameStr, &len)) 
		{
			strcpy(NTNodeNameStr, unknown);
		}
	}

	XSRETURN_PV(NTNodeNameStr);
}

XS(NTDomainName)
{
	dXSARGS;
	char SID[400];
	DWORD SIDLen;
	SID_NAME_USE snu;

	ADVAPISTARTUP;
	if(*NTDomainNameStr == '\0')
	{
		char buffer[TMPBUFSZ];
		unsigned long len;
		len = sizeof(NTDomainNameStr);

		if(*NTLoginNameStr == '\0')
			GetLoginName(pPerl);

		SIDLen = sizeof(SID);
		if(!pLookupAccountName(NULL,		// System (NULL = local)
							NTLoginNameStr,	// Account name
							&SID,			// SID structure
							&SIDLen,		// Size of SID buffer
							NTDomainNameStr,// Domain buffer
							&len,			// Domain buffer size
							&snu))			// SID name type
		{
			strcpy(NTDomainNameStr, unknown);
		}
	}

	XSRETURN_PV(NTDomainNameStr);
}

XS(NTFsType)
{
	dXSARGS;
	DWORD flags, fsnamelen;
	char buffer[TMPBUFSZ];

	if(!GetVolumeInformation(NULL, NULL, 0, NULL, &fsnamelen, &flags, buffer, sizeof(buffer)))
		strcpy(buffer, unknown);

	XSRETURN_PV(buffer);
}

XS(NTGetCwd)
{
	dXSARGS;
	char buffer[TMPBUFSZ];

	if(pPerl->GetpVtbl()->GetCWD(buffer, sizeof(buffer)) == 0)
		strcpy(buffer, unknown);

	XSRETURN_PV(buffer);
}

XS(NTSetCwd)
{
	dXSARGS;
	char *lpSource;

	if(items != 1) 
	{
		CROAK("usage: Win32::SetCwd($String);\n");
	}
	lpSource = (char *)SvPV(ST(0), na);

	XSRETURN_IV(pPerl->GetpVtbl()->SetCWD(lpSource));
}

XS(NTGetArch)
{
	dXSARGS;
	XSRETURN_PV(getenv("PROCESSOR_ARCHITECTURE"));
}

XS(NTGetChipName)
{
	dXSARGS;
	SYSTEM_INFO	sysinfo;
	memset(&sysinfo,0,sizeof(SYSTEM_INFO));
	GetSystemInfo(&sysinfo);

	XSRETURN_IV(sysinfo.dwProcessorType);
}

XS(NTGetVersion)
{
	dSP;
	OSVERSIONINFO osver;

	memset(&osver, 0, sizeof(OSVERSIONINFO));
	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osver);

	PUSHMARK(sp);
	XPUSHs(newSVpv(osver.szCSDVersion, strlen(osver.szCSDVersion)));
	XPUSHs(newSViv(osver.dwMajorVersion));
	XPUSHs(newSViv(osver.dwMinorVersion));
	XPUSHs(newSViv(osver.dwBuildNumber));
	XPUSHs(newSViv(osver.dwPlatformId));
	PUTBACK;
}

XS(NTFormatMessage)
{
	dXSARGS;
	char buffer[TMPBUFSZ];
	int nError;
	DWORD source = 0;

	if(items != 1) 
	{
		CROAK("usage: Win32::FormatMessage($errorCode);\n");
	}
	nError = SvIV(ST(0));
	if(FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, &source, nError, 0, buffer, sizeof(buffer), NULL) == 0)
		strcmp(buffer, "<Unknown error code>");

	XSRETURN_PV(buffer);
}

XS(NTRegCloseKey)
{
	dXSARGS;

	if(items != 1) 
	{
		CROAK("usage: Win32::RegCloseKey($hkey);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegCloseKey(SvHKEY(ST(0))));
}

XS(NTRegConnectRegistry)
{
	dXSARGS;
	HKEY handle;

	if(items != 3) 
	{
		CROAK("usage: Win32::RegConnectRegistry($machine, $hkey, $handle);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegConnectRegistry((char *)SvPV(ST(0), na), SvHKEY(ST(1)), &handle))) 
	{
		SETHKEY(2,handle);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegCreateKey)
{
	dXSARGS;
	HKEY handle;
	DWORD disposition;
	long retval;

	if(items != 3) 
	{
		CROAK("usage: Win32::RegCreateKey($hkey, $subkey, $handle);\n");
	}


	ADVAPISTARTUP;
	retval =  pRegCreateKeyEx(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
						NULL, &handle, &disposition);

	if(SUCCESSRETURNED(retval)) 
	{
		SETHKEY(2,handle);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegCreateKeyEx)
{
	dXSARGS;

	unsigned int length;
	long retval;
	HKEY hkey, handle;
	char *subkey;
	char *keyclass;
	DWORD options, disposition;
	REGSAM sam;
	SECURITY_ATTRIBUTES sa, *psa;

	if(items != 9) 
	{
		CROAK("usage: Win32::RegCreateKeyEx($hkey, $subkey, $reserved, $class, $options, $sam, "
				"$security, $handle, $disposition);\n");
	}

	ADVAPISTARTUP;
	hkey = SvHKEY(ST(0));
	subkey = (char *)SvPV(ST(1), na);
	keyclass = (char *)SvPV(ST(3), na);
	options = (DWORD) ((unsigned long)SvIV(ST(4)));
	sam = (REGSAM) ((unsigned long)SvIV(ST(5)));
	psa = (SECURITY_ATTRIBUTES*)SvPV(ST(6), length);
	if(length != sizeof(SECURITY_ATTRIBUTES))
	{
		psa = &sa;
		memset(&sa, 0, sizeof(SECURITY_ATTRIBUTES));
		sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	}

	retval =  pRegCreateKeyEx(hkey, subkey, 0, keyclass, options, sam,
						psa, &handle, &disposition);

	if(SUCCESSRETURNED(retval)) 
	{
		if(psa == &sa)
			SETPVN(6, &sa, sizeof(sa));

		SETHKEY(7,handle);
		SETIV(8,disposition);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegDeleteKey)
{
	dXSARGS;

	if(items != 2) 
	{
		CROAK("usage: Win32::RegDeleteKey($hkey, $subkey);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegDeleteKey(SvHKEY(ST(0)), (char *)SvPV(ST(1), na)));
}

XS(NTRegDeleteValue)
{
	dXSARGS;

	if(items != 2) 
	{
		CROAK("usage: Win32::RegDeleteValue($hkey, $valname);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegDeleteValue(SvHKEY(ST(0)), (char *)SvPV(ST(1), na)));
}

XS(NTRegEnumKey)
{
	dXSARGS;

	char keybuffer[TMPBUFSZ];

	if(items != 3) 
	{
		CROAK("usage: Win32::RegEnumKey($hkey, $idx, $subkeyname);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegEnumKey(SvHKEY(ST(0)), SvIV(ST(1)), keybuffer, sizeof(keybuffer)))) 
	{
		SETPV(2, keybuffer);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegEnumKeyEx)
{
	dXSARGS;
	int length;

	DWORD keysz, classsz;
	char keybuffer[TMPBUFSZ];
	char classbuffer[TMPBUFSZ];
	long retval;
	FILETIME filetime;

	if(items != 6) 			
	{
		CROAK("usage: Win32::RegEnumKeyEx($hkey, $idx, $subkeyname, $reserved, $class, $time);\n");
	}

	ADVAPISTARTUP;
	keysz = sizeof(keybuffer);
	classsz = sizeof(classbuffer);
	retval = pRegEnumKeyEx(SvHKEY(ST(0)), SvIV(ST(1)), keybuffer, &keysz, 0,
							classbuffer, &classsz, &filetime);
	if(SUCCESSRETURNED(retval)) 
	{
		SETPV(2, keybuffer);
		SETPV(4, classbuffer);
		SETIV(5, ft2timet(&filetime));
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegEnumValue)
{
	dXSARGS;
	HKEY hkey;
	DWORD type, namesz, valsz;
	long retval;

	if(items != 6) 
	{
		CROAK("usage: Win32::RegEnumValue($hkey, $i, $name, $reserved, $type, $value);\n");
	}

	ADVAPISTARTUP;
	hkey = SvHKEY(ST(0));

	// If this is a new key, find out how big the maximum name and value sizes are and
	// allocate space for them. Free any old storage and set the old key value to the
	// current key.

	if(hkey != (HKEY)last_hkey) 
	{
		char keyclass[TMPBUFSZ];
		DWORD classsz, subkeys, maxsubkey, maxclass, values, salen;
		FILETIME ft;
		classsz = sizeof(keyclass);
		retval = pRegQueryInfoKey(hkey, keyclass, &classsz, 0, &subkeys, &maxsubkey, &maxclass,
							&values, &maxnamesz, &maxvalsz, &salen, &ft);

		if(!SUCCESSRETURNED(retval)) 
		{
			XSRETURN_NO;
		}
		if(valbuf)
			Safefree(valbuf);

		NEW(1903, valbuf, ++maxvalsz, char);

		if(namebuf)
			Safefree(namebuf);

		NEW(1903, namebuf, ++maxnamesz, char);
		last_hkey = hkey;
	}

	namesz = maxnamesz;
	valsz = maxvalsz;
	retval = pRegEnumValue(hkey, SvIV(ST(1)), namebuf, &namesz, 0, &type, (LPBYTE) valbuf, &valsz);
	if(!SUCCESSRETURNED(retval)) 
	{
		XSRETURN_NO;
	}
	else 
	{
		// return includes the null terminator so delete it if REG_SZ, REG_MULTI_SZ or REG_EXPAND_SZ
		switch(type)
		{
			case REG_SZ:
			case REG_MULTI_SZ:
			case REG_EXPAND_SZ:
				if(valsz)
					--valsz;
				break;

			default:
				break;
		}

		SETPV(2, namebuf);
		SETIV(4, type);
		SETPVN(5, valbuf, valsz);
		XSRETURN_YES;
	}
}

XS(NTRegFlushKey)
{
	dXSARGS;

	if(items != 1) 
	{
		CROAK("usage: Win32::RegFlushKey($hkey);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegFlushKey(SvHKEY(ST(0))));
}

XS(NTRegGetKeySecurity)
{
	dXSARGS;
	SECURITY_DESCRIPTOR sd;
	DWORD sdsz;

	if(items != 3) 
	{
		CROAK("usage: Win32::RegGetKeySecurity($hkey, $security_info, $security_descriptor);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegGetKeySecurity(SvHKEY(ST(0)), SvIV(ST(1)), &sd, &sdsz))) 
	{
		SETPVN(2, &sd, sdsz);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}


XS(NTRegLoadKey)
{
	dXSARGS;

	if(items != 3) 
	{
		CROAK("usage: Win32::RegLoadKey($hkey, $subkey, $filename);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegLoadKey(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), (char *)SvPV(ST(2), na)));
}


XS(NTRegNotifyChangeKeyValue)
{
    CROAK("Win32::RegNotifyChangeKeyValue not yet implemented!\n");
}


XS(NTRegOpenKey)
{
	dXSARGS;
	HKEY handle;

	if(items != 3) 
	{
		CROAK("usage: Win32::RegOpenKey($hkey, $subkey, $handle);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegOpenKey(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), &handle))) 
	{
		SETHKEY(2,handle);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegOpenKeyEx)
{
	dXSARGS;
	HKEY handle;

	if(items != 5) 
	{
		CROAK("usage: Win32::RegOpenKeyEx($hkey, $subkey, $reserved, $sam, $handle);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegOpenKeyEx(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), 
					0, (REGSAM) ((unsigned long)SvIV(ST(3))), &handle))) 
	{
		SETHKEY(4,handle);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

#pragma optimize("", off)
XS(NTRegQueryInfoKey)
{
	dXSARGS;
	int length;

	char keyclass[TMPBUFSZ];
	DWORD subkeys, maxsubkey, maxclass, values, maxvalname, maxvaldata;
	DWORD seclen, classsz;
	FILETIME ft;
	long retval;

	if(items != 10) 
	{
		CROAK("usage: Win32::RegQueryInfoKey($hkey, $class, $numsubkeys, $maxsubkey,"
				"$maxclass, $values, $maxvalname, $maxvaldata, $secdesclen,"
					"$lastwritetime);\n");
	}

	ADVAPISTARTUP;
	classsz = sizeof(keyclass);
	retval = pRegQueryInfoKey(SvHKEY(ST(0)), keyclass, &classsz, 0, &subkeys, &maxsubkey,
								&maxclass, &values, &maxvalname, &maxvaldata,
									&seclen, &ft);
	if(SUCCESSRETURNED(retval)) 
	{
		SETPV(1, keyclass);
		SETIV(2, subkeys);
		SETIV(3, maxsubkey);
		SETIV(4, maxclass);
		SETIV(5, values);
		SETIV(6, maxvalname);
		SETIV(7, maxvaldata);
		SETIV(8, seclen);
		SETIV(9, ft2timet(&ft));
		XSRETURN_YES;
	}
	XSRETURN_NO;
}
#pragma optimize("", on)

XS(NTRegQueryValue)
{
	dXSARGS;

	unsigned char databuffer[TMPBUFSZ*2];
	long datasz = sizeof(databuffer);

	if(items != 3) 
	{
		CROAK("usage: Win32::RegQueryValue($hkey, $valuename, $data);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegQueryValue(SvHKEY(ST(0)), SvPV(ST(1), na), (char*)databuffer, &datasz))) 
	{
		// return includes the null terminator so delete it
		SETPVN(2, databuffer, --datasz);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}

XS(NTRegQueryValueEx)
{
	dXSARGS;

	unsigned char databuffer[TMPBUFSZ*2];
	DWORD datasz = sizeof(databuffer);
	DWORD type;

	if(items != 5) 
	{
		CROAK("usage: Win32::RegQueryValueEx($hkey, $valuename, $reserved, $type, $data);\n");
	}

	ADVAPISTARTUP;
	if(SUCCESSRETURNED(pRegQueryValueEx(SvHKEY(ST(0)), SvPV(ST(1), na), 0, &type, (LPBYTE)databuffer, &datasz))) 
	{
		// return includes the null terminator so delete it if REG_SZ, REG_MULTI_SZ or REG_EXPAND_SZ
		switch(type)
		{
			case REG_SZ:
			case REG_MULTI_SZ:
			case REG_EXPAND_SZ:
				--datasz;
				break;

			default:
				break;
		}

		SETIV(3, type);
		SETPVN(4, databuffer, datasz);
		XSRETURN_YES;
	}
	XSRETURN_NO;
}


XS(NTRegReplaceKey)
{
	dXSARGS;

	if(items != 4) 
	{
		CROAK("usage: Win32::RegReplaceKey($hkey, $subkey, $newfile, $oldfile);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegReplaceKey(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), (char *)SvPV(ST(2), na), (char *)SvPV(ST(3), na)));
}

XS(NTRegRestoreKey)
{
	dXSARGS;

	if(items < 2 || items > 3) 
	{
		CROAK("usage: Win32::RegRestoreKey($hkey, $filename [, $flags]);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegRestoreKey(SvHKEY(ST(0)), (char*)SvPV(ST(1), na), (DWORD)((items == 3) ? SvIV(ST(2)) : 0)));
}

XS(NTRegSaveKey)
{
	dXSARGS;

	if(items != 2) 
	{
		CROAK("usage: Win32::RegSaveKey($hkey, $filename);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegSaveKey(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), NULL));
}

XS(NTRegSetKeySecurity)
{
	dXSARGS;

	if(items != 3) 
	{
		CROAK("usage: Win32::RegSetKeySecurity($hkey, $security_info, $security_descriptor);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegSetKeySecurity(SvHKEY(ST(0)), SvIV(ST(1)), (SECURITY_DESCRIPTOR*)SvPV(ST(2), na)));
}

XS(NTRegSetValue)
{
	dXSARGS;

	unsigned int size;
	char *buffer;

	if(items != 4) 
	{
		CROAK("usage: Win32::RegSetValue($hkey, $subKey, $type, $data);\n");
	}
	
	if(SvIV(ST(2)) != REG_SZ)
	{
		CROAK("Win32::RegSetValue: Type was not REG_SZ, cannot set %s\n", (char *)SvPV(ST(1), na));
	}

	ADVAPISTARTUP;
	buffer = (char *)SvPV(ST(3), size);
	REGRETURN(pRegSetValue(SvHKEY(ST(0)), SvPV(ST(1), na), REG_SZ, buffer, size));
}

XS(NTRegSetValueEx)
{
	dXSARGS;

	DWORD type;
	DWORD val;
	unsigned int size;
	char *buffer;

	if(items != 5) 
	{
		CROAK("usage: Win32::RegSetValueEx($hkey, $valname, $reserved, $type, $data);\n");
	}

	ADVAPISTARTUP;
	type = (DWORD)SvIV(ST(3));
	switch(type) 
	{
		case REG_SZ:
		case REG_BINARY:
		case REG_MULTI_SZ:
		case REG_EXPAND_SZ:
			buffer = (char *)SvPV(ST(4), size);
			if(type != REG_BINARY)
				size++; // include null terminator in size

			REGRETURN(pRegSetValueEx(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), 0, type, (PBYTE) buffer, size));
			break;

		case REG_DWORD_BIG_ENDIAN:
		case REG_DWORD_LITTLE_ENDIAN: // Same as REG_DWORD
			val = (DWORD)SvIV(ST(4));
			REGRETURN(pRegSetValueEx(SvHKEY(ST(0)), (char *)SvPV(ST(1), na), 0, type, (PBYTE) &val, sizeof(DWORD)));
			break;

		default:
			CROAK("Win32::RegSetValueEx: Type not specified, cannot set %s\n", (char *)SvPV(ST(1), na));
	}
}


XS(NTRegUnloadKey)
{
	dXSARGS;

	if(items != 2) 
	{
		CROAK("usage: Win32::RegUnLoadKey($hkey, $subkey);\n");
	}

	ADVAPISTARTUP;
	REGRETURN(pRegUnLoadKey(SvHKEY(ST(0)), (char *)SvPV(ST(1), na)));
}

typedef struct _EvtLogCtlBuf
{
	DWORD  dwID;					// id for mem block
	HANDLE hLog;					// event log handle
	LPBYTE BufPtr;					// pointer to data buffer
	DWORD  BufLen;					// size of buffer
	DWORD  NumEntries;				// number of entries in buffer
	DWORD  CurEntryNum;				// next entry to return
	EVENTLOGRECORD *CurEntry;		// point to next entry to return
	DWORD  Flags;					// read flags for ReadEventLog
} EvtLogCtlBuf, *lpEvtLogCtlBuf;

#define EVTLOGBUFSIZE 1024
#define EVTLOGID		((DWORD)0x674c7645L)
#define SvEvtLog(x)	(lpEvtLogCtlBuf) ((unsigned long)SvIV(x))

XS(NTOpenEventLog)
{
	dXSARGS;
	lpEvtLogCtlBuf lpEvtLog;

	if(items != 3)
	{
		CROAK("usage: Win32::OpenEventLog($handle, $server, $source);\n");
	}

	ADVAPISTARTUP;
	NEW(1908, lpEvtLog, 1, EvtLogCtlBuf);
	lpEvtLog->BufLen = EVTLOGBUFSIZE;
	NEW(1908, lpEvtLog->BufPtr, lpEvtLog->BufLen, BYTE);

	if(lpEvtLog->hLog = pOpenEventLog((char *)SvPV(ST(1), na), (char *)SvPV(ST(2), na))) 
	{
		// return info...
		lpEvtLog->dwID			= EVTLOGID;
		lpEvtLog->NumEntries	= 0;
		lpEvtLog->CurEntryNum	= 0;
		lpEvtLog->CurEntry		= NULL;
		lpEvtLog->Flags			= 0;
		SETIV(0, ((unsigned long)lpEvtLog));
		XSRETURN_YES;
	}
	else 
	{
		// Open failed...
		if(lpEvtLog->BufPtr)
			Safefree(lpEvtLog->BufPtr);
		Safefree(lpEvtLog);
		XSRETURN_NO;
	}
}

XS(NTOpenBackupEventLog)
{
	dXSARGS;
	lpEvtLogCtlBuf lpEvtLog;

	if(items != 3)
	{
		CROAK("usage: Win32::OpenBackupEventLog($handle, $server, $file);\n");
	}

	ADVAPISTARTUP;
	NEW(1908, lpEvtLog, 1, EvtLogCtlBuf);
	lpEvtLog->BufLen = EVTLOGBUFSIZE;
	NEW(1908, lpEvtLog->BufPtr, lpEvtLog->BufLen, BYTE);

	if(lpEvtLog->hLog = pOpenBackupEventLog((char *)SvPV(ST(1), na), (char *)SvPV(ST(2), na)))
	{
		// return info...
		lpEvtLog->dwID			= EVTLOGID;
		lpEvtLog->NumEntries	= 0;
		lpEvtLog->CurEntryNum	= 0;
		lpEvtLog->CurEntry		= NULL;
		lpEvtLog->Flags			= 0;
		SETIV(0, ((unsigned long)lpEvtLog));
		XSRETURN_YES;
	}
	else 
	{
		// Open failed...
		if(lpEvtLog->BufPtr)
			Safefree(lpEvtLog->BufPtr);
		Safefree(lpEvtLog);
		XSRETURN_NO;
	}
}	// NTOpenBackupEventLog

XS(NTBackupEventLog)
{
	dXSARGS;
	lpEvtLogCtlBuf lpEvtLog;

	if(items != 2)
	{
		CROAK("usage: Win32::BackupEventLog($handle, $filename);\n");
	}

	ADVAPISTARTUP;
	lpEvtLog = SvEvtLog(ST(0));
	if((lpEvtLog != NULL) && (lpEvtLog->dwID == EVTLOGID))
	{
		if(pBackupEventLog(lpEvtLog->hLog, (char *)SvPV(ST(1), na)))
		{
			XSRETURN_YES;
		}
	}
	XSRETURN_NO;
}	// NTBackupEventLog

XS(NTClearEventLog)
{
	dXSARGS;
	lpEvtLogCtlBuf lpEvtLog;

	if(items != 2)
	{
		CROAK("usage: Win32::ClearEventLog($handle, $filename);\n");
	}

	ADVAPISTARTUP;
	lpEvtLog = SvEvtLog(ST(0));
	if((lpEvtLog != NULL) && (lpEvtLog->dwID == EVTLOGID))
	{
		if(pClearEventLog(lpEvtLog->hLog, (char *)SvPV(ST(1), na)))
		{
			if(pCloseEventLog(lpEvtLog->hLog)) 
			{
				if(lpEvtLog->BufPtr)
					Safefree(lpEvtLog->BufPtr);
				Safefree(lpEvtLog);
				XSRETURN_YES;
			}
		}
	}
	XSRETURN_NO;
}	// NTClearEventLog

XS(NTCloseEventLog)
{
	dXSARGS;
	lpEvtLogCtlBuf lpEvtLog;

	if(items != 1)
	{
		CROAK("usage: Win32::CloseEventLog($handle);\n");
	}

	ADVAPISTARTUP;
	lpEvtLog = SvEvtLog(ST(0));
	if((lpEvtLog != NULL) && (lpEvtLog->dwID == EVTLOGID)) 
	{
		if(pCloseEventLog(lpEvtLog->hLog)) 
		{
			if(lpEvtLog->BufPtr)
				Safefree(lpEvtLog->BufPtr);
			Safefree(lpEvtLog);
			XSRETURN_YES;
		}
	}
	XSRETURN_NO;
}

XS(NTGetNumberOfEventLogRecords)
{
	dXSARGS;
	lpEvtLogCtlBuf lpEvtLog;
	DWORD Num;

	if(items != 2)
	{
		CROAK("usage: Win32::GetNumberOfEventLogRecords($handle, $number);\n");
	}

	ADVAPISTARTUP;
	lpEvtLog = SvEvtLog(ST(0));
	if((lpEvtLog != NULL) && (lpEvtLog->dwID == EVTLOGID)) 
	{
		if(pGetNumberOfEventLogRecords(lpEvtLog->hLog, &Num)) 
		{
			SETIV(1, Num);
			XSRETURN_YES;
		} 
	}
	XSRETURN_NO;
}

XS(NTReadEventLog)
{
	dXSARGS;
	int length;
	lpEvtLogCtlBuf lpEvtLog;

	if(items != 9)
	{
		CROAK("usage: Win32::ReadEventLog($handle, $flags, $rec, $evtHeader, $SourceName, $ComputerName, $sid, $data, $strings);\n");
	}

	ADVAPISTARTUP;
	lpEvtLog = SvEvtLog(ST(0));
	if((lpEvtLog != NULL) && (lpEvtLog->dwID == EVTLOGID)) 
	{
		DWORD Flags, Record, NumRead, Required;
		long retval;
		Flags = SvIV(ST(1));
		if(Flags != lpEvtLog->Flags) 
		{
			// Reset to new read mode & force a re-read call
			lpEvtLog->Flags      = Flags;
			lpEvtLog->NumEntries = 0;
		}
		Record = SvIV(ST(2));
		if((lpEvtLog->NumEntries == 0) || (Record != 0)) 
		{
			if(pReadEventLog(lpEvtLog->hLog, Flags, Record, lpEvtLog->BufPtr,
								lpEvtLog->BufLen, &NumRead, &Required)) 
			{
				lpEvtLog->NumEntries = NumRead;
			}
			else 
			{
				lpEvtLog->NumEntries = 0;
				GetLastError();
			}
			lpEvtLog->CurEntryNum = 0;
			lpEvtLog->CurEntry    = (EVENTLOGRECORD*)lpEvtLog->BufPtr;
		}

		if(lpEvtLog->CurEntryNum < lpEvtLog->NumEntries) 
		{
			char *name;
			EVENTLOGRECORD *LogBuf;
			LogBuf = lpEvtLog->CurEntry;        
			SETPVN(3, (char*)LogBuf, LogBuf->Length);
			name = ((LPSTR)LogBuf)+sizeof(EVENTLOGRECORD);
			SETPV(4, name);
			name += strlen(name)+1; // step over NULL
			SETPV(5, name);
			SETPVN(6, ((LPBYTE)LogBuf)+LogBuf->UserSidOffset, LogBuf->UserSidLength);
			SETPVN(7, ((LPBYTE)LogBuf)+LogBuf->DataOffset, LogBuf->DataLength);
			SETPVN(8, ((LPBYTE)LogBuf)+LogBuf->StringOffset, LogBuf->DataOffset-LogBuf->StringOffset);

			// to next entry in buffer
			lpEvtLog->CurEntryNum += LogBuf->Length;
			lpEvtLog->CurEntry = (EVENTLOGRECORD*)(((LPBYTE)LogBuf) + LogBuf->Length);
			if(lpEvtLog->CurEntryNum == lpEvtLog->NumEntries) 
			{
				lpEvtLog->NumEntries  = 0;
				lpEvtLog->CurEntryNum = 0;
				lpEvtLog->CurEntry    = NULL;
			}
			XSRETURN_YES;
		}
	}
	XSRETURN_NO;
}


XS(NTWriteEventLog)
{
	dXSARGS;
	unsigned int bufLength, dataLength, index;
	char *server, *source, *buffer, *data, **array;
	HANDLE hLog;
	BOOL bSuccess = FALSE;

	if(items < 8)
	{
		CROAK("usage: Win32::WriteEventLog($server, $source, $eventType, $category, $eventID, $reserved, $data, $message1, ...);\n");
	}

	server = SvPV(ST(0), bufLength);
	if(bufLength == 0)
		server = NULL;

	ADVAPISTARTUP;
	source = SvPV(ST(1), bufLength);
	if((hLog = pRegisterEventSource(server, source)) != NULL)
	{
		data = SvPV(ST(6), dataLength);
		NEW(3101, array, items - 7, char*);
		for(index = 0; index < items - 7; ++index)
		{
			buffer = SvPV(ST(index+7), bufLength);
			array[index] = buffer;
		}
		if(pReportEvent(hLog,			// handle returned by RegisterEventSource
					SvIV(ST(2)),		// event type to log
					SvIV(ST(3)),		// event category
					SvIV(ST(4)),		// event identifier
					NULL,				// user security identifier (optional)
					items - 7,			// number of strings to merge with message
					dataLength,			// size of raw (binary) data (in bytes)
					(const char**)array,// array of strings to merge with message 
					data				// address of binary data 
				))
		{
			bSuccess = TRUE;
		}
		Safefree(array);
		pDeregisterEventSource(hLog);
	}
	XSRETURN_IV(bSuccess);
}

XS(NTSpawn)
{
	dXSARGS;
	char *cmd, *args;
	PROCESS_INFORMATION stProcInfo;
	STARTUPINFO stStartInfo;
	BOOL bSuccess = FALSE;

	if(items != 3)
	{
		CROAK("usage: Win32::Spawn($cmdName, $args, $PID);\n");
	}

	cmd = SvPV(ST(0), na);
	args = SvPV(ST(1), na);

	memset(&stStartInfo, 0, sizeof(stStartInfo));	// Clear the block
	stStartInfo.cb = sizeof(stStartInfo);			// Set the structure size
	stStartInfo.dwFlags = STARTF_USESHOWWINDOW;		// Enable wShowWindow control
	stStartInfo.wShowWindow = SW_SHOWMINNOACTIVE;	// Start min (normal)

	if(CreateProcess(cmd,					// Image path
					args,	 				// Arguments for command line
					NULL,					// Default process security
					NULL,					// Default thread security
					FALSE,					// Must be TRUE to use std handles
					NORMAL_PRIORITY_CLASS,	// No special scheduling
					NULL,					// Inherit our environment block
					NULL,					// Inherit our currrent directory
					&stStartInfo,			// -> Startup info
					&stProcInfo))			// <- Process info (if OK)
	{
		CloseHandle(stProcInfo.hThread);	// library source code does this.
		SETIV(2, stProcInfo.dwProcessId);
		bSuccess = TRUE;
	}
	XSRETURN_IV(bSuccess);
}

XS(NTLookupAccountName)
{
	dXSARGS;
	char SID[400];
	DWORD SIDLen;
	SID_NAME_USE snu;
	char Domain[256];
	DWORD DomLen;
            
	if (items != 5)
	{
		CROAK("usage: Win32::LookupAccountName($system, $account, $domain, $sid, $sidtype);\n");
	}

	ADVAPISTARTUP;
	SIDLen = sizeof(SID);
	DomLen = sizeof(Domain);
	if (pLookupAccountName(
			SvPV(ST(0), na),		// System
			SvPV(ST(1), na),		// Account name
			&SID,					// SID structure
			&SIDLen,				// Size of SID buffer
			Domain,					// Domain buffer
			&DomLen,				// Domain buffer size
			&snu))					// SID name type
	{
		SETPV(2, Domain);
		SETPVN(3, SID, SIDLen);
		SETIV(4, snu);
		XSRETURN_YES;
	}
	else
	{
		GetLastError();
		XSRETURN_NO;
	}
}	// NTLookupAccountName


XS(NTLookupAccountSID)
{
	dXSARGS;
	PSID sid;
	char Account[256];
	DWORD AcctLen = sizeof(Account);
	char Domain[256];
	DWORD DomLen = sizeof(Domain);
	SID_NAME_USE snu;
	long retval;
    
	if (items != 5)
	{
		CROAK("usage: Win32::LookupAccountSID($system, $sid, $account, $domain, $sidtype);\n");
	}

	ADVAPISTARTUP;
	sid = SvPV(ST(1), na);
	if (pIsValidSid(sid)) 
	{
		if (pLookupAccountSid(
				SvPV(ST(0), na),	// System
				sid,				// SID structure
				Account,			// Account name buffer
				&AcctLen,			// name buffer length
				Domain,				// Domain buffer
				&DomLen,			// Domain buffer length
				&snu))				// SID name type
		{
			SETPV(2, Account);
			SETPV(3, Domain);
			SETIV(4, (double) snu);
			XSRETURN_YES;
		}
		else
		{
			GetLastError();
			XSRETURN_NO;
		}
	}
	else
	{
		GetLastError();
		XSRETURN_NO;
    }
}	// NTLookupAccountSID

XS(NTInitiateSystemShutdown)
{
	dXSARGS;
	HANDLE hToken;              // handle to process token  
	TOKEN_PRIVILEGES tkp;       // pointer to token structure 
	BOOL bRet;
	char *machineName, *message;

	if(items != 5)
	{
		CROAK("usage: Win32::InitiateSystemShutdown($machineName, $message, $timeOut, $forceClose, $reboot);\n");
	}

	ADVAPISTARTUP;
	machineName = SvPV(ST(0), na);

	if(pOpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
	{
		pLookupPrivilegeValue(machineName, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid);
		tkp.PrivilegeCount = 1; // only setting one
		tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

		// Get shutdown privilege for this process.
		pAdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
	}

	message = SvPV(ST(1), na);
	bRet = pInitiateSystemShutdown(machineName, message, SvIV(ST(2)), SvIV(ST(3)), SvIV(ST(4)));
	CloseHandle(hToken);

	// Disable shutdown privilege.
	tkp.Privileges[0].Attributes = 0; 
	pAdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0); 

	XSRETURN_IV(bRet);
}

XS(NTAbortSystemShutdown)
{
	dXSARGS;
	HANDLE hToken;              // handle to process token  
	TOKEN_PRIVILEGES tkp;       // pointer to token structure 
	BOOL bRet;
	char *machineName;

	if(items != 1)
	{
		CROAK("usage: Win32::AbortSystemShutdown($machineName);\n");
	}

	ADVAPISTARTUP;
	machineName = SvPV(ST(0), na);

	if(pOpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
	{
		pLookupPrivilegeValue(machineName, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid);
		tkp.PrivilegeCount = 1; // only setting one
		tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

		// Get shutdown privilege for this process.
		pAdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
	}

	bRet = pAbortSystemShutdown(machineName);

	// Disable shutdown privilege.
	tkp.Privileges[0].Attributes = 0;
	pAdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
	CloseHandle(hToken);

	XSRETURN_IV(bRet);
}

XS(NTGetTickCount)
{
	dXSARGS;
	XSRETURN_IV(GetTickCount());
}

XS(NTIsWinNT)
{
	dXSARGS;
	XSRETURN_IV(pPerl->IsWinNT());
}

XS(NTIsWin95)
{
	dXSARGS;
	XSRETURN_IV(pPerl->IsWin95());
}

XS(NTGetShortPathName)
{
	dXSARGS;
	DWORD dwResult;
	char szShortPathName[256];
	char *lpLongPathName;

	if(items != 1)
	{
		CROAK("usage: Win32::GetShortPathName($longPathName);\n");
	}

	lpLongPathName = SvPV(ST(0), na);
	dwResult = GetShortPathName(lpLongPathName, szShortPathName, sizeof(szShortPathName));
	XSRETURN_PV(szShortPathName);
}
 
XS(NTGetNextAvailDrive)
{
	int index;
	char szBuffer[256];
	dXSARGS;

	ST(0) = &sv_undef;
	strcpy(szBuffer, "x:\\");
	for(index = 'A'; index <= 'Z'; ++index)
	{
		szBuffer[0] = index;
		if(GetDriveType(szBuffer) == 1)
		{
			szBuffer[2] = '\0';
			ST(0) = sv_2mortal(newSVpv(szBuffer, 0));
			break;
		}
	}
	XSRETURN(1);
}


void NTInit(CPerl *pPerl)
{
	// Instantiate our extension subroutines

	newXSInternal("Win32::RegCloseKey", NTRegCloseKey, thisFile);
	newXSInternal("Win32::RegConnectRegistry", NTRegConnectRegistry, thisFile);
	newXSInternal("Win32::RegCreateKey", NTRegCreateKey, thisFile);
	newXSInternal("Win32::RegCreateKeyEx", NTRegCreateKeyEx, thisFile);
	newXSInternal("Win32::RegDeleteKey", NTRegDeleteKey, thisFile);
	newXSInternal("Win32::RegDeleteValue", NTRegDeleteValue, thisFile);

	newXSInternal("Win32::RegEnumKey", NTRegEnumKey, thisFile);
	newXSInternal("Win32::RegEnumKeyEx", NTRegEnumKeyEx, thisFile);
	newXSInternal("Win32::RegEnumValue", NTRegEnumValue, thisFile);

	newXSInternal("Win32::RegFlushKey", NTRegFlushKey, thisFile);
	newXSInternal("Win32::RegGetKeySecurity", NTRegGetKeySecurity, thisFile);

	newXSInternal("Win32::RegLoadKey", NTRegLoadKey, thisFile);
	newXSInternal("Win32::RegOpenKey", NTRegOpenKey, thisFile);
	newXSInternal("Win32::RegOpenKeyEx", NTRegOpenKeyEx, thisFile);
	newXSInternal("Win32::RegQueryInfoKey", NTRegQueryInfoKey, thisFile);
	newXSInternal("Win32::RegQueryValue", NTRegQueryValue, thisFile);
	newXSInternal("Win32::RegQueryValueEx", NTRegQueryValueEx, thisFile);

	newXSInternal("Win32::RegReplaceKey", NTRegReplaceKey, thisFile);
	newXSInternal("Win32::RegRestoreKey", NTRegRestoreKey, thisFile);
	newXSInternal("Win32::RegSaveKey", NTRegSaveKey, thisFile);
	newXSInternal("Win32::RegSetKeySecurity", NTRegSetKeySecurity, thisFile);
	newXSInternal("Win32::RegSetValue", NTRegSetValue, thisFile);
	newXSInternal("Win32::RegSetValueEx", NTRegSetValueEx, thisFile);
	newXSInternal("Win32::RegUnloadKey", NTRegUnloadKey, thisFile);

	newXSInternal("Win32::OpenEventLog", NTOpenEventLog, thisFile);
	newXSInternal("Win32::OpenBackupEventLog", NTOpenBackupEventLog, thisFile);
	newXSInternal("Win32::BackupEventLog", NTBackupEventLog, thisFile);
	newXSInternal("Win32::ClearEventLog", NTClearEventLog, thisFile);
	newXSInternal("Win32::CloseEventLog", NTCloseEventLog, thisFile);
	newXSInternal("Win32::GetNumberOfEventLogRecords", NTGetNumberOfEventLogRecords, thisFile);
	newXSInternal("Win32::ReadEventLog", NTReadEventLog, thisFile);
	newXSInternal("Win32::WriteEventLog", NTWriteEventLog, thisFile);

	newXSInternal("Win32::GetLastError", NTGetLastError, thisFile);

	newXSInternal("Win32::PerlVersion", NTPerlVersion, thisFile); // DEPRECIATED!! DON'T USE!
	newXSInternal("Win32::BuildNumber", NTBuildNumber, thisFile);

	newXSInternal("Win32::LoginName", NTLoginName, thisFile);
	newXSInternal("Win32::NodeName", NTNodeName, thisFile);
	newXSInternal("Win32::DomainName", NTDomainName, thisFile);
	newXSInternal("Win32::FsType", NTFsType, thisFile);
	newXSInternal("Win32::GetCwd", NTGetCwd, thisFile);
	newXSInternal("Win32::SetCwd", NTSetCwd, thisFile);
	newXSInternal("Win32::GetOSVersion", NTGetVersion, thisFile);
	newXSInternal("Win32::FormatMessage", NTFormatMessage, thisFile);

	newXSInternal("Win32::Spawn", NTSpawn, thisFile);
	newXSInternal("Win32::LookupAccountName", NTLookupAccountName, thisFile);
	newXSInternal("Win32::LookupAccountSID", NTLookupAccountSID, thisFile);

	newXSInternal("Win32::InitiateSystemShutdown", NTInitiateSystemShutdown, thisFile);
	newXSInternal("Win32::AbortSystemShutdown", NTAbortSystemShutdown, thisFile);

	newXSInternal("Win32::GetTickCount", NTGetTickCount, thisFile);
	newXSInternal("Win32::IsWinNT", NTIsWinNT, thisFile);
	newXSInternal("Win32::IsWin95", NTIsWin95, thisFile);
	newXSInternal("Win32::GetArchName",NTGetArch,thisFile);
	newXSInternal("Win32::GetChipName",NTGetChipName,thisFile);
	newXSInternal("Win32::ExpandEnvironmentStrings", NTExpandEnvironmentStrings, thisFile);

	newXSInternal("Win32::GetShortPathName", NTGetShortPathName, thisFile);
	newXSInternal("Win32::GetNextAvailDrive", NTGetNextAvailDrive, thisFile);
}
