#ifndef PERL_OBJECT
#define pp_i_preinc pp_preinc
#define pp_i_predec pp_predec
#define pp_i_postinc pp_postinc
#define pp_i_postdec pp_postdec
#define CPERLarg void
#define CPERLarg_ 
#else
#define PP_i_preinc PP_preinc
#define PP_i_predec PP_predec
#define PP_i_postinc PP_postinc
#define PP_i_postdec PP_postdec
#endif
typedef enum {
	OP_NULL,	/* 0 */
	OP_STUB,	/* 1 */
	OP_SCALAR,	/* 2 */
	OP_PUSHMARK,	/* 3 */
	OP_WANTARRAY,	/* 4 */
	OP_CONST,	/* 5 */
	OP_GVSV,	/* 6 */
	OP_GV,		/* 7 */
	OP_GELEM,	/* 8 */
	OP_PADSV,	/* 9 */
	OP_PADAV,	/* 10 */
	OP_PADHV,	/* 11 */
	OP_PADANY,	/* 12 */
	OP_PUSHRE,	/* 13 */
	OP_RV2GV,	/* 14 */
	OP_RV2SV,	/* 15 */
	OP_AV2ARYLEN,	/* 16 */
	OP_RV2CV,	/* 17 */
	OP_ANONCODE,	/* 18 */
	OP_PROTOTYPE,	/* 19 */
	OP_REFGEN,	/* 20 */
	OP_SREFGEN,	/* 21 */
	OP_REF,		/* 22 */
	OP_BLESS,	/* 23 */
	OP_BACKTICK,	/* 24 */
	OP_GLOB,	/* 25 */
	OP_READLINE,	/* 26 */
	OP_RCATLINE,	/* 27 */
	OP_REGCMAYBE,	/* 28 */
	OP_REGCOMP,	/* 29 */
	OP_MATCH,	/* 30 */
	OP_SUBST,	/* 31 */
	OP_SUBSTCONT,	/* 32 */
	OP_TRANS,	/* 33 */
	OP_SASSIGN,	/* 34 */
	OP_AASSIGN,	/* 35 */
	OP_CHOP,	/* 36 */
	OP_SCHOP,	/* 37 */
	OP_CHOMP,	/* 38 */
	OP_SCHOMP,	/* 39 */
	OP_DEFINED,	/* 40 */
	OP_UNDEF,	/* 41 */
	OP_STUDY,	/* 42 */
	OP_POS,		/* 43 */
	OP_PREINC,	/* 44 */
	OP_I_PREINC,	/* 45 */
	OP_PREDEC,	/* 46 */
	OP_I_PREDEC,	/* 47 */
	OP_POSTINC,	/* 48 */
	OP_I_POSTINC,	/* 49 */
	OP_POSTDEC,	/* 50 */
	OP_I_POSTDEC,	/* 51 */
	OP_POW,		/* 52 */
	OP_MULTIPLY,	/* 53 */
	OP_I_MULTIPLY,	/* 54 */
	OP_DIVIDE,	/* 55 */
	OP_I_DIVIDE,	/* 56 */
	OP_MODULO,	/* 57 */
	OP_I_MODULO,	/* 58 */
	OP_REPEAT,	/* 59 */
	OP_ADD,		/* 60 */
	OP_I_ADD,	/* 61 */
	OP_SUBTRACT,	/* 62 */
	OP_I_SUBTRACT,	/* 63 */
	OP_CONCAT,	/* 64 */
	OP_STRINGIFY,	/* 65 */
	OP_LEFT_SHIFT,	/* 66 */
	OP_RIGHT_SHIFT,	/* 67 */
	OP_LT,		/* 68 */
	OP_I_LT,	/* 69 */
	OP_GT,		/* 70 */
	OP_I_GT,	/* 71 */
	OP_LE,		/* 72 */
	OP_I_LE,	/* 73 */
	OP_GE,		/* 74 */
	OP_I_GE,	/* 75 */
	OP_EQ,		/* 76 */
	OP_I_EQ,	/* 77 */
	OP_NE,		/* 78 */
	OP_I_NE,	/* 79 */
	OP_NCMP,	/* 80 */
	OP_I_NCMP,	/* 81 */
	OP_SLT,		/* 82 */
	OP_SGT,		/* 83 */
	OP_SLE,		/* 84 */
	OP_SGE,		/* 85 */
	OP_SEQ,		/* 86 */
	OP_SNE,		/* 87 */
	OP_SCMP,	/* 88 */
	OP_BIT_AND,	/* 89 */
	OP_BIT_XOR,	/* 90 */
	OP_BIT_OR,	/* 91 */
	OP_NEGATE,	/* 92 */
	OP_I_NEGATE,	/* 93 */
	OP_NOT,		/* 94 */
	OP_COMPLEMENT,	/* 95 */
	OP_ATAN2,	/* 96 */
	OP_SIN,		/* 97 */
	OP_COS,		/* 98 */
	OP_RAND,	/* 99 */
	OP_SRAND,	/* 100 */
	OP_EXP,		/* 101 */
	OP_LOG,		/* 102 */
	OP_SQRT,	/* 103 */
	OP_INT,		/* 104 */
	OP_HEX,		/* 105 */
	OP_OCT,		/* 106 */
	OP_ABS,		/* 107 */
	OP_LENGTH,	/* 108 */
	OP_SUBSTR,	/* 109 */
	OP_VEC,		/* 110 */
	OP_INDEX,	/* 111 */
	OP_RINDEX,	/* 112 */
	OP_SPRINTF,	/* 113 */
	OP_FORMLINE,	/* 114 */
	OP_ORD,		/* 115 */
	OP_CHR,		/* 116 */
	OP_CRYPT,	/* 117 */
	OP_UCFIRST,	/* 118 */
	OP_LCFIRST,	/* 119 */
	OP_UC,		/* 120 */
	OP_LC,		/* 121 */
	OP_QUOTEMETA,	/* 122 */
	OP_RV2AV,	/* 123 */
	OP_AELEMFAST,	/* 124 */
	OP_AELEM,	/* 125 */
	OP_ASLICE,	/* 126 */
	OP_EACH,	/* 127 */
	OP_VALUES,	/* 128 */
	OP_KEYS,	/* 129 */
	OP_DELETE,	/* 130 */
	OP_EXISTS,	/* 131 */
	OP_RV2HV,	/* 132 */
	OP_HELEM,	/* 133 */
	OP_HSLICE,	/* 134 */
	OP_UNPACK,	/* 135 */
	OP_PACK,	/* 136 */
	OP_SPLIT,	/* 137 */
	OP_JOIN,	/* 138 */
	OP_LIST,	/* 139 */
	OP_LSLICE,	/* 140 */
	OP_ANONLIST,	/* 141 */
	OP_ANONHASH,	/* 142 */
	OP_SPLICE,	/* 143 */
	OP_PUSH,	/* 144 */
	OP_POP,		/* 145 */
	OP_SHIFT,	/* 146 */
	OP_UNSHIFT,	/* 147 */
	OP_SORT,	/* 148 */
	OP_REVERSE,	/* 149 */
	OP_GREPSTART,	/* 150 */
	OP_GREPWHILE,	/* 151 */
	OP_MAPSTART,	/* 152 */
	OP_MAPWHILE,	/* 153 */
	OP_RANGE,	/* 154 */
	OP_FLIP,	/* 155 */
	OP_FLOP,	/* 156 */
	OP_AND,		/* 157 */
	OP_OR,		/* 158 */
	OP_XOR,		/* 159 */
	OP_COND_EXPR,	/* 160 */
	OP_ANDASSIGN,	/* 161 */
	OP_ORASSIGN,	/* 162 */
	OP_METHOD,	/* 163 */
	OP_ENTERSUB,	/* 164 */
	OP_LEAVESUB,	/* 165 */
	OP_CALLER,	/* 166 */
	OP_WARN,	/* 167 */
	OP_DIE,		/* 168 */
	OP_RESET,	/* 169 */
	OP_LINESEQ,	/* 170 */
	OP_NEXTSTATE,	/* 171 */
	OP_DBSTATE,	/* 172 */
	OP_UNSTACK,	/* 173 */
	OP_ENTER,	/* 174 */
	OP_LEAVE,	/* 175 */
	OP_SCOPE,	/* 176 */
	OP_ENTERITER,	/* 177 */
	OP_ITER,	/* 178 */
	OP_ENTERLOOP,	/* 179 */
	OP_LEAVELOOP,	/* 180 */
	OP_RETURN,	/* 181 */
	OP_LAST,	/* 182 */
	OP_NEXT,	/* 183 */
	OP_REDO,	/* 184 */
	OP_DUMP,	/* 185 */
	OP_GOTO,	/* 186 */
	OP_EXIT,	/* 187 */
	OP_OPEN,	/* 188 */
	OP_CLOSE,	/* 189 */
	OP_PIPE_OP,	/* 190 */
	OP_FILENO,	/* 191 */
	OP_UMASK,	/* 192 */
	OP_BINMODE,	/* 193 */
	OP_TIE,		/* 194 */
	OP_UNTIE,	/* 195 */
	OP_TIED,	/* 196 */
	OP_DBMOPEN,	/* 197 */
	OP_DBMCLOSE,	/* 198 */
	OP_SSELECT,	/* 199 */
	OP_SELECT,	/* 200 */
	OP_GETC,	/* 201 */
	OP_READ,	/* 202 */
	OP_ENTERWRITE,	/* 203 */
	OP_LEAVEWRITE,	/* 204 */
	OP_PRTF,	/* 205 */
	OP_PRINT,	/* 206 */
	OP_SYSOPEN,	/* 207 */
	OP_SYSREAD,	/* 208 */
	OP_SYSWRITE,	/* 209 */
	OP_SEND,	/* 210 */
	OP_RECV,	/* 211 */
	OP_EOF,		/* 212 */
	OP_TELL,	/* 213 */
	OP_SEEK,	/* 214 */
	OP_TRUNCATE,	/* 215 */
	OP_FCNTL,	/* 216 */
	OP_IOCTL,	/* 217 */
	OP_FLOCK,	/* 218 */
	OP_SOCKET,	/* 219 */
	OP_SOCKPAIR,	/* 220 */
	OP_BIND,	/* 221 */
	OP_CONNECT,	/* 222 */
	OP_LISTEN,	/* 223 */
	OP_ACCEPT,	/* 224 */
	OP_SHUTDOWN,	/* 225 */
	OP_GSOCKOPT,	/* 226 */
	OP_SSOCKOPT,	/* 227 */
	OP_GETSOCKNAME,	/* 228 */
	OP_GETPEERNAME,	/* 229 */
	OP_LSTAT,	/* 230 */
	OP_STAT,	/* 231 */
	OP_FTRREAD,	/* 232 */
	OP_FTRWRITE,	/* 233 */
	OP_FTREXEC,	/* 234 */
	OP_FTEREAD,	/* 235 */
	OP_FTEWRITE,	/* 236 */
	OP_FTEEXEC,	/* 237 */
	OP_FTIS,	/* 238 */
	OP_FTEOWNED,	/* 239 */
	OP_FTROWNED,	/* 240 */
	OP_FTZERO,	/* 241 */
	OP_FTSIZE,	/* 242 */
	OP_FTMTIME,	/* 243 */
	OP_FTATIME,	/* 244 */
	OP_FTCTIME,	/* 245 */
	OP_FTSOCK,	/* 246 */
	OP_FTCHR,	/* 247 */
	OP_FTBLK,	/* 248 */
	OP_FTFILE,	/* 249 */
	OP_FTDIR,	/* 250 */
	OP_FTPIPE,	/* 251 */
	OP_FTLINK,	/* 252 */
	OP_FTSUID,	/* 253 */
	OP_FTSGID,	/* 254 */
	OP_FTSVTX,	/* 255 */
	OP_FTTTY,	/* 256 */
	OP_FTTEXT,	/* 257 */
	OP_FTBINARY,	/* 258 */
	OP_CHDIR,	/* 259 */
	OP_CHOWN,	/* 260 */
	OP_CHROOT,	/* 261 */
	OP_UNLINK,	/* 262 */
	OP_CHMOD,	/* 263 */
	OP_UTIME,	/* 264 */
	OP_RENAME,	/* 265 */
	OP_LINK,	/* 266 */
	OP_SYMLINK,	/* 267 */
	OP_READLINK,	/* 268 */
	OP_MKDIR,	/* 269 */
	OP_RMDIR,	/* 270 */
	OP_OPEN_DIR,	/* 271 */
	OP_READDIR,	/* 272 */
	OP_TELLDIR,	/* 273 */
	OP_SEEKDIR,	/* 274 */
	OP_REWINDDIR,	/* 275 */
	OP_CLOSEDIR,	/* 276 */
	OP_FORK,	/* 277 */
	OP_WAIT,	/* 278 */
	OP_WAITPID,	/* 279 */
	OP_SYSTEM,	/* 280 */
	OP_EXEC,	/* 281 */
	OP_KILL,	/* 282 */
	OP_GETPPID,	/* 283 */
	OP_GETPGRP,	/* 284 */
	OP_SETPGRP,	/* 285 */
	OP_GETPRIORITY,	/* 286 */
	OP_SETPRIORITY,	/* 287 */
	OP_TIME,	/* 288 */
	OP_TMS,		/* 289 */
	OP_LOCALTIME,	/* 290 */
	OP_GMTIME,	/* 291 */
	OP_ALARM,	/* 292 */
	OP_SLEEP,	/* 293 */
	OP_SHMGET,	/* 294 */
	OP_SHMCTL,	/* 295 */
	OP_SHMREAD,	/* 296 */
	OP_SHMWRITE,	/* 297 */
	OP_MSGGET,	/* 298 */
	OP_MSGCTL,	/* 299 */
	OP_MSGSND,	/* 300 */
	OP_MSGRCV,	/* 301 */
	OP_SEMGET,	/* 302 */
	OP_SEMCTL,	/* 303 */
	OP_SEMOP,	/* 304 */
	OP_REQUIRE,	/* 305 */
	OP_DOFILE,	/* 306 */
	OP_ENTEREVAL,	/* 307 */
	OP_LEAVEEVAL,	/* 308 */
	OP_ENTERTRY,	/* 309 */
	OP_LEAVETRY,	/* 310 */
	OP_GHBYNAME,	/* 311 */
	OP_GHBYADDR,	/* 312 */
	OP_GHOSTENT,	/* 313 */
	OP_GNBYNAME,	/* 314 */
	OP_GNBYADDR,	/* 315 */
	OP_GNETENT,	/* 316 */
	OP_GPBYNAME,	/* 317 */
	OP_GPBYNUMBER,	/* 318 */
	OP_GPROTOENT,	/* 319 */
	OP_GSBYNAME,	/* 320 */
	OP_GSBYPORT,	/* 321 */
	OP_GSERVENT,	/* 322 */
	OP_SHOSTENT,	/* 323 */
	OP_SNETENT,	/* 324 */
	OP_SPROTOENT,	/* 325 */
	OP_SSERVENT,	/* 326 */
	OP_EHOSTENT,	/* 327 */
	OP_ENETENT,	/* 328 */
	OP_EPROTOENT,	/* 329 */
	OP_ESERVENT,	/* 330 */
	OP_GPWNAM,	/* 331 */
	OP_GPWUID,	/* 332 */
	OP_GPWENT,	/* 333 */
	OP_SPWENT,	/* 334 */
	OP_EPWENT,	/* 335 */
	OP_GGRNAM,	/* 336 */
	OP_GGRGID,	/* 337 */
	OP_GGRENT,	/* 338 */
	OP_SGRENT,	/* 339 */
	OP_EGRENT,	/* 340 */
	OP_GETLOGIN,	/* 341 */
	OP_SYSCALL,	/* 342 */
	OP_max		
} opcode;

#define MAXO 343

#ifndef DOINIT
EXT char *op_name[];
#else
EXT char *op_name[] = {
	"null",
	"stub",
	"scalar",
	"pushmark",
	"wantarray",
	"const",
	"gvsv",
	"gv",
	"gelem",
	"padsv",
	"padav",
	"padhv",
	"padany",
	"pushre",
	"rv2gv",
	"rv2sv",
	"av2arylen",
	"rv2cv",
	"anoncode",
	"prototype",
	"refgen",
	"srefgen",
	"ref",
	"bless",
	"backtick",
	"glob",
	"readline",
	"rcatline",
	"regcmaybe",
	"regcomp",
	"match",
	"subst",
	"substcont",
	"trans",
	"sassign",
	"aassign",
	"chop",
	"schop",
	"chomp",
	"schomp",
	"defined",
	"undef",
	"study",
	"pos",
	"preinc",
	"i_preinc",
	"predec",
	"i_predec",
	"postinc",
	"i_postinc",
	"postdec",
	"i_postdec",
	"pow",
	"multiply",
	"i_multiply",
	"divide",
	"i_divide",
	"modulo",
	"i_modulo",
	"repeat",
	"add",
	"i_add",
	"subtract",
	"i_subtract",
	"concat",
	"stringify",
	"left_shift",
	"right_shift",
	"lt",
	"i_lt",
	"gt",
	"i_gt",
	"le",
	"i_le",
	"ge",
	"i_ge",
	"eq",
	"i_eq",
	"ne",
	"i_ne",
	"ncmp",
	"i_ncmp",
	"slt",
	"sgt",
	"sle",
	"sge",
	"seq",
	"sne",
	"scmp",
	"bit_and",
	"bit_xor",
	"bit_or",
	"negate",
	"i_negate",
	"not",
	"complement",
	"atan2",
	"sin",
	"cos",
	"rand",
	"srand",
	"exp",
	"log",
	"sqrt",
	"int",
	"hex",
	"oct",
	"abs",
	"length",
	"substr",
	"vec",
	"index",
	"rindex",
	"sprintf",
	"formline",
	"ord",
	"chr",
	"crypt",
	"ucfirst",
	"lcfirst",
	"uc",
	"lc",
	"quotemeta",
	"rv2av",
	"aelemfast",
	"aelem",
	"aslice",
	"each",
	"values",
	"keys",
	"delete",
	"exists",
	"rv2hv",
	"helem",
	"hslice",
	"unpack",
	"pack",
	"split",
	"join",
	"list",
	"lslice",
	"anonlist",
	"anonhash",
	"splice",
	"push",
	"pop",
	"shift",
	"unshift",
	"sort",
	"reverse",
	"grepstart",
	"grepwhile",
	"mapstart",
	"mapwhile",
	"range",
	"flip",
	"flop",
	"and",
	"or",
	"xor",
	"cond_expr",
	"andassign",
	"orassign",
	"method",
	"entersub",
	"leavesub",
	"caller",
	"warn",
	"die",
	"reset",
	"lineseq",
	"nextstate",
	"dbstate",
	"unstack",
	"enter",
	"leave",
	"scope",
	"enteriter",
	"iter",
	"enterloop",
	"leaveloop",
	"return",
	"last",
	"next",
	"redo",
	"dump",
	"goto",
	"exit",
	"open",
	"close",
	"pipe_op",
	"fileno",
	"umask",
	"binmode",
	"tie",
	"untie",
	"tied",
	"dbmopen",
	"dbmclose",
	"sselect",
	"select",
	"getc",
	"read",
	"enterwrite",
	"leavewrite",
	"prtf",
	"print",
	"sysopen",
	"sysread",
	"syswrite",
	"send",
	"recv",
	"eof",
	"tell",
	"seek",
	"truncate",
	"fcntl",
	"ioctl",
	"flock",
	"socket",
	"sockpair",
	"bind",
	"connect",
	"listen",
	"accept",
	"shutdown",
	"gsockopt",
	"ssockopt",
	"getsockname",
	"getpeername",
	"lstat",
	"stat",
	"ftrread",
	"ftrwrite",
	"ftrexec",
	"fteread",
	"ftewrite",
	"fteexec",
	"ftis",
	"fteowned",
	"ftrowned",
	"ftzero",
	"ftsize",
	"ftmtime",
	"ftatime",
	"ftctime",
	"ftsock",
	"ftchr",
	"ftblk",
	"ftfile",
	"ftdir",
	"ftpipe",
	"ftlink",
	"ftsuid",
	"ftsgid",
	"ftsvtx",
	"fttty",
	"fttext",
	"ftbinary",
	"chdir",
	"chown",
	"chroot",
	"unlink",
	"chmod",
	"utime",
	"rename",
	"link",
	"symlink",
	"readlink",
	"mkdir",
	"rmdir",
	"open_dir",
	"readdir",
	"telldir",
	"seekdir",
	"rewinddir",
	"closedir",
	"fork",
	"wait",
	"waitpid",
	"system",
	"exec",
	"kill",
	"getppid",
	"getpgrp",
	"setpgrp",
	"getpriority",
	"setpriority",
	"time",
	"tms",
	"localtime",
	"gmtime",
	"alarm",
	"sleep",
	"shmget",
	"shmctl",
	"shmread",
	"shmwrite",
	"msgget",
	"msgctl",
	"msgsnd",
	"msgrcv",
	"semget",
	"semctl",
	"semop",
	"require",
	"dofile",
	"entereval",
	"leaveeval",
	"entertry",
	"leavetry",
	"ghbyname",
	"ghbyaddr",
	"ghostent",
	"gnbyname",
	"gnbyaddr",
	"gnetent",
	"gpbyname",
	"gpbynumber",
	"gprotoent",
	"gsbyname",
	"gsbyport",
	"gservent",
	"shostent",
	"snetent",
	"sprotoent",
	"sservent",
	"ehostent",
	"enetent",
	"eprotoent",
	"eservent",
	"gpwnam",
	"gpwuid",
	"gpwent",
	"spwent",
	"epwent",
	"ggrnam",
	"ggrgid",
	"ggrent",
	"sgrent",
	"egrent",
	"getlogin",
	"syscall",
};
#endif

#ifndef DOINIT
EXT char *op_desc[];
#else
EXT char *op_desc[] = {
	"null operation",
	"stub",
	"scalar",
	"pushmark",
	"wantarray",
	"constant item",
	"scalar variable",
	"glob value",
	"glob elem",
	"private variable",
	"private array",
	"private hash",
	"private something",
	"push regexp",
	"ref-to-glob cast",
	"scalar deref",
	"array length",
	"subroutine deref",
	"anonymous subroutine",
	"subroutine prototype",
	"reference constructor",
	"scalar ref constructor",
	"reference-type operator",
	"bless",
	"backticks",
	"glob",
	"<HANDLE>",
	"append I/O operator",
	"regexp comp once",
	"regexp compilation",
	"pattern match",
	"substitution",
	"substitution cont",
	"character translation",
	"scalar assignment",
	"list assignment",
	"chop",
	"scalar chop",
	"safe chop",
	"scalar safe chop",
	"defined operator",
	"undef operator",
	"study",
	"match position",
	"preincrement",
	"integer preincrement",
	"predecrement",
	"integer predecrement",
	"postincrement",
	"integer postincrement",
	"postdecrement",
	"integer postdecrement",
	"exponentiation",
	"multiplication",
	"integer multiplication",
	"division",
	"integer division",
	"modulus",
	"integer modulus",
	"repeat",
	"addition",
	"integer addition",
	"subtraction",
	"integer subtraction",
	"concatenation",
	"string",
	"left bitshift",
	"right bitshift",
	"numeric lt",
	"integer lt",
	"numeric gt",
	"integer gt",
	"numeric le",
	"integer le",
	"numeric ge",
	"integer ge",
	"numeric eq",
	"integer eq",
	"numeric ne",
	"integer ne",
	"spaceship operator",
	"integer spaceship",
	"string lt",
	"string gt",
	"string le",
	"string ge",
	"string eq",
	"string ne",
	"string comparison",
	"bitwise and",
	"bitwise xor",
	"bitwise or",
	"negate",
	"integer negate",
	"not",
	"1's complement",
	"atan2",
	"sin",
	"cos",
	"rand",
	"srand",
	"exp",
	"log",
	"sqrt",
	"int",
	"hex",
	"oct",
	"abs",
	"length",
	"substr",
	"vec",
	"index",
	"rindex",
	"sprintf",
	"formline",
	"ord",
	"chr",
	"crypt",
	"upper case first",
	"lower case first",
	"upper case",
	"lower case",
	"quote metachars",
	"array deref",
	"known array element",
	"array element",
	"array slice",
	"each",
	"values",
	"keys",
	"delete",
	"exists operator",
	"associative array deref",
	"associative array elem",
	"associative array slice",
	"unpack",
	"pack",
	"split",
	"join",
	"list",
	"list slice",
	"anonymous list",
	"anonymous hash",
	"splice",
	"push",
	"pop",
	"shift",
	"unshift",
	"sort",
	"reverse",
	"grep",
	"grep iterator",
	"map",
	"map iterator",
	"flipflop",
	"range (or flip)",
	"range (or flop)",
	"logical and",
	"logical or",
	"logical xor",
	"conditional expression",
	"logical and assignment",
	"logical or assignment",
	"method lookup",
	"subroutine entry",
	"subroutine exit",
	"caller",
	"warn",
	"die",
	"reset",
	"line sequence",
	"next statement",
	"debug next statement",
	"unstack",
	"block entry",
	"block exit",
	"block",
	"foreach loop entry",
	"foreach loop iterator",
	"loop entry",
	"loop exit",
	"return",
	"last",
	"next",
	"redo",
	"dump",
	"goto",
	"exit",
	"open",
	"close",
	"pipe",
	"fileno",
	"umask",
	"binmode",
	"tie",
	"untie",
	"tied",
	"dbmopen",
	"dbmclose",
	"select system call",
	"select",
	"getc",
	"read",
	"write",
	"write exit",
	"printf",
	"print",
	"sysopen",
	"sysread",
	"syswrite",
	"send",
	"recv",
	"eof",
	"tell",
	"seek",
	"truncate",
	"fcntl",
	"ioctl",
	"flock",
	"socket",
	"socketpair",
	"bind",
	"connect",
	"listen",
	"accept",
	"shutdown",
	"getsockopt",
	"setsockopt",
	"getsockname",
	"getpeername",
	"lstat",
	"stat",
	"-R",
	"-W",
	"-X",
	"-r",
	"-w",
	"-x",
	"-e",
	"-O",
	"-o",
	"-z",
	"-s",
	"-M",
	"-A",
	"-C",
	"-S",
	"-c",
	"-b",
	"-f",
	"-d",
	"-p",
	"-l",
	"-u",
	"-g",
	"-k",
	"-t",
	"-T",
	"-B",
	"chdir",
	"chown",
	"chroot",
	"unlink",
	"chmod",
	"utime",
	"rename",
	"link",
	"symlink",
	"readlink",
	"mkdir",
	"rmdir",
	"opendir",
	"readdir",
	"telldir",
	"seekdir",
	"rewinddir",
	"closedir",
	"fork",
	"wait",
	"waitpid",
	"system",
	"exec",
	"kill",
	"getppid",
	"getpgrp",
	"setpgrp",
	"getpriority",
	"setpriority",
	"time",
	"times",
	"localtime",
	"gmtime",
	"alarm",
	"sleep",
	"shmget",
	"shmctl",
	"shmread",
	"shmwrite",
	"msgget",
	"msgctl",
	"msgsnd",
	"msgrcv",
	"semget",
	"semctl",
	"semop",
	"require",
	"do 'file'",
	"eval string",
	"eval exit",
	"eval block",
	"eval block exit",
	"gethostbyname",
	"gethostbyaddr",
	"gethostent",
	"getnetbyname",
	"getnetbyaddr",
	"getnetent",
	"getprotobyname",
	"getprotobynumber",
	"getprotoent",
	"getservbyname",
	"getservbyport",
	"getservent",
	"sethostent",
	"setnetent",
	"setprotoent",
	"setservent",
	"endhostent",
	"endnetent",
	"endprotoent",
	"endservent",
	"getpwnam",
	"getpwuid",
	"getpwent",
	"setpwent",
	"endpwent",
	"getgrnam",
	"getgrgid",
	"getgrent",
	"setgrent",
	"endgrent",
	"getlogin",
	"syscall",
};
#endif

OP *	CK_concat	_((CPERLarg_ OP* op));
OP *	CK_delete	_((CPERLarg_ OP* op));
OP *	CK_eof		_((CPERLarg_ OP* op));
OP *	CK_eval		_((CPERLarg_ OP* op));
OP *	CK_exec		_((CPERLarg_ OP* op));
OP *	CK_formline	_((CPERLarg_ OP* op));
OP *	CK_ftst		_((CPERLarg_ OP* op));
OP *	CK_fun		_((CPERLarg_ OP* op));
OP *	CK_glob		_((CPERLarg_ OP* op));
OP *	CK_grep		_((CPERLarg_ OP* op));
OP *	CK_index	_((CPERLarg_ OP* op));
OP *	CK_lengthconst	_((CPERLarg_ OP* op));
OP *	CK_lfun		_((CPERLarg_ OP* op));
OP *	CK_listiob	_((CPERLarg_ OP* op));
OP *	CK_match	_((CPERLarg_ OP* op));
OP *	CK_null		_((CPERLarg_ OP* op));
OP *	CK_repeat	_((CPERLarg_ OP* op));
OP *	CK_require	_((CPERLarg_ OP* op));
OP *	CK_rfun		_((CPERLarg_ OP* op));
OP *	CK_rvconst	_((CPERLarg_ OP* op));
OP *	CK_select	_((CPERLarg_ OP* op));
OP *	CK_shift	_((CPERLarg_ OP* op));
OP *	CK_sort		_((CPERLarg_ OP* op));
OP *	CK_spair	_((CPERLarg_ OP* op));
OP *	CK_split	_((CPERLarg_ OP* op));
OP *	CK_subr		_((CPERLarg_ OP* op));
OP *	CK_svconst	_((CPERLarg_ OP* op));
OP *	CK_trunc	_((CPERLarg_ OP* op));

OP *	PP_null		_((CPERLarg));
OP *	PP_stub		_((CPERLarg));
OP *	PP_scalar	_((CPERLarg));
OP *	PP_pushmark	_((CPERLarg));
OP *	PP_wantarray	_((CPERLarg));
OP *	PP_const	_((CPERLarg));
OP *	PP_gvsv		_((CPERLarg));
OP *	PP_gv		_((CPERLarg));
OP *	PP_gelem	_((CPERLarg));
OP *	PP_padsv	_((CPERLarg));
OP *	PP_padav	_((CPERLarg));
OP *	PP_padhv	_((CPERLarg));
OP *	PP_padany	_((CPERLarg));
OP *	PP_pushre	_((CPERLarg));
OP *	PP_rv2gv	_((CPERLarg));
OP *	PP_rv2sv	_((CPERLarg));
OP *	PP_av2arylen	_((CPERLarg));
OP *	PP_rv2cv	_((CPERLarg));
OP *	PP_anoncode	_((CPERLarg));
OP *	PP_prototype	_((CPERLarg));
OP *	PP_refgen	_((CPERLarg));
OP *	PP_srefgen	_((CPERLarg));
OP *	PP_ref		_((CPERLarg));
OP *	PP_bless	_((CPERLarg));
OP *	PP_backtick	_((CPERLarg));
OP *	PP_glob		_((CPERLarg));
OP *	PP_readline	_((CPERLarg));
OP *	PP_rcatline	_((CPERLarg));
OP *	PP_regcmaybe	_((CPERLarg));
OP *	PP_regcomp	_((CPERLarg));
OP *	PP_match	_((CPERLarg));
OP *	PP_subst	_((CPERLarg));
OP *	PP_substcont	_((CPERLarg));
OP *	PP_trans	_((CPERLarg));
OP *	PP_sassign	_((CPERLarg));
OP *	PP_aassign	_((CPERLarg));
OP *	PP_chop		_((CPERLarg));
OP *	PP_schop	_((CPERLarg));
OP *	PP_chomp	_((CPERLarg));
OP *	PP_schomp	_((CPERLarg));
OP *	PP_defined	_((CPERLarg));
OP *	PP_undef	_((CPERLarg));
OP *	PP_study	_((CPERLarg));
OP *	PP_pos		_((CPERLarg));
OP *	PP_preinc	_((CPERLarg));
OP *	PP_i_preinc	_((CPERLarg));
OP *	PP_predec	_((CPERLarg));
OP *	PP_i_predec	_((CPERLarg));
OP *	PP_postinc	_((CPERLarg));
OP *	PP_i_postinc	_((CPERLarg));
OP *	PP_postdec	_((CPERLarg));
OP *	PP_i_postdec	_((CPERLarg));
OP *	PP_pow		_((CPERLarg));
OP *	PP_multiply	_((CPERLarg));
OP *	PP_i_multiply	_((CPERLarg));
OP *	PP_divide	_((CPERLarg));
OP *	PP_i_divide	_((CPERLarg));
OP *	PP_modulo	_((CPERLarg));
OP *	PP_i_modulo	_((CPERLarg));
OP *	PP_repeat	_((CPERLarg));
OP *	PP_add		_((CPERLarg));
OP *	PP_i_add	_((CPERLarg));
OP *	PP_subtract	_((CPERLarg));
OP *	PP_i_subtract	_((CPERLarg));
OP *	PP_concat	_((CPERLarg));
OP *	PP_stringify	_((CPERLarg));
OP *	PP_left_shift	_((CPERLarg));
OP *	PP_right_shift	_((CPERLarg));
OP *	PP_lt		_((CPERLarg));
OP *	PP_i_lt		_((CPERLarg));
OP *	PP_gt		_((CPERLarg));
OP *	PP_i_gt		_((CPERLarg));
OP *	PP_le		_((CPERLarg));
OP *	PP_i_le		_((CPERLarg));
OP *	PP_ge		_((CPERLarg));
OP *	PP_i_ge		_((CPERLarg));
OP *	PP_eq		_((CPERLarg));
OP *	PP_i_eq		_((CPERLarg));
OP *	PP_ne		_((CPERLarg));
OP *	PP_i_ne		_((CPERLarg));
OP *	PP_ncmp		_((CPERLarg));
OP *	PP_i_ncmp	_((CPERLarg));
OP *	PP_slt		_((CPERLarg));
OP *	PP_sgt		_((CPERLarg));
OP *	PP_sle		_((CPERLarg));
OP *	PP_sge		_((CPERLarg));
OP *	PP_seq		_((CPERLarg));
OP *	PP_sne		_((CPERLarg));
OP *	PP_scmp		_((CPERLarg));
OP *	PP_bit_and	_((CPERLarg));
OP *	PP_bit_xor	_((CPERLarg));
OP *	PP_bit_or	_((CPERLarg));
OP *	PP_negate	_((CPERLarg));
OP *	PP_i_negate	_((CPERLarg));
OP *	PP_not		_((CPERLarg));
OP *	PP_complement	_((CPERLarg));
OP *	PP_atan2	_((CPERLarg));
OP *	PP_sin		_((CPERLarg));
OP *	PP_cos		_((CPERLarg));
OP *	PP_rand		_((CPERLarg));
OP *	PP_srand	_((CPERLarg));
OP *	PP_exp		_((CPERLarg));
OP *	PP_log		_((CPERLarg));
OP *	PP_sqrt		_((CPERLarg));
OP *	PP_int		_((CPERLarg));
OP *	PP_hex		_((CPERLarg));
OP *	PP_oct		_((CPERLarg));
OP *	PP_abs		_((CPERLarg));
OP *	PP_length	_((CPERLarg));
OP *	PP_substr	_((CPERLarg));
OP *	PP_vec		_((CPERLarg));
OP *	PP_index	_((CPERLarg));
OP *	PP_rindex	_((CPERLarg));
OP *	PP_sprintf	_((CPERLarg));
OP *	PP_formline	_((CPERLarg));
OP *	PP_ord		_((CPERLarg));
OP *	PP_chr		_((CPERLarg));
OP *	PP_crypt	_((CPERLarg));
OP *	PP_ucfirst	_((CPERLarg));
OP *	PP_lcfirst	_((CPERLarg));
OP *	PP_uc		_((CPERLarg));
OP *	PP_lc		_((CPERLarg));
OP *	PP_quotemeta	_((CPERLarg));
OP *	PP_rv2av	_((CPERLarg));
OP *	PP_aelemfast	_((CPERLarg));
OP *	PP_aelem	_((CPERLarg));
OP *	PP_aslice	_((CPERLarg));
OP *	PP_each		_((CPERLarg));
OP *	PP_values	_((CPERLarg));
OP *	PP_keys		_((CPERLarg));
OP *	PP_delete	_((CPERLarg));
OP *	PP_exists	_((CPERLarg));
OP *	PP_rv2hv	_((CPERLarg));
OP *	PP_helem	_((CPERLarg));
OP *	PP_hslice	_((CPERLarg));
OP *	PP_unpack	_((CPERLarg));
OP *	PP_pack		_((CPERLarg));
OP *	PP_split	_((CPERLarg));
OP *	PP_join		_((CPERLarg));
OP *	PP_list		_((CPERLarg));
OP *	PP_lslice	_((CPERLarg));
OP *	PP_anonlist	_((CPERLarg));
OP *	PP_anonhash	_((CPERLarg));
OP *	PP_splice	_((CPERLarg));
OP *	PP_push		_((CPERLarg));
OP *	PP_pop		_((CPERLarg));
OP *	PP_shift	_((CPERLarg));
OP *	PP_unshift	_((CPERLarg));
OP *	PP_sort		_((CPERLarg));
OP *	PP_reverse	_((CPERLarg));
OP *	PP_grepstart	_((CPERLarg));
OP *	PP_grepwhile	_((CPERLarg));
OP *	PP_mapstart	_((CPERLarg));
OP *	PP_mapwhile	_((CPERLarg));
OP *	PP_range	_((CPERLarg));
OP *	PP_flip		_((CPERLarg));
OP *	PP_flop		_((CPERLarg));
OP *	PP_and		_((CPERLarg));
OP *	PP_or		_((CPERLarg));
OP *	PP_xor		_((CPERLarg));
OP *	PP_cond_expr	_((CPERLarg));
OP *	PP_andassign	_((CPERLarg));
OP *	PP_orassign	_((CPERLarg));
OP *	PP_method	_((CPERLarg));
OP *	PP_entersub	_((CPERLarg));
OP *	PP_leavesub	_((CPERLarg));
OP *	PP_caller	_((CPERLarg));
OP *	PP_warn		_((CPERLarg));
OP *	PP_die		_((CPERLarg));
OP *	PP_reset	_((CPERLarg));
OP *	PP_lineseq	_((CPERLarg));
OP *	PP_nextstate	_((CPERLarg));
OP *	PP_dbstate	_((CPERLarg));
OP *	PP_unstack	_((CPERLarg));
OP *	PP_enter	_((CPERLarg));
OP *	PP_leave	_((CPERLarg));
OP *	PP_scope	_((CPERLarg));
OP *	PP_enteriter	_((CPERLarg));
OP *	PP_iter		_((CPERLarg));
OP *	PP_enterloop	_((CPERLarg));
OP *	PP_leaveloop	_((CPERLarg));
OP *	PP_return	_((CPERLarg));
OP *	PP_last		_((CPERLarg));
OP *	PP_next		_((CPERLarg));
OP *	PP_redo		_((CPERLarg));
OP *	PP_dump		_((CPERLarg));
OP *	PP_goto		_((CPERLarg));
OP *	PP_exit		_((CPERLarg));
OP *	PP_open		_((CPERLarg));
OP *	PP_close	_((CPERLarg));
OP *	PP_pipe_op	_((CPERLarg));
OP *	PP_fileno	_((CPERLarg));
OP *	PP_umask	_((CPERLarg));
OP *	PP_binmode	_((CPERLarg));
OP *	PP_tie		_((CPERLarg));
OP *	PP_untie	_((CPERLarg));
OP *	PP_tied		_((CPERLarg));
OP *	PP_dbmopen	_((CPERLarg));
OP *	PP_dbmclose	_((CPERLarg));
OP *	PP_sselect	_((CPERLarg));
OP *	PP_select	_((CPERLarg));
OP *	PP_getc		_((CPERLarg));
OP *	PP_read		_((CPERLarg));
OP *	PP_enterwrite	_((CPERLarg));
OP *	PP_leavewrite	_((CPERLarg));
OP *	PP_prtf		_((CPERLarg));
OP *	PP_print	_((CPERLarg));
OP *	PP_sysopen	_((CPERLarg));
OP *	PP_sysread	_((CPERLarg));
OP *	PP_syswrite	_((CPERLarg));
OP *	PP_send		_((CPERLarg));
OP *	PP_recv		_((CPERLarg));
OP *	PP_eof		_((CPERLarg));
OP *	PP_tell		_((CPERLarg));
OP *	PP_seek		_((CPERLarg));
OP *	PP_truncate	_((CPERLarg));
OP *	PP_fcntl	_((CPERLarg));
OP *	PP_ioctl	_((CPERLarg));
OP *	PP_flock	_((CPERLarg));
OP *	PP_socket	_((CPERLarg));
OP *	PP_sockpair	_((CPERLarg));
OP *	PP_bind		_((CPERLarg));
OP *	PP_connect	_((CPERLarg));
OP *	PP_listen	_((CPERLarg));
OP *	PP_accept	_((CPERLarg));
OP *	PP_shutdown	_((CPERLarg));
OP *	PP_gsockopt	_((CPERLarg));
OP *	PP_ssockopt	_((CPERLarg));
OP *	PP_getsockname	_((CPERLarg));
OP *	PP_getpeername	_((CPERLarg));
OP *	PP_lstat	_((CPERLarg));
OP *	PP_stat		_((CPERLarg));
OP *	PP_ftrread	_((CPERLarg));
OP *	PP_ftrwrite	_((CPERLarg));
OP *	PP_ftrexec	_((CPERLarg));
OP *	PP_fteread	_((CPERLarg));
OP *	PP_ftewrite	_((CPERLarg));
OP *	PP_fteexec	_((CPERLarg));
OP *	PP_ftis		_((CPERLarg));
OP *	PP_fteowned	_((CPERLarg));
OP *	PP_ftrowned	_((CPERLarg));
OP *	PP_ftzero	_((CPERLarg));
OP *	PP_ftsize	_((CPERLarg));
OP *	PP_ftmtime	_((CPERLarg));
OP *	PP_ftatime	_((CPERLarg));
OP *	PP_ftctime	_((CPERLarg));
OP *	PP_ftsock	_((CPERLarg));
OP *	PP_ftchr	_((CPERLarg));
OP *	PP_ftblk	_((CPERLarg));
OP *	PP_ftfile	_((CPERLarg));
OP *	PP_ftdir	_((CPERLarg));
OP *	PP_ftpipe	_((CPERLarg));
OP *	PP_ftlink	_((CPERLarg));
OP *	PP_ftsuid	_((CPERLarg));
OP *	PP_ftsgid	_((CPERLarg));
OP *	PP_ftsvtx	_((CPERLarg));
OP *	PP_fttty	_((CPERLarg));
OP *	PP_fttext	_((CPERLarg));
OP *	PP_ftbinary	_((CPERLarg));
OP *	PP_chdir	_((CPERLarg));
OP *	PP_chown	_((CPERLarg));
OP *	PP_chroot	_((CPERLarg));
OP *	PP_unlink	_((CPERLarg));
OP *	PP_chmod	_((CPERLarg));
OP *	PP_utime	_((CPERLarg));
OP *	PP_rename	_((CPERLarg));
OP *	PP_link		_((CPERLarg));
OP *	PP_symlink	_((CPERLarg));
OP *	PP_readlink	_((CPERLarg));
OP *	PP_mkdir	_((CPERLarg));
OP *	PP_rmdir	_((CPERLarg));
OP *	PP_open_dir	_((CPERLarg));
OP *	PP_readdir	_((CPERLarg));
OP *	PP_telldir	_((CPERLarg));
OP *	PP_seekdir	_((CPERLarg));
OP *	PP_rewinddir	_((CPERLarg));
OP *	PP_closedir	_((CPERLarg));
OP *	PP_fork		_((CPERLarg));
OP *	PP_wait		_((CPERLarg));
OP *	PP_waitpid	_((CPERLarg));
OP *	PP_system	_((CPERLarg));
OP *	PP_exec		_((CPERLarg));
OP *	PP_kill		_((CPERLarg));
OP *	PP_getppid	_((CPERLarg));
OP *	PP_getpgrp	_((CPERLarg));
OP *	PP_setpgrp	_((CPERLarg));
OP *	PP_getpriority	_((CPERLarg));
OP *	PP_setpriority	_((CPERLarg));
OP *	PP_time		_((CPERLarg));
OP *	PP_tms		_((CPERLarg));
OP *	PP_localtime	_((CPERLarg));
OP *	PP_gmtime	_((CPERLarg));
OP *	PP_alarm	_((CPERLarg));
OP *	PP_sleep	_((CPERLarg));
OP *	PP_shmget	_((CPERLarg));
OP *	PP_shmctl	_((CPERLarg));
OP *	PP_shmread	_((CPERLarg));
OP *	PP_shmwrite	_((CPERLarg));
OP *	PP_msgget	_((CPERLarg));
OP *	PP_msgctl	_((CPERLarg));
OP *	PP_msgsnd	_((CPERLarg));
OP *	PP_msgrcv	_((CPERLarg));
OP *	PP_semget	_((CPERLarg));
OP *	PP_semctl	_((CPERLarg));
OP *	PP_semop	_((CPERLarg));
OP *	PP_require	_((CPERLarg));
OP *	PP_dofile	_((CPERLarg));
OP *	PP_entereval	_((CPERLarg));
OP *	PP_leaveeval	_((CPERLarg));
OP *	PP_entertry	_((CPERLarg));
OP *	PP_leavetry	_((CPERLarg));
OP *	PP_ghbyname	_((CPERLarg));
OP *	PP_ghbyaddr	_((CPERLarg));
OP *	PP_ghostent	_((CPERLarg));
OP *	PP_gnbyname	_((CPERLarg));
OP *	PP_gnbyaddr	_((CPERLarg));
OP *	PP_gnetent	_((CPERLarg));
OP *	PP_gpbyname	_((CPERLarg));
OP *	PP_gpbynumber	_((CPERLarg));
OP *	PP_gprotoent	_((CPERLarg));
OP *	PP_gsbyname	_((CPERLarg));
OP *	PP_gsbyport	_((CPERLarg));
OP *	PP_gservent	_((CPERLarg));
OP *	PP_shostent	_((CPERLarg));
OP *	PP_snetent	_((CPERLarg));
OP *	PP_sprotoent	_((CPERLarg));
OP *	PP_sservent	_((CPERLarg));
OP *	PP_ehostent	_((CPERLarg));
OP *	PP_enetent	_((CPERLarg));
OP *	PP_eprotoent	_((CPERLarg));
OP *	PP_eservent	_((CPERLarg));
OP *	PP_gpwnam	_((CPERLarg));
OP *	PP_gpwuid	_((CPERLarg));
OP *	PP_gpwent	_((CPERLarg));
OP *	PP_spwent	_((CPERLarg));
OP *	PP_epwent	_((CPERLarg));
OP *	PP_ggrnam	_((CPERLarg));
OP *	PP_ggrgid	_((CPERLarg));
OP *	PP_ggrent	_((CPERLarg));
OP *	PP_sgrent	_((CPERLarg));
OP *	PP_egrent	_((CPERLarg));
OP *	PP_getlogin	_((CPERLarg));
OP *	PP_syscall	_((CPERLarg));

#ifndef DOINIT
EXT OP * (*ppaddr[])(CPERLarg);
#else
EXT OP * (*ppaddr[])(CPERLarg) = {
	PP_null,
	PP_stub,
	PP_scalar,
	PP_pushmark,
	PP_wantarray,
	PP_const,
	PP_gvsv,
	PP_gv,
	PP_gelem,
	PP_padsv,
	PP_padav,
	PP_padhv,
	PP_padany,
	PP_pushre,
	PP_rv2gv,
	PP_rv2sv,
	PP_av2arylen,
	PP_rv2cv,
	PP_anoncode,
	PP_prototype,
	PP_refgen,
	PP_srefgen,
	PP_ref,
	PP_bless,
	PP_backtick,
	PP_glob,
	PP_readline,
	PP_rcatline,
	PP_regcmaybe,
	PP_regcomp,
	PP_match,
	PP_subst,
	PP_substcont,
	PP_trans,
	PP_sassign,
	PP_aassign,
	PP_chop,
	PP_schop,
	PP_chomp,
	PP_schomp,
	PP_defined,
	PP_undef,
	PP_study,
	PP_pos,
	PP_preinc,
	PP_i_preinc,
	PP_predec,
	PP_i_predec,
	PP_postinc,
	PP_i_postinc,
	PP_postdec,
	PP_i_postdec,
	PP_pow,
	PP_multiply,
	PP_i_multiply,
	PP_divide,
	PP_i_divide,
	PP_modulo,
	PP_i_modulo,
	PP_repeat,
	PP_add,
	PP_i_add,
	PP_subtract,
	PP_i_subtract,
	PP_concat,
	PP_stringify,
	PP_left_shift,
	PP_right_shift,
	PP_lt,
	PP_i_lt,
	PP_gt,
	PP_i_gt,
	PP_le,
	PP_i_le,
	PP_ge,
	PP_i_ge,
	PP_eq,
	PP_i_eq,
	PP_ne,
	PP_i_ne,
	PP_ncmp,
	PP_i_ncmp,
	PP_slt,
	PP_sgt,
	PP_sle,
	PP_sge,
	PP_seq,
	PP_sne,
	PP_scmp,
	PP_bit_and,
	PP_bit_xor,
	PP_bit_or,
	PP_negate,
	PP_i_negate,
	PP_not,
	PP_complement,
	PP_atan2,
	PP_sin,
	PP_cos,
	PP_rand,
	PP_srand,
	PP_exp,
	PP_log,
	PP_sqrt,
	PP_int,
	PP_hex,
	PP_oct,
	PP_abs,
	PP_length,
	PP_substr,
	PP_vec,
	PP_index,
	PP_rindex,
	PP_sprintf,
	PP_formline,
	PP_ord,
	PP_chr,
	PP_crypt,
	PP_ucfirst,
	PP_lcfirst,
	PP_uc,
	PP_lc,
	PP_quotemeta,
	PP_rv2av,
	PP_aelemfast,
	PP_aelem,
	PP_aslice,
	PP_each,
	PP_values,
	PP_keys,
	PP_delete,
	PP_exists,
	PP_rv2hv,
	PP_helem,
	PP_hslice,
	PP_unpack,
	PP_pack,
	PP_split,
	PP_join,
	PP_list,
	PP_lslice,
	PP_anonlist,
	PP_anonhash,
	PP_splice,
	PP_push,
	PP_pop,
	PP_shift,
	PP_unshift,
	PP_sort,
	PP_reverse,
	PP_grepstart,
	PP_grepwhile,
	PP_mapstart,
	PP_mapwhile,
	PP_range,
	PP_flip,
	PP_flop,
	PP_and,
	PP_or,
	PP_xor,
	PP_cond_expr,
	PP_andassign,
	PP_orassign,
	PP_method,
	PP_entersub,
	PP_leavesub,
	PP_caller,
	PP_warn,
	PP_die,
	PP_reset,
	PP_lineseq,
	PP_nextstate,
	PP_dbstate,
	PP_unstack,
	PP_enter,
	PP_leave,
	PP_scope,
	PP_enteriter,
	PP_iter,
	PP_enterloop,
	PP_leaveloop,
	PP_return,
	PP_last,
	PP_next,
	PP_redo,
	PP_dump,
	PP_goto,
	PP_exit,
	PP_open,
	PP_close,
	PP_pipe_op,
	PP_fileno,
	PP_umask,
	PP_binmode,
	PP_tie,
	PP_untie,
	PP_tied,
	PP_dbmopen,
	PP_dbmclose,
	PP_sselect,
	PP_select,
	PP_getc,
	PP_read,
	PP_enterwrite,
	PP_leavewrite,
	PP_prtf,
	PP_print,
	PP_sysopen,
	PP_sysread,
	PP_syswrite,
	PP_send,
	PP_recv,
	PP_eof,
	PP_tell,
	PP_seek,
	PP_truncate,
	PP_fcntl,
	PP_ioctl,
	PP_flock,
	PP_socket,
	PP_sockpair,
	PP_bind,
	PP_connect,
	PP_listen,
	PP_accept,
	PP_shutdown,
	PP_gsockopt,
	PP_ssockopt,
	PP_getsockname,
	PP_getpeername,
	PP_lstat,
	PP_stat,
	PP_ftrread,
	PP_ftrwrite,
	PP_ftrexec,
	PP_fteread,
	PP_ftewrite,
	PP_fteexec,
	PP_ftis,
	PP_fteowned,
	PP_ftrowned,
	PP_ftzero,
	PP_ftsize,
	PP_ftmtime,
	PP_ftatime,
	PP_ftctime,
	PP_ftsock,
	PP_ftchr,
	PP_ftblk,
	PP_ftfile,
	PP_ftdir,
	PP_ftpipe,
	PP_ftlink,
	PP_ftsuid,
	PP_ftsgid,
	PP_ftsvtx,
	PP_fttty,
	PP_fttext,
	PP_ftbinary,
	PP_chdir,
	PP_chown,
	PP_chroot,
	PP_unlink,
	PP_chmod,
	PP_utime,
	PP_rename,
	PP_link,
	PP_symlink,
	PP_readlink,
	PP_mkdir,
	PP_rmdir,
	PP_open_dir,
	PP_readdir,
	PP_telldir,
	PP_seekdir,
	PP_rewinddir,
	PP_closedir,
	PP_fork,
	PP_wait,
	PP_waitpid,
	PP_system,
	PP_exec,
	PP_kill,
	PP_getppid,
	PP_getpgrp,
	PP_setpgrp,
	PP_getpriority,
	PP_setpriority,
	PP_time,
	PP_tms,
	PP_localtime,
	PP_gmtime,
	PP_alarm,
	PP_sleep,
	PP_shmget,
	PP_shmctl,
	PP_shmread,
	PP_shmwrite,
	PP_msgget,
	PP_msgctl,
	PP_msgsnd,
	PP_msgrcv,
	PP_semget,
	PP_semctl,
	PP_semop,
	PP_require,
	PP_dofile,
	PP_entereval,
	PP_leaveeval,
	PP_entertry,
	PP_leavetry,
	PP_ghbyname,
	PP_ghbyaddr,
	PP_ghostent,
	PP_gnbyname,
	PP_gnbyaddr,
	PP_gnetent,
	PP_gpbyname,
	PP_gpbynumber,
	PP_gprotoent,
	PP_gsbyname,
	PP_gsbyport,
	PP_gservent,
	PP_shostent,
	PP_snetent,
	PP_sprotoent,
	PP_sservent,
	PP_ehostent,
	PP_enetent,
	PP_eprotoent,
	PP_eservent,
	PP_gpwnam,
	PP_gpwuid,
	PP_gpwent,
	PP_spwent,
	PP_epwent,
	PP_ggrnam,
	PP_ggrgid,
	PP_ggrent,
	PP_sgrent,
	PP_egrent,
	PP_getlogin,
	PP_syscall,
};
#endif

#ifndef DOINIT
EXT OP * (*check[]) _((CPERLarg_ OP* op));
#else
EXT OP * (*check[]) _((CPERLarg_ OP* op)) = {
	CK_null,	/* null */
	CK_null,	/* stub */
	CK_fun,		/* scalar */
	CK_null,	/* pushmark */
	CK_null,	/* wantarray */
	CK_svconst,	/* const */
	CK_null,	/* gvsv */
	CK_null,	/* gv */
	CK_null,	/* gelem */
	CK_null,	/* padsv */
	CK_null,	/* padav */
	CK_null,	/* padhv */
	CK_null,	/* padany */
	CK_null,	/* pushre */
	CK_rvconst,	/* rv2gv */
	CK_rvconst,	/* rv2sv */
	CK_null,	/* av2arylen */
	CK_rvconst,	/* rv2cv */
	CK_null,	/* anoncode */
	CK_null,	/* prototype */
	CK_spair,	/* refgen */
	CK_null,	/* srefgen */
	CK_fun,		/* ref */
	CK_fun,		/* bless */
	CK_null,	/* backtick */
	CK_glob,	/* glob */
	CK_null,	/* readline */
	CK_null,	/* rcatline */
	CK_fun,		/* regcmaybe */
	CK_null,	/* regcomp */
	CK_match,	/* match */
	CK_null,	/* subst */
	CK_null,	/* substcont */
	CK_null,	/* trans */
	CK_null,	/* sassign */
	CK_null,	/* aassign */
	CK_spair,	/* chop */
	CK_null,	/* schop */
	CK_spair,	/* chomp */
	CK_null,	/* schomp */
	CK_rfun,	/* defined */
	CK_lfun,	/* undef */
	CK_fun,		/* study */
	CK_lfun,	/* pos */
	CK_lfun,	/* preinc */
	CK_lfun,	/* i_preinc */
	CK_lfun,	/* predec */
	CK_lfun,	/* i_predec */
	CK_lfun,	/* postinc */
	CK_lfun,	/* i_postinc */
	CK_lfun,	/* postdec */
	CK_lfun,	/* i_postdec */
	CK_null,	/* pow */
	CK_null,	/* multiply */
	CK_null,	/* i_multiply */
	CK_null,	/* divide */
	CK_null,	/* i_divide */
	CK_null,	/* modulo */
	CK_null,	/* i_modulo */
	CK_repeat,	/* repeat */
	CK_null,	/* add */
	CK_null,	/* i_add */
	CK_null,	/* subtract */
	CK_null,	/* i_subtract */
	CK_concat,	/* concat */
	CK_fun,		/* stringify */
	CK_null,	/* left_shift */
	CK_null,	/* right_shift */
	CK_null,	/* lt */
	CK_null,	/* i_lt */
	CK_null,	/* gt */
	CK_null,	/* i_gt */
	CK_null,	/* le */
	CK_null,	/* i_le */
	CK_null,	/* ge */
	CK_null,	/* i_ge */
	CK_null,	/* eq */
	CK_null,	/* i_eq */
	CK_null,	/* ne */
	CK_null,	/* i_ne */
	CK_null,	/* ncmp */
	CK_null,	/* i_ncmp */
	CK_null,	/* slt */
	CK_null,	/* sgt */
	CK_null,	/* sle */
	CK_null,	/* sge */
	CK_null,	/* seq */
	CK_null,	/* sne */
	CK_null,	/* scmp */
	CK_null,	/* bit_and */
	CK_null,	/* bit_xor */
	CK_null,	/* bit_or */
	CK_null,	/* negate */
	CK_null,	/* i_negate */
	CK_null,	/* not */
	CK_null,	/* complement */
	CK_fun,		/* atan2 */
	CK_fun,		/* sin */
	CK_fun,		/* cos */
	CK_fun,		/* rand */
	CK_fun,		/* srand */
	CK_fun,		/* exp */
	CK_fun,		/* log */
	CK_fun,		/* sqrt */
	CK_fun,		/* int */
	CK_fun,		/* hex */
	CK_fun,		/* oct */
	CK_fun,		/* abs */
	CK_lengthconst,	/* length */
	CK_fun,		/* substr */
	CK_fun,		/* vec */
	CK_index,	/* index */
	CK_index,	/* rindex */
	CK_fun,		/* sprintf */
	CK_formline,	/* formline */
	CK_fun,		/* ord */
	CK_fun,		/* chr */
	CK_fun,		/* crypt */
	CK_fun,		/* ucfirst */
	CK_fun,		/* lcfirst */
	CK_fun,		/* uc */
	CK_fun,		/* lc */
	CK_fun,		/* quotemeta */
	CK_rvconst,	/* rv2av */
	CK_null,	/* aelemfast */
	CK_null,	/* aelem */
	CK_null,	/* aslice */
	CK_fun,		/* each */
	CK_fun,		/* values */
	CK_fun,		/* keys */
	CK_delete,	/* delete */
	CK_delete,	/* exists */
	CK_rvconst,	/* rv2hv */
	CK_null,	/* helem */
	CK_null,	/* hslice */
	CK_fun,		/* unpack */
	CK_fun,		/* pack */
	CK_split,	/* split */
	CK_fun,		/* join */
	CK_null,	/* list */
	CK_null,	/* lslice */
	CK_fun,		/* anonlist */
	CK_fun,		/* anonhash */
	CK_fun,		/* splice */
	CK_fun,		/* push */
	CK_shift,	/* pop */
	CK_shift,	/* shift */
	CK_fun,		/* unshift */
	CK_sort,	/* sort */
	CK_fun,		/* reverse */
	CK_grep,	/* grepstart */
	CK_null,	/* grepwhile */
	CK_grep,	/* mapstart */
	CK_null,	/* mapwhile */
	CK_null,	/* range */
	CK_null,	/* flip */
	CK_null,	/* flop */
	CK_null,	/* and */
	CK_null,	/* or */
	CK_null,	/* xor */
	CK_null,	/* cond_expr */
	CK_null,	/* andassign */
	CK_null,	/* orassign */
	CK_null,	/* method */
	CK_subr,	/* entersub */
	CK_null,	/* leavesub */
	CK_fun,		/* caller */
	CK_fun,		/* warn */
	CK_fun,		/* die */
	CK_fun,		/* reset */
	CK_null,	/* lineseq */
	CK_null,	/* nextstate */
	CK_null,	/* dbstate */
	CK_null,	/* unstack */
	CK_null,	/* enter */
	CK_null,	/* leave */
	CK_null,	/* scope */
	CK_null,	/* enteriter */
	CK_null,	/* iter */
	CK_null,	/* enterloop */
	CK_null,	/* leaveloop */
	CK_null,	/* return */
	CK_null,	/* last */
	CK_null,	/* next */
	CK_null,	/* redo */
	CK_null,	/* dump */
	CK_null,	/* goto */
	CK_fun,		/* exit */
	CK_fun,		/* open */
	CK_fun,		/* close */
	CK_fun,		/* pipe_op */
	CK_fun,		/* fileno */
	CK_fun,		/* umask */
	CK_fun,		/* binmode */
	CK_fun,		/* tie */
	CK_fun,		/* untie */
	CK_fun,		/* tied */
	CK_fun,		/* dbmopen */
	CK_fun,		/* dbmclose */
	CK_select,	/* sselect */
	CK_select,	/* select */
	CK_eof,		/* getc */
	CK_fun,		/* read */
	CK_fun,		/* enterwrite */
	CK_null,	/* leavewrite */
	CK_listiob,	/* prtf */
	CK_listiob,	/* print */
	CK_fun,		/* sysopen */
	CK_fun,		/* sysread */
	CK_fun,		/* syswrite */
	CK_fun,		/* send */
	CK_fun,		/* recv */
	CK_eof,		/* eof */
	CK_fun,		/* tell */
	CK_fun,		/* seek */
	CK_trunc,	/* truncate */
	CK_fun,		/* fcntl */
	CK_fun,		/* ioctl */
	CK_fun,		/* flock */
	CK_fun,		/* socket */
	CK_fun,		/* sockpair */
	CK_fun,		/* bind */
	CK_fun,		/* connect */
	CK_fun,		/* listen */
	CK_fun,		/* accept */
	CK_fun,		/* shutdown */
	CK_fun,		/* gsockopt */
	CK_fun,		/* ssockopt */
	CK_fun,		/* getsockname */
	CK_fun,		/* getpeername */
	CK_ftst,	/* lstat */
	CK_ftst,	/* stat */
	CK_ftst,	/* ftrread */
	CK_ftst,	/* ftrwrite */
	CK_ftst,	/* ftrexec */
	CK_ftst,	/* fteread */
	CK_ftst,	/* ftewrite */
	CK_ftst,	/* fteexec */
	CK_ftst,	/* ftis */
	CK_ftst,	/* fteowned */
	CK_ftst,	/* ftrowned */
	CK_ftst,	/* ftzero */
	CK_ftst,	/* ftsize */
	CK_ftst,	/* ftmtime */
	CK_ftst,	/* ftatime */
	CK_ftst,	/* ftctime */
	CK_ftst,	/* ftsock */
	CK_ftst,	/* ftchr */
	CK_ftst,	/* ftblk */
	CK_ftst,	/* ftfile */
	CK_ftst,	/* ftdir */
	CK_ftst,	/* ftpipe */
	CK_ftst,	/* ftlink */
	CK_ftst,	/* ftsuid */
	CK_ftst,	/* ftsgid */
	CK_ftst,	/* ftsvtx */
	CK_ftst,	/* fttty */
	CK_ftst,	/* fttext */
	CK_ftst,	/* ftbinary */
	CK_fun,		/* chdir */
	CK_fun,		/* chown */
	CK_fun,		/* chroot */
	CK_fun,		/* unlink */
	CK_fun,		/* chmod */
	CK_fun,		/* utime */
	CK_fun,		/* rename */
	CK_fun,		/* link */
	CK_fun,		/* symlink */
	CK_fun,		/* readlink */
	CK_fun,		/* mkdir */
	CK_fun,		/* rmdir */
	CK_fun,		/* open_dir */
	CK_fun,		/* readdir */
	CK_fun,		/* telldir */
	CK_fun,		/* seekdir */
	CK_fun,		/* rewinddir */
	CK_fun,		/* closedir */
	CK_null,	/* fork */
	CK_null,	/* wait */
	CK_fun,		/* waitpid */
	CK_exec,	/* system */
	CK_exec,	/* exec */
	CK_fun,		/* kill */
	CK_null,	/* getppid */
	CK_fun,		/* getpgrp */
	CK_fun,		/* setpgrp */
	CK_fun,		/* getpriority */
	CK_fun,		/* setpriority */
	CK_null,	/* time */
	CK_null,	/* tms */
	CK_fun,		/* localtime */
	CK_fun,		/* gmtime */
	CK_fun,		/* alarm */
	CK_fun,		/* sleep */
	CK_fun,		/* shmget */
	CK_fun,		/* shmctl */
	CK_fun,		/* shmread */
	CK_fun,		/* shmwrite */
	CK_fun,		/* msgget */
	CK_fun,		/* msgctl */
	CK_fun,		/* msgsnd */
	CK_fun,		/* msgrcv */
	CK_fun,		/* semget */
	CK_fun,		/* semctl */
	CK_fun,		/* semop */
	CK_require,	/* require */
	CK_fun,		/* dofile */
	CK_eval,	/* entereval */
	CK_null,	/* leaveeval */
	CK_null,	/* entertry */
	CK_null,	/* leavetry */
	CK_fun,		/* ghbyname */
	CK_fun,		/* ghbyaddr */
	CK_null,	/* ghostent */
	CK_fun,		/* gnbyname */
	CK_fun,		/* gnbyaddr */
	CK_null,	/* gnetent */
	CK_fun,		/* gpbyname */
	CK_fun,		/* gpbynumber */
	CK_null,	/* gprotoent */
	CK_fun,		/* gsbyname */
	CK_fun,		/* gsbyport */
	CK_null,	/* gservent */
	CK_fun,		/* shostent */
	CK_fun,		/* snetent */
	CK_fun,		/* sprotoent */
	CK_fun,		/* sservent */
	CK_null,	/* ehostent */
	CK_null,	/* enetent */
	CK_null,	/* eprotoent */
	CK_null,	/* eservent */
	CK_fun,		/* gpwnam */
	CK_fun,		/* gpwuid */
	CK_null,	/* gpwent */
	CK_null,	/* spwent */
	CK_null,	/* epwent */
	CK_fun,		/* ggrnam */
	CK_fun,		/* ggrgid */
	CK_null,	/* ggrent */
	CK_null,	/* sgrent */
	CK_null,	/* egrent */
	CK_null,	/* getlogin */
	CK_fun,		/* syscall */
};
#endif

#ifndef DOINIT
EXT U32 opargs[];
#else
EXT U32 opargs[] = {
	0x00000000,	/* null */
	0x00000000,	/* stub */
	0x00000104,	/* scalar */
	0x00000004,	/* pushmark */
	0x00000014,	/* wantarray */
	0x00000004,	/* const */
	0x00000044,	/* gvsv */
	0x00000044,	/* gv */
	0x00001140,	/* gelem */
	0x00000044,	/* padsv */
	0x00000040,	/* padav */
	0x00000040,	/* padhv */
	0x00000040,	/* padany */
	0x00000000,	/* pushre */
	0x00000044,	/* rv2gv */
	0x00000044,	/* rv2sv */
	0x00000014,	/* av2arylen */
	0x00000040,	/* rv2cv */
	0x00000000,	/* anoncode */
	0x00000104,	/* prototype */
	0x00000201,	/* refgen */
	0x00000106,	/* srefgen */
	0x0000098c,	/* ref */
	0x00009104,	/* bless */
	0x00000008,	/* backtick */
	0x00001108,	/* glob */
	0x00000008,	/* readline */
	0x00000008,	/* rcatline */
	0x00000104,	/* regcmaybe */
	0x00000104,	/* regcomp */
	0x00000040,	/* match */
	0x00000154,	/* subst */
	0x00000054,	/* substcont */
	0x00000114,	/* trans */
	0x00000004,	/* sassign */
	0x00002208,	/* aassign */
	0x0000020d,	/* chop */
	0x0000098c,	/* schop */
	0x0000020d,	/* chomp */
	0x0000098c,	/* schomp */
	0x00000994,	/* defined */
	0x00000904,	/* undef */
	0x00000984,	/* study */
	0x0000098c,	/* pos */
	0x00000164,	/* preinc */
	0x00000154,	/* i_preinc */
	0x00000164,	/* predec */
	0x00000154,	/* i_predec */
	0x0000016c,	/* postinc */
	0x0000015c,	/* i_postinc */
	0x0000016c,	/* postdec */
	0x0000015c,	/* i_postdec */
	0x0000110e,	/* pow */
	0x0000112e,	/* multiply */
	0x0000111e,	/* i_multiply */
	0x0000112e,	/* divide */
	0x0000111e,	/* i_divide */
	0x0000113e,	/* modulo */
	0x0000111e,	/* i_modulo */
	0x00001209,	/* repeat */
	0x0000112e,	/* add */
	0x0000111e,	/* i_add */
	0x0000112e,	/* subtract */
	0x0000111e,	/* i_subtract */
	0x0000110e,	/* concat */
	0x0000010e,	/* stringify */
	0x0000111e,	/* left_shift */
	0x0000111e,	/* right_shift */
	0x00001136,	/* lt */
	0x00001116,	/* i_lt */
	0x00001136,	/* gt */
	0x00001116,	/* i_gt */
	0x00001136,	/* le */
	0x00001116,	/* i_le */
	0x00001136,	/* ge */
	0x00001116,	/* i_ge */
	0x00001136,	/* eq */
	0x00001116,	/* i_eq */
	0x00001136,	/* ne */
	0x00001116,	/* i_ne */
	0x0000113e,	/* ncmp */
	0x0000111e,	/* i_ncmp */
	0x00001116,	/* slt */
	0x00001116,	/* sgt */
	0x00001116,	/* sle */
	0x00001116,	/* sge */
	0x00001116,	/* seq */
	0x00001116,	/* sne */
	0x0000111e,	/* scmp */
	0x0000110e,	/* bit_and */
	0x0000110e,	/* bit_xor */
	0x0000110e,	/* bit_or */
	0x0000012e,	/* negate */
	0x0000011e,	/* i_negate */
	0x00000116,	/* not */
	0x0000010e,	/* complement */
	0x0000110e,	/* atan2 */
	0x0000098e,	/* sin */
	0x0000098e,	/* cos */
	0x0000090c,	/* rand */
	0x00000904,	/* srand */
	0x0000098e,	/* exp */
	0x0000098e,	/* log */
	0x0000098e,	/* sqrt */
	0x0000098e,	/* int */
	0x0000099c,	/* hex */
	0x0000099c,	/* oct */
	0x0000098e,	/* abs */
	0x0000099c,	/* length */
	0x0009110c,	/* substr */
	0x0001111c,	/* vec */
	0x0009111c,	/* index */
	0x0009111c,	/* rindex */
	0x0000210d,	/* sprintf */
	0x00002105,	/* formline */
	0x0000099e,	/* ord */
	0x0000098e,	/* chr */
	0x0000110e,	/* crypt */
	0x0000010e,	/* ucfirst */
	0x0000010e,	/* lcfirst */
	0x0000010e,	/* uc */
	0x0000010e,	/* lc */
	0x0000010e,	/* quotemeta */
	0x00000048,	/* rv2av */
	0x00001304,	/* aelemfast */
	0x00001304,	/* aelem */
	0x00002301,	/* aslice */
	0x00000408,	/* each */
	0x00000408,	/* values */
	0x00000408,	/* keys */
	0x00000104,	/* delete */
	0x00000114,	/* exists */
	0x00000048,	/* rv2hv */
	0x00001404,	/* helem */
	0x00002401,	/* hslice */
	0x00001100,	/* unpack */
	0x0000210d,	/* pack */
	0x00011108,	/* split */
	0x0000210d,	/* join */
	0x00000201,	/* list */
	0x00022400,	/* lslice */
	0x00000205,	/* anonlist */
	0x00000205,	/* anonhash */
	0x00299301,	/* splice */
	0x0000231d,	/* push */
	0x00000304,	/* pop */
	0x00000304,	/* shift */
	0x0000231d,	/* unshift */
	0x00002d01,	/* sort */
	0x00000209,	/* reverse */
	0x00002541,	/* grepstart */
	0x00000048,	/* grepwhile */
	0x00002541,	/* mapstart */
	0x00000048,	/* mapwhile */
	0x00001100,	/* range */
	0x00001100,	/* flip */
	0x00000000,	/* flop */
	0x00000000,	/* and */
	0x00000000,	/* or */
	0x00001106,	/* xor */
	0x00000040,	/* cond_expr */
	0x00000004,	/* andassign */
	0x00000004,	/* orassign */
	0x00000040,	/* method */
	0x00000249,	/* entersub */
	0x00000000,	/* leavesub */
	0x00000908,	/* caller */
	0x0000021d,	/* warn */
	0x0000025d,	/* die */
	0x00000914,	/* reset */
	0x00000000,	/* lineseq */
	0x00000004,	/* nextstate */
	0x00000004,	/* dbstate */
	0x00000004,	/* unstack */
	0x00000000,	/* enter */
	0x00000000,	/* leave */
	0x00000000,	/* scope */
	0x00000040,	/* enteriter */
	0x00000000,	/* iter */
	0x00000040,	/* enterloop */
	0x00000000,	/* leaveloop */
	0x00000241,	/* return */
	0x00000044,	/* last */
	0x00000044,	/* next */
	0x00000044,	/* redo */
	0x00000044,	/* dump */
	0x00000044,	/* goto */
	0x00000944,	/* exit */
	0x0000961c,	/* open */
	0x00000e14,	/* close */
	0x00006614,	/* pipe_op */
	0x0000061c,	/* fileno */
	0x0000091c,	/* umask */
	0x00000604,	/* binmode */
	0x00021755,	/* tie */
	0x00000714,	/* untie */
	0x00000704,	/* tied */
	0x00011414,	/* dbmopen */
	0x00000414,	/* dbmclose */
	0x00111108,	/* sselect */
	0x00000e0c,	/* select */
	0x00000e0c,	/* getc */
	0x0091761d,	/* read */
	0x00000e54,	/* enterwrite */
	0x00000000,	/* leavewrite */
	0x00002e15,	/* prtf */
	0x00002e15,	/* print */
	0x00911604,	/* sysopen */
	0x0091761d,	/* sysread */
	0x0091161d,	/* syswrite */
	0x0091161d,	/* send */
	0x0011761d,	/* recv */
	0x00000e14,	/* eof */
	0x00000e0c,	/* tell */
	0x00011604,	/* seek */
	0x00001114,	/* truncate */
	0x0001160c,	/* fcntl */
	0x0001160c,	/* ioctl */
	0x0000161c,	/* flock */
	0x00111614,	/* socket */
	0x01116614,	/* sockpair */
	0x00001614,	/* bind */
	0x00001614,	/* connect */
	0x00001614,	/* listen */
	0x0000661c,	/* accept */
	0x0000161c,	/* shutdown */
	0x00011614,	/* gsockopt */
	0x00111614,	/* ssockopt */
	0x00000614,	/* getsockname */
	0x00000614,	/* getpeername */
	0x00000680,	/* lstat */
	0x00000680,	/* stat */
	0x00000694,	/* ftrread */
	0x00000694,	/* ftrwrite */
	0x00000694,	/* ftrexec */
	0x00000694,	/* fteread */
	0x00000694,	/* ftewrite */
	0x00000694,	/* fteexec */
	0x00000694,	/* ftis */
	0x00000694,	/* fteowned */
	0x00000694,	/* ftrowned */
	0x00000694,	/* ftzero */
	0x0000069c,	/* ftsize */
	0x0000068c,	/* ftmtime */
	0x0000068c,	/* ftatime */
	0x0000068c,	/* ftctime */
	0x00000694,	/* ftsock */
	0x00000694,	/* ftchr */
	0x00000694,	/* ftblk */
	0x00000694,	/* ftfile */
	0x00000694,	/* ftdir */
	0x00000694,	/* ftpipe */
	0x00000694,	/* ftlink */
	0x00000694,	/* ftsuid */
	0x00000694,	/* ftsgid */
	0x00000694,	/* ftsvtx */
	0x00000614,	/* fttty */
	0x00000694,	/* fttext */
	0x00000694,	/* ftbinary */
	0x0000091c,	/* chdir */
	0x0000021d,	/* chown */
	0x0000099c,	/* chroot */
	0x0000029d,	/* unlink */
	0x0000021d,	/* chmod */
	0x0000021d,	/* utime */
	0x0000111c,	/* rename */
	0x0000111c,	/* link */
	0x0000111c,	/* symlink */
	0x0000098c,	/* readlink */
	0x0000111c,	/* mkdir */
	0x0000099c,	/* rmdir */
	0x00001614,	/* open_dir */
	0x00000600,	/* readdir */
	0x0000060c,	/* telldir */
	0x00001604,	/* seekdir */
	0x00000604,	/* rewinddir */
	0x00000614,	/* closedir */
	0x0000001c,	/* fork */
	0x0000001c,	/* wait */
	0x0000111c,	/* waitpid */
	0x0000291d,	/* system */
	0x0000295d,	/* exec */
	0x0000025d,	/* kill */
	0x0000001c,	/* getppid */
	0x0000091c,	/* getpgrp */
	0x0000991c,	/* setpgrp */
	0x0000111c,	/* getpriority */
	0x0001111c,	/* setpriority */
	0x0000001c,	/* time */
	0x00000000,	/* tms */
	0x00000908,	/* localtime */
	0x00000908,	/* gmtime */
	0x0000099c,	/* alarm */
	0x0000091c,	/* sleep */
	0x0001111d,	/* shmget */
	0x0001111d,	/* shmctl */
	0x0011111d,	/* shmread */
	0x0011111d,	/* shmwrite */
	0x0000111d,	/* msgget */
	0x0001111d,	/* msgctl */
	0x0001111d,	/* msgsnd */
	0x0111111d,	/* msgrcv */
	0x0001111d,	/* semget */
	0x0011111d,	/* semctl */
	0x0000111d,	/* semop */
	0x000009c0,	/* require */
	0x00000140,	/* dofile */
	0x00000140,	/* entereval */
	0x00000100,	/* leaveeval */
	0x00000000,	/* entertry */
	0x00000000,	/* leavetry */
	0x00000100,	/* ghbyname */
	0x00001100,	/* ghbyaddr */
	0x00000000,	/* ghostent */
	0x00000100,	/* gnbyname */
	0x00001100,	/* gnbyaddr */
	0x00000000,	/* gnetent */
	0x00000100,	/* gpbyname */
	0x00000100,	/* gpbynumber */
	0x00000000,	/* gprotoent */
	0x00001100,	/* gsbyname */
	0x00001100,	/* gsbyport */
	0x00000000,	/* gservent */
	0x00000114,	/* shostent */
	0x00000114,	/* snetent */
	0x00000114,	/* sprotoent */
	0x00000114,	/* sservent */
	0x00000014,	/* ehostent */
	0x00000014,	/* enetent */
	0x00000014,	/* eprotoent */
	0x00000014,	/* eservent */
	0x00000100,	/* gpwnam */
	0x00000100,	/* gpwuid */
	0x00000000,	/* gpwent */
	0x00000014,	/* spwent */
	0x00000014,	/* epwent */
	0x00000100,	/* ggrnam */
	0x00000100,	/* ggrgid */
	0x00000000,	/* ggrent */
	0x00000014,	/* sgrent */
	0x00000014,	/* egrent */
	0x0000000c,	/* getlogin */
	0x0000211d,	/* syscall */
};
#endif
