// PerlLib.C

// (c) 1995 Microsoft Corporation. All rights reserved. 
//	Developed by ActiveWare Internet Corp., http://www.ActiveWare.com

//    You may distribute under the terms of either the GNU General Public
//    License or the Artistic License, as specified in the README file.


#include <windows.h>
#include <process.h>
#define WIN32_LEAN_AND_MEAN

#include "EXTERN.h"
#include "perl.h"
#include "perllib.h"

//CPerlDll

class CPerlDll : public IPerlSupport
{
	// memory allocation routines
	void *Malloc(size_t) { return NULL; };
	void *Realloc(void*, size_t) { return NULL; };
	void Free(void*) {};

	// FILE* routines
	FILE* Stdin(void) { return NULL; };
	FILE* Stdout(void) { return NULL; };
	FILE* Stderr(void) { return NULL; };
	void Clearerr(FILE *) {};
	int Fclose(FILE *, int&) { return 0; };
	FILE *Fdopen(int, const char *, int&) { return NULL; };
	int Feof(FILE *, int&) { return 0; };
	int Ferror(FILE *, int&) { return 0; };
	int FFlush(FILE *, int&) { return 0; };
	int Flushall(int&) { return 0; };
	int Fgetc(FILE *, int&) { return 0; };
	char *Fgets(char *, int, FILE *, int&) { return NULL; };
	int FGetpos(FILE *, fpos_t *, int&) { return 0; };
	int Fileno(FILE *, int&) { return 0; };
	FILE *Fopen(const char *, const char *, int&) { return NULL; };
	int Fputs(const char *, FILE *, int&) { return 0; };
	size_t Fread(void *, size_t, size_t, FILE *, int&) { return 0; };
	int Fseek(FILE *, long, int, int&) { return 0; };
	int FSetpos(FILE *, fpos_t *, int&) { return 0; };
	int FStat(int, struct stat *, int&) { return 0; };
	long Ftell(FILE *, int&) { return 0; };
	size_t Fwrite(const void *, size_t, size_t, FILE *, int&) { return 0; };
	int Getc(FILE *, int&) { return 0; };
	int Putc(int c, FILE *, int&) { return 0; };
	void Rewind(FILE *) {};
	void Setbuf(FILE *, char *, int&) {};
	int Setvbuf(FILE *, char *, int, size_t, int&) { return 0; };
	FILE* TmpFile(int&) { return NULL; };
	int Ungetc(int, FILE *, int&) { return 0; };
	int Vfprintf(FILE *, const char *, va_list, int&) { return 0; };
	FILE *Popen(const char *, const char *, int&) { return NULL; };
	int Pclose(FILE *, int&) { return 0; };
	int Pipe(int *, unsigned int, int, int&) { return 0; };

	// Low level I/O
	int Access(const char *, int, int&) { return 0; };
	int Chmod(const char *, int, int&) { return 0; };
	int Chsize(int, long, int&) { return 0; };
	int Close(int, int&) { return 0; };
	int Dup(int, int&) { return 0; };
	int Dup2(int, int, int&) { return 0; };
	int Isatty(int, int&) { return 0; };
	long Lseek(int, long, int, int&) { return 0; };
	char *Mktemp(char *, int&) { return NULL; };
	int Open(const char *, int, int, int&) { return 0; };
	int Read(int, void *, unsigned int, int&) { return 0; };
	int Rename(const char *, const char *, int&) { return 0; };
	int Setmode(int, int, int&) { return 0; };
	char *Tmpnam(char *, int&) { return NULL; };
	int Umask(int, int&) { return 0; };
	int Unlink(const char *, int&) { return 0; };
	int Utime(const char *filename, struct utimbuf *times, int&) { return 0; };
	int Write(int, const void *, unsigned int, int&) { return 0; };

	// Spawning
	int Spawn(int mode, const char *cmdname, const char * const *argv, const char * const *envp, int& e) { return 0; };
	int Cmd(int mode, const char *shell, const char *cmd, const char * const *envp) { return 0; };
	int Execv(const char *cmdname, const char *const *argv) { return 0; };
	int Execvp(const char *cmdname, const char *const *argv) { return 0; };

	// Sockets
	int OpenOSfhandle(long osfhandle, int flags) { return 0; };
	int GetOSfhandle(int filenum) { return 0; };

	// Misc
	int SetSignal(int i) { return 0; };
	void SignalHandler(CPerl *pPerl, int sig);
	void Die(CPerl *pPerl, char *message);
	void Putenv(const char *envstring) {};
	char* Getenv(const char *envstring) { return NULL; };
	int GetCWD(char *buffer, int size) { return 0; };
	int SetCWD(char *buffer) { return 0; };
	void PerlCaller(char *string, int size);
	void* GetECB(void) { return NULL; };

	int MkDir(char *, int&) { return -1; };
	int ChDir(char *, int&) { return -1; };
	int RmDir(char *, int&) { return -1; };
	int FileStat(char *, void *, int&) { return -1; };
	char *GetStrerror(int) { return NULL; };
	void XInit(void) {};

	// find file functions
	HANDLE FindFirstFile(const char *, void*) { return NULL; };
	int FindNextFile(HANDLE, void *) { return 0; };
	int FindClose(HANDLE) { return 0; };
};

void CPerlDll::SignalHandler(CPerl *pPerl, int sig)
{
	pPerl->sighandler(sig);
}

void CPerlDll::Die(CPerl *pPerl, char *message)
{
	pPerl->die(message);
}

#ifdef PRIVATE_PERL
#define NT_PERL_NAME "pPerl300.dll"
#else
#define NT_PERL_NAME "Perl300.dll"
#endif

void CPerlDll::PerlCaller(char *string, int size)
{
	char *ptr = NT_PERL_NAME;

	while(--size && (*string++ = *ptr++) != '\0')
		;

	*string = '\0';
}

void Win32_xs_init _((CPerl *pPerl));
void __cdecl Win32OLECleanUp(void);
void EndSockets(void);
void __cdecl NTADVAPICleanUp(void);

CRITICAL_SECTION csSortCv, csSortCmp, csSock;
CRITICAL_SECTION csADVAPI;
CRITICAL_SECTION csOLE;
CRITICAL_SECTION csLibLoader;

static CPerl *pSortCvPerl;
static int SortCv(const void *a, const void *b)
{
	return pSortCvPerl->sortcv(a, b);
}


void QSortCv(CPerl *pPerl, void *base, size_t max, size_t width)
{
	EnterCriticalSection(&csSortCv);
	pSortCvPerl = pPerl;
	qsort(base, max, width, SortCv);
	LeaveCriticalSection(&csSortCv);
}

static CPerl *pSortCmpPerl;
static int SortCmp(const void *a, const void *b)
{
	return pSortCmpPerl->sortcmp(a, b);
}


void QSortCmp(CPerl *pPerl, void *base, size_t max, size_t width)
{
	EnterCriticalSection(&csSortCmp);
	pSortCmpPerl = pPerl;
	qsort(base, max, width, SortCmp);
	LeaveCriticalSection(&csSortCmp);
}

CPerlDll g_perlDll;

CPerl* PERLLIBAPI CreateCPerl(IPerlSupport *pVtbl, IPerlSupport **pdllvtbl)
{
	*pdllvtbl = &g_perlDll;
	return perl_alloc(pVtbl);
}

int PERLLIBAPI PerlGetVersion(void)
{
	return atoi(NT_BUILD_NUMBER);
}

class LibraryLoader
{
public:
	LibraryLoader()
	{
		pNext = NULL;
		hInstance = NULL;
		fileName = NULL;
	};
	~LibraryLoader()
	{
		if(hInstance)
			FreeLibrary(hInstance);
		delete [] fileName;
	};
	LibraryLoader* GetNext(void) { return pNext; };
	void SetNext(LibraryLoader*pN) { pNext = pN; };
	HINSTANCE GetInstance(void) { return hInstance; };
	BOOL IsMatch(char*filename)
	{
		if(fileName != NULL)
			return (strcmp(fileName, filename) == 0);
		return FALSE;
	};
	HINSTANCE Load(char*filename)
	{
		hInstance = LoadLibrary(filename);
		if(hInstance != NULL)
		{
			fileName = new char[strlen(filename)+1];
			if(fileName != NULL)
				strcpy(fileName, filename);
		}
		return hInstance;
	};
protected:
	LibraryLoader* pNext;
	HINSTANCE hInstance;
	char* fileName;
};

LibraryLoader* g_LibLoader;

void UnloadLibraries(void)
{
	LibraryLoader* pLib;
	LibraryLoader* pTemp;
	EnterCriticalSection(&csLibLoader);
	for(pLib = g_LibLoader; pLib != NULL; pLib = pTemp)
	{
		pTemp = pLib->GetNext();
		delete pLib;
	}
	LeaveCriticalSection(&csLibLoader);
}

void* LibraryLoad(char*filename)
{
	HINSTANCE hInstance = NULL;
	LibraryLoader* pLibLoader;

	EnterCriticalSection(&csLibLoader);
	for(pLibLoader = g_LibLoader; pLibLoader != NULL; pLibLoader = pLibLoader->GetNext())
	{
		if(pLibLoader->IsMatch(filename))
			hInstance = pLibLoader->GetInstance();
	}

	// did not find filename in list
	if(hInstance == NULL)
	{
		pLibLoader = new LibraryLoader();
		if(pLibLoader != NULL)
		{
			hInstance = pLibLoader->Load(filename);
			if(hInstance != NULL)
			{
				pLibLoader->SetNext(g_LibLoader);
				g_LibLoader = pLibLoader;
			}
			else
				delete pLibLoader;
		}
	}
	LeaveCriticalSection(&csLibLoader);
	return hInstance;
}


#ifdef DETECTION
const BYTE* memStartPtr = (BYTE*)0x1009d430;
const BYTE* memEndPtr = (BYTE*)0x100b3800;
const int count = (memEndPtr - memStartPtr);
BYTE* memCopy;

unsigned long _stdcall WatchDog(void *)
{
	BYTE* ptr = (BYTE*)memStartPtr;
	int index;
	char szBuffer[256];

	for(;;)
	{
		for(index = 0; index < count; ++index)
		{
			if(ptr[index] != memCopy[index])
			{
				sprintf(szBuffer, "%08x: %02x -> %02x\n", (ptr+index), memCopy[index], ptr[index]);
				OutputDebugString(szBuffer);
				memCopy[index] = ptr[index];
			}
		}
	}
	return 0;
}
HANDLE ghThread;
DWORD gtWatchDog;

#undef malloc
#endif

BOOL APIENTRY DllMain(HANDLE hModule,		// DLL module handle
						DWORD fdwReason,	// reason called
						LPVOID lpvReserved)	// reserved
{ 
	switch (fdwReason)
	{
		// The DLL is attaching to a process due to process
		// initialization or a call to LoadLibrary.
		case DLL_PROCESS_ATTACH:
			g_LibLoader = NULL;
			InitializeCriticalSection(&csLibLoader);
			InitializeCriticalSection(&csSortCv);
			InitializeCriticalSection(&csSortCmp);
			InitializeCriticalSection(&csSock);
			InitializeCriticalSection(&csADVAPI);
			InitializeCriticalSection(&csOLE);
#ifdef DETECTION
			memCopy = (BYTE*)malloc(count+1);
			memcpy(memCopy, memStartPtr, count);
			ghThread = CreateThread(NULL, 0, WatchDog, 0, 0, &gtWatchDog);
#endif
			break;

		// The DLL is detaching from a process due to
		// process termination or call to FreeLibrary.
		case DLL_PROCESS_DETACH:
			UnloadLibraries();
			Win32OLECleanUp();
			EndSockets();
			NTADVAPICleanUp();
			DeleteCriticalSection(&csLibLoader);
			DeleteCriticalSection(&csSortCv);
			DeleteCriticalSection(&csSortCmp);
			DeleteCriticalSection(&csSock);
			DeleteCriticalSection(&csADVAPI);
			DeleteCriticalSection(&csOLE);
#ifdef DETECTION
			TerminateThread(ghThread, 0);
#endif
			break;

		// The attached process creates a new thread.
		case DLL_THREAD_ATTACH:
			break;

		// The thread of the attached process terminates.
		case DLL_THREAD_DETACH:
			break;

		default:
			break;
	}
	return TRUE;
}



/* Register any extra external extensions */
void Win32_xs_init(CPerl *pPerl)
{
   /* Do not delete this line--writemain depends on it */
	char * file = __FILE__;
	NTInit(pPerl);
	NTLibInit(pPerl);
	Win32OLEInit(pPerl);
	{
		extern void boot_DynaLoader _((CPerl *pPerl, CV* cv));
		pPerl->newXS("DynaLoader::boot_DynaLoader", boot_DynaLoader, file);
	}
	{
		extern void boot_Winsock _((CPerl *pPerl, CV* cv));
		pPerl->newXS("Winsock::boot_Winsock", boot_Winsock, file);
	}
	pPerl->GetpVtbl()->XInit();
}
